<?php
/***************************************************************************
 *								admin_album_cat.php
 *								-------------------
 *   begin                : Saturday, July 20, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor@zapo.net
 *
 *   $Id: admin_album.php,v 1.5.0 2002/7/21, 14:19:22 hnt Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Album']['īװ'] = $filename;
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'album_mod/album_common.' . $phpEx);

if (!isset($HTTP_GET_VARS['action']))
{
	if (!isset($HTTP_POST_VARS['new_cat']))
	{
		$template->set_filenames(array(
			'body' => 'admin/album_cat_body.tpl')
		);

		$template->assign_vars(array(
			'L_ALBUM_MANAGER_TITLE' => $lang['Album_Manager_Title'],
			'L_ALBUM_MANAGER_EXPLAIN' => $lang['Album_Manager_Explain'],
			'S_CAT_ACTION' => append_sid("admin_album_cat.$phpEx"),
			'L_ALBUM' => $lang['Album'],
			'L_CATEGORY' => $lang['Category'],
			'L_EDIT' => $lang['Edit'],
			'L_DELETE' => $lang['Delete'],
			'L_CREATE_CATEGORY' => $lang['Create_category'],
			) // end array
		);

		$sql = "SELECT * FROM ".TABLE_ALBUM_CAT." ORDER BY cat_title";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not query Album Categories information", "", __LINE__, __FILE__, $sql);
		}
		$total_cat = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$catrow[] = $row;
			$total_cat++;
		}

		for ($i = 0; $i < $total_cat; $i++)
		{
			$lock = $catrow[$i]['cat_lock'] ? 'unlock' : 'lock';

			$template->assign_block_vars('catrow', array(
				'COLOR' => ($i % 2) ? 'row1' : 'row2',
				'TITLE' => $catrow[$i]['cat_title'],
				'S_LOCK' => $catrow[$i]['cat_lock'] ? 'Unlock' : 'Lock',
				'S_EDIT_ACTION' => append_sid("admin_album_cat.$phpEx?action=edit&amp;cat_id=" . $catrow[$i]['cat_id']),
				'S_LOCK_ACTION' => append_sid("admin_album_cat.$phpEx?action=$lock&amp;cat_id=" . $catrow[$i]['cat_id']),
				'S_DELETE_ACTION' => append_sid("admin_album_cat.$phpEx?action=delete&amp;cat_id=" . $catrow[$i]['cat_id'])
				)
			);
		}

		$template->pparse('body');

		include('./page_footer_admin.'.$phpEx);

	}
	else // Create new category
	{
		$new_cat = htmlspecialchars(trim($HTTP_POST_VARS['new_cat']));
		$cat_lock = htmlspecialchars(trim($HTTP_POST_VARS['cat_lock']));

		$sql = "INSERT INTO ".TABLE_ALBUM_CAT." VALUES ('','$new_cat','$cat_lock')";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not create new Category", "", __LINE__, __FILE__, $sql);
		}
		else
		{
			$message = "The category $new_cat has been created successfully<br /><br />" . sprintf($lang['Click_return_album_category'], "<a href=\"" . append_sid("admin_album_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

			message_die(GENERAL_MESSAGE, $message);
		}
	}
}
else
{
	$cat_id = $HTTP_GET_VARS['cat_id'];

	if ($HTTP_GET_VARS['action'] == 'edit')
	{
		if (!isset($HTTP_POST_VARS['new_title']))
		{
			$template->set_filenames(array(
				'body' => 'admin/album_edit_body.tpl')
			);

			$template->assign_vars(array(
				'L_ALBUM_MANAGER_TITLE' => $lang['Album_Manager_Title'],
				'L_ALBUM_MANAGER_EXPLAIN' => $lang['Album_Manager_Explain'],
				'S_EDIT_ACTION' => append_sid("admin_album_cat.$phpEx?action=edit&amp;cat_id=$cat_id"),
				'L_RESET' => $lang['Reset'],
				'L_SUBMIT' => $lang['Submit']
				) // end array
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		else
		{
			$new_title = htmlspecialchars(trim($HTTP_POST_VARS['new_title']));

			$sql = "UPDATE " . TABLE_ALBUM_CAT . " SET cat_title = '$new_title' WHERE cat_id = '".$cat_id."'";
	
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Could not update Category information", "", __LINE__, __FILE__, $sql);
			}
			else
			{
				$message = "This category has been renamed successfully<br /><br />" . sprintf($lang['Click_return_album_category'], "<a href=\"" . append_sid("admin_album_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

				message_die(GENERAL_MESSAGE, $message);
			}
		}
	}
	elseif ($HTTP_GET_VARS['action'] == 'delete')
	{
		// Get all files information in this category
		$sql = "SELECT filename FROM ".TABLE_ALBUM." WHERE cat_id = '$cat_id'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
		}

		$total_pics = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$picrow[] = $row;
			$total_pics++;
		}

		// Delete all files
		for ($i = 0; $i < $total_pics; $i++)
		{
			@unlink($phpbb_root_path . ALBUM_UPLOAD_PATH . $picrow[$i]['filename']);
		}

		// Delete all SQL entries
		$sql = "DELETE FROM ".TABLE_ALBUM." WHERE cat_id = '$cat_id'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not update Album information", "", __LINE__, __FILE__, $sql);
		}

		// Remove this category
		$sql = "DELETE FROM ".TABLE_ALBUM_CAT." WHERE cat_id = '$cat_id'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not update Album Category information", "", __LINE__, __FILE__, $sql);
		}

		$message = "This category has been removed successfully<br /><br />" . sprintf($lang['Click_return_album_category'], "<a href=\"" . append_sid("admin_album_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	elseif ($HTTP_GET_VARS['action'] == 'lock')
	{
		$sql = "UPDATE ".TABLE_ALBUM_CAT." SET cat_lock = '1' WHERE cat_id = '$cat_id'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not update Category information", "", __LINE__, __FILE__, $sql);
		}
		else
		{
			$message = "This category has been locked successfully<br /><br />" . sprintf($lang['Click_return_album_category'], "<a href=\"" . append_sid("admin_album_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

			message_die(GENERAL_MESSAGE, $message);
		}
	}
	elseif ($HTTP_GET_VARS['action'] == 'unlock')
	{
		$sql = "UPDATE ".TABLE_ALBUM_CAT." SET cat_lock = '0' WHERE cat_id = '$cat_id'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not update Category information", "", __LINE__, __FILE__, $sql);
		}
		else
		{
			$message = "This category has been unlocked successfully<br /><br />" . sprintf($lang['Click_return_album_category'], "<a href=\"" . append_sid("admin_album_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

			message_die(GENERAL_MESSAGE, $message);
		}
	}
}

?>