<?php
/***************************************************************************
*                             admin_mass_email.php
*                              -------------------
*     begin                : Thu May 31, 2001
*     copyright            : (C) 2001 The phpBB Group
*     email                : support@phpbb.com
*
*     $Id: admin_mass_email.php,v 1.15.2.5 2002/05/20 00:52:18 psotfx Exp $
*
****************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['General']['Mass_Email'] = $filename;
	
	return;
}

//
// Load default header
//
$no_page_header = TRUE;
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

//
// Increase maximum execution time in case of a lot of users, but don't complain about it if it isn't
// allowed.
//
@set_time_limit(1200);

$message = '';
$subject = '';

//
// Do the job ...
//
if ( isset($HTTP_POST_VARS['refine_recipients']) )
{
	$group_id = intval($HTTP_POST_VARS[POST_GROUPS_URL]);

	$sql = ( $group_id != -1 ) ? "SELECT u.user_email, u.username, u.user_id FROM " . USERS_TABLE . " u, " . USER_GROUP_TABLE . " ug WHERE ug.group_id = $group_id AND ug.user_pending <> " . TRUE . " AND u.user_id = ug.user_id" : "SELECT user_email, username, user_id FROM " . USERS_TABLE . " WHERE user_id <> -1";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not select group members', '', __LINE__, __FILE__, $sql);
	}

	if ( $row = $db->sql_fetchrow($result))
	{
		do
		{
			$user_list[] = $row;
		}
		while ( $row = $db->sql_fetchrow($result) );

		$db->sql_freeresult($result);
	}
	else
	{
		$message = ( $group_id != -1 ) ? $lang['Group_not_exist'] : $lang['No_such_user'];

		$error = true;
		$error_msg .= ( !empty($error_msg) ) ? '<br />' . $message : $message;
	}

	$upr = 5;
	$ul_count = 0;
	$ul_max = ( @sizeof($user_list) - 1 % 2 ? @sizeof($user_list) - 1 : @sizeof($user_list) );
	$ul_rem_users = $ul_max % $upr;
	$ul_rows = ($ul_max - $ul_rem_users) / $upr;

	//Parse each ROW
	for( $rc=1; $rc <= $ul_rows; $rc++)
	{
		$row_color = ( !($rc % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
		$row_class = ( !($rc % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

		$template->assign_block_vars('ml_row', array(
			'ROW_COLOR' => '#' . $row_color,
			'ROW_CLASS' => $row_class)
		);

		//Parse each user from the current ROW
		for( $uc=($rc-1)*$upr; $uc<=$rc*$upr-1; $uc++)
		{
			$template->assign_block_vars('ml_row.user', array(
				'EMAIL' => $user_list[$uc]['user_email'],
				'USERNAME' => $user_list[$uc]['username'],
				
				'U_USER_PROFILE' => append_sid($phpbb_root_path."profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $user_list[$uc]['user_id'])
				)
			);
		}
	}

	//Work with the remaining USERS
	$row_color = ( $row_color == $theme['td_color2']) ? $theme['td_color1'] : $theme['td_color2'];
	$row_class = ( $row_class == $theme['td_class2']) ? $theme['td_class1'] : $theme['td_class2'];

	$template->assign_block_vars('ml_row', array(
		'ROW_COLOR' => '#' . $row_color,
		'ROW_CLASS' => $row_class)
	);

//	for( $uc=($rc-1)*$upr; $uc<=$ul_rem_users; $uc++)
for( $uc=($ul_rows)*$upr; $uc<=$ul_rem_users+($ul_rows)*$upr; $uc++)
	{
		$template->assign_block_vars('ml_row.user', array(
			'EMAIL' => $user_list[$uc]['user_email'],
			'USERNAME' => $user_list[$uc]['username'],

			'U_USER_PROFILE' => append_sid($phpbb_root_path."profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $user_list[$uc]['user_id'])
			)
		);
	}

	$template->set_filenames(array(
		'refine_box' => 'admin/refine_email_body.tpl')
	);

	$template->assign_var_from_handle('REFINE_BOX', 'refine_box');
	
}
if ( isset($HTTP_POST_VARS['submit']) )
{
	$subject = stripslashes(trim($HTTP_POST_VARS['subject']));
	$message = stripslashes(trim($HTTP_POST_VARS['message']));

	$mail_list = $HTTP_POST_VARS['mail_list'];
	
	$error = FALSE;
	$error_msg = '';

	if ( empty($subject) )
	{
		$error = true;
		$error_msg .= ( !empty($error_msg) ) ? '<br />' . $lang['Empty_subject'] : $lang['Empty_subject'];
	}

	if ( empty($message) )
	{
		$error = true;
		$error_msg .= ( !empty($error_msg) ) ? '<br />' . $lang['Empty_message'] : $lang['Empty_message'];
	}
	if ( empty($mail_list) )
	{
		$group_id = intval($HTTP_POST_VARS[POST_GROUPS_URL]);

		$sql = ( $group_id != -1 ) ? "SELECT u.user_email FROM " . USERS_TABLE . " u, " . USER_GROUP_TABLE . " ug WHERE ug.group_id = $group_id AND ug.user_pending <> " . TRUE . " AND u.user_id = ug.user_id" : "SELECT user_email FROM " . USERS_TABLE;
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select group members', '', __LINE__, __FILE__, $sql);
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			$bcc_list = '';
			do
			{
				$bcc_list .= ( ( $bcc_list != '' ) ? ', ' : '' ) . $row['user_email'];
			}
			while ( $row = $db->sql_fetchrow($result) );

			$db->sql_freeresult($result);
		}
		else
		{
			$message = ( $group_id != -1 ) ? $lang['Group_not_exist'] : $lang['No_such_user'];

			$error = true;
			$error_msg .= ( !empty($error_msg) ) ? '<br />' . $message : $message;
		}
	}
	else if ( is_array($mail_list) )
	{
		$bcc_list = '';

		while ( list($chave, $email) = @each($mail_list) )
		{
			$bcc_list .= ( ( $bcc_list != '' ) ? ', ' : '' ) . $email;
		}	
	}
	if ( !$error )
	{
		include($phpbb_root_path . 'includes/emailer.'.$phpEx);

		//
		// Let's do some checking to make sure that mass mail functions
		// are working in win32 versions of php.
		//
		if ( preg_match('/[c-z]:\\\.*/i', getenv('PATH')) && !$board_config['smtp_delivery'])
		{
			$ini_val = ( @phpversion() >= '4.0.0' ) ? 'ini_get' : 'get_cfg_var';

			// We are running on windows, force delivery to use our smtp functions
			// since php's are broken by default
			$board_config['smtp_delivery'] = 1;
			$board_config['smtp_host'] = @$ini_val('SMTP');
		}

		$emailer = new emailer($board_config['smtp_delivery']);
	
		$email_headers = 'Return-Path: ' . $userdata['board_email'] . "\nFrom: " . $board_config['board_email'] . "\n";
		$email_headers .= 'X-AntiAbuse: Board servername - ' . $board_config['server_name'] . "\n";
		$email_headers .= 'X-AntiAbuse: User_id - ' . $userdata['user_id'] . "\n";
		$email_headers .= 'X-AntiAbuse: Username - ' . $userdata['username'] . "\n";
		$email_headers .= 'X-AntiAbuse: User IP - ' . decode_ip($user_ip) . "\n";
		$email_headers .= "Bcc: $bcc_list\n";

		$emailer->use_template('admin_send_email');
		$emailer->email_address($board_config['board_email']);
		$emailer->set_subject($subject);
		$emailer->extra_headers($email_headers);

		$emailer->assign_vars(array(
			'SITENAME' => $board_config['sitename'], 
			'BOARD_EMAIL' => $board_config['board_email'], 
			'MESSAGE' => $message)
		);
		$emailer->send();
		$emailer->reset();

		message_die(GENERAL_MESSAGE, $lang['Email_sent'] . '<br /><br />' . sprintf($lang['Click_return_admin_index'],  '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>'));
	}
}	

if ( $error )
{
	$template->set_filenames(array(
		'reg_header' => 'error_body.tpl')
	);
	$template->assign_vars(array(
		'ERROR_MESSAGE' => $error_msg)
	);
	$template->assign_var_from_handle('ERROR_BOX', 'reg_header');
}

//
// Initial selection
//

$sql = "SELECT group_id, group_name 
	FROM ".GROUPS_TABLE . "  
	WHERE group_single_user <> 1";
if ( !($result = $db->sql_query($sql)) ) 
{
	message_die(GENERAL_ERROR, 'Could not obtain list of groups', '', __LINE__, __FILE__, $sql);
}

$select_list = '<select name = "' . POST_GROUPS_URL . '"><option value = "-1">' . $lang['All_users'] . '</option>';
if ( $row = $db->sql_fetchrow($result) )
{
	do
	{
		$selected = ($row['group_id'] == $group_id) ? 'selected="selected"' : '';
		$select_list .= '<option value = "' . $row['group_id'] . '"' . $selected . '>' . $row['group_name'] . '</option>';
	}
	while ( $row = $db->sql_fetchrow($result) );
}
$select_list .= '</select>';

//
// Generate page
//
include('./page_header_admin.'.$phpEx);

$template->set_filenames(array(
	'body' => 'admin/user_email_body.tpl')
);

$template->assign_vars(array(
	'L_REFINE_RECIPIENTS' => $lang['Refine_recipients'],
	'L_RECIPIENTS_LIST' => $lang['Recipients_list']
	)
);

$template->assign_vars(array(
	'MESSAGE' => $message,
	'SUBJECT' => $subject, 

	'L_EMAIL_TITLE' => $lang['Email'],
	'L_EMAIL_EXPLAIN' => $lang['Mass_email_explain'],
	'L_COMPOSE' => $lang['Compose'],
	'L_RECIPIENTS' => $lang['Recipients'],
	'L_EMAIL_SUBJECT' => $lang['Subject'],
	'L_EMAIL_MSG' => $lang['Message'],
	'L_EMAIL' => $lang['Email'],
	'L_NOTICE' => $notice,

	'S_USER_ACTION' => append_sid('admin_mass_email.'.$phpEx),
	'S_GROUP_SELECT' => $select_list)
);

$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>