<?php
/*************************************************************************** 
*                            admin_delete_zero.php 
*             php Admin Script for delete inactive mod 
*                       ------------------- 
*   begin                : April 30, 2002 
*   email                : ncr@db9.dk HTTP://mods.db9.dk 
*      ver. 0.9.3. 
* 
* 
*   History:
* 	ver 0.9.0. - initial BETA
*     ver 0.9.1. - added prune inativated option
*	ver 0.9.2. - added support for the end user easely can customise the
*			 interface with more options    
*	ver 0.9.3. - changed $lang['prune'] to $lang['Prune__commands']
*
***************************************************************************/ 

/*************************************************************************** 
* 
*   This program is free software; you can redistribute it and/or modify 
*   it under the terms of the GNU General Public License as published by 
*   the Free Software Foundation; either version 2 of the License, or 
*   (at your option) any later version. 
* 
***************************************************************************/ 

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['General'][$lang['Prune_users']] = $filename;
	return;
}
//
// Load default header
//
$no_page_header = TRUE;
$phpbb_root_path = "../";
require($phpbb_root_path . 'extension.inc');
require('pagestart.' . $phpEx);
$sql = array();
$default = array();


// ********************************************************************************
// from here you can define you own delete creterias, if you makes more, then you shall also
// edit the files lang_main.php, and the file delete_users.php, so they hold the same amount
// of options

//
// Initial selection
//

// find zero posters
$sql [0] = ' AND user_posts="0"';
$default [0] = 10;
// find inactive users who have newer logged in
$sql [1] = ' AND user_lastvisit="0"';
$default [1] = 45;

// find not activated users
$sql [2] = ' AND user_lastvisit=0 AND user_active=0';
$default [2] = 5;

// ********************************************************************************
// ****************** Do not change any thing below *******************************

$options = '<option value="1">&nbsp;'.$lang['1_Day'].'</option>
	<option value="7">&nbsp;'.$lang['7_Days'].'</option>
	<option value="14">&nbsp;'.$lang['2_Weeks'].'</option>
	<option value="30">&nbsp;'.$lang['1_Month'].'</option>
	<option value="90">&nbsp;'.$lang['3_Months'].'</option>
	<option value="180">&nbsp;'.$lang['6_Months'].'</option>
	<option value="365">&nbsp;'.$lang['1_Year'].'</option>
  	</select>';

//
// Generate page
//
include('page_header_admin.'.$phpEx);
$template->set_filenames(array("body" => "admin/prune_users_body.tpl"));
$n=0;
while ( !empty($sql[$n]) )
{
	$vars='days_'.$n;
	$default [$n] = ($default [$n])?$default [$n]:10;
	$days [$n] = ( isset($HTTP_GET_VARS[$vars]) ) ? $HTTP_GET_VARS[$vars] : (( isset($HTTP_POST_VARS[$vars]) ) ? intval($HTTP_POST_VARS[$vars]) : $default[$n]);

	$select[$n] = '<select name="days_'.$n.'" size="1" onchange="SetLastVisit();" class="gen">
		<option value="'.$days[$n].'" SELECTED>&nbsp;'.$days[$n].' '.$lang['Days'].'&nbsp;</option>'.$options;
	if(!$result = $db->sql_query('SELECT user_id , username, user_level FROM '. USERS_TABLE .' WHERE user_id<>"'.ANONYMOUS.'"'.$sql[$n].' AND user_regdate<"'.(time()-(86400*$days [$n])).'"'))
		message_die(GENERAL_ERROR, 'Error obtaining userdata', '', __LINE__, __FILE__, $sql[$n]);
	$user_list = $db->sql_fetchrowset($result);
	for($i = 0; $i < count($user_list); $i++) 
	{ 
		$style_color = ($user__list[$i]['user_level'] == ADMIN )?'style="color:#' . $theme['fontcolor3'] . '"':(( $user__list[$i]['user_level'] == MOD )?'style="color:#' . $theme['fontcolor2'] . '"':''); 
		$list[$n] .= ' <a href="' . append_sid($phpbb_root_path."profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $user_list[$i]['user_id']) . '"' . $style_color .'>' . $user_list[$i]['username'] . '</a>'; 
	}
	$db->sql_freeresult($result);
$template->assign_block_vars('prune_list', array(
		"LIST" => ($list[$n])?$list[$n]:$lang['None'],
		"L_PRUNE" => $lang['Prune_commands'][$n],
		"L_PRUNE_EXPLAIN" => sprintf($lang['Prune_explain'][$n],$days[$n]),
		"S_DAYS" => $select[$n],
		"U_PRUNE" => '<a href="'.append_sid($phpbb_root_path.'delete_users.php?mode=prune_'.$n.'&days='.$days[$n]).'">'.$lang['Prune_commands'][$n].'<a>',));
	$n++;
}

$template->assign_vars(array(
	"L_PRUNE_ACTION" => $lang['Prune_Action'],
	"L_PRUNE_LIST" =>	$lang['Prune_user_list'],
	"L_DAYS" => $lang['Days'],
	"L_PRUNE_USERS" => $lang['Prune_users'],
	"L_PRUNE_USERS_EXPLAIN" => $lang['Prune_users_explain'],
));

$template->pparse('body');
include('page_footer_admin.'.$phpEx);

?>
