<?php
/***************************************************************************
 *                           album_thumbnail.php
 *                           -------------------
 *   begin                : Monday, July 15, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor_xp@hotmail.com
 *
 *   $Id: album_thumbnail.php,v 1.6.5 2002/11/05, 13:28:43 ngoctu Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'album_mod/album_common.'.$phpEx);

error_reporting(E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

//
// Get Album Configuration
//
$sql = "SELECT * FROM " . TABLE_ALBUM_CONFIG;
if(!$result = $db->sql_query($sql))
{
	exit();
}

while( $row = $db->sql_fetchrow($result) )
{
	$album_config_name = $row['config_name'];
	$album_config_value = $row['config_value'];
	$album_config[$album_config_name] = $album_config_value;
}

// Check View Level
$user_level = $userdata['user_level'];

if ($user_level == 2)
{
	$user_level = 0;
}

if ($album_config['view_level'] > -1)
{
	if (!$userdata['session_logged_in'])
	{
		exit();
	}

	if ($user_level < $album_config['view_level'])
	{
		exit();
	}
}

if ( !isset($HTTP_GET_VARS['id']) )
{
	exit();
}

// OK, now get information from the database
$sql = "SELECT * FROM " . TABLE_ALBUM . " WHERE id=" . $HTTP_GET_VARS['id'];

if(!$result = $db->sql_query($sql))
{
	exit();
}

$pic = $db->sql_fetchrow($result);

// If this ID not found
if (empty($pic))
{
	exit();
}

// Read the original file
$file_ext = substr($pic['filename'], strlen($pic['filename']) - 4, 4 );

$src = 0;

switch ( $file_ext )
{
	case '.gif':		
		header('Content-Disposition: inline; filename=nothumbnail.jpg');
		header('Content-type: image/jpeg');
		readfile(ALBUM_PATH  . 'nothumbnail.jpg');
		exit();
		break;
	case '.png':
		$src = @ImageCreateFromPNG(ALBUM_UPLOAD_PATH  . $pic['filename']);
		break;
	case '.jpg':
		$src = @ImageCreateFromJPEG(ALBUM_UPLOAD_PATH  . $pic['filename']);
		break;
}

if (!$src)
{
	if( ($album_config['thumbnail_force_GIF'] == 1) and (file_exists(ALBUM_UPLOAD_PATH . $pic['filename'])) )
	{
		header('Content-Disposition: inline; filename=' . $pic['filename']);
		header('Content-type: file');
		readfile(ALBUM_UPLOAD_PATH  . $pic['filename']);		
	}
	else
	{
		header('Content-Disposition: inline; filename=nothumbnail.jpg');
		header('Content-type: image/jpeg');
		readfile(ALBUM_PATH  . 'nothumbnail.jpg');
	}
}
else
{
	// Generate Thumbnail
	$size = @GetImageSize(ALBUM_UPLOAD_PATH  . $pic['filename']);
	if(!$size)
	{
		header('Content-Disposition: inline; filename=nothumbnail.jpg');
		header('Content-type: image/jpeg');
		readfile(ALBUM_PATH  . 'nothumbnail.jpg');
		exit();
	}

	$orig_width = $size[0];
	$orig_height = $size[1];

	if (($orig_width < 1) or ($orig_height < 1))
	{
		header('Content-Disposition: inline; filename=nothumbnail.jpg');
		header('Content-type: image/jpeg');
		readfile(ALBUM_PATH  . 'nothumbnail.jpg');
		exit();
	}

	$max_dimension = isset($HTTP_GET_VARS['size'])? intval($HTTP_GET_VARS['size']) : 150;
	
	if( ($orig_width > $max_dimension) or ($orig_height > $max_dimension) )
	{
		if ($orig_width > $orig_height)
		{
			$thumbnail_width = $max_dimension;
			$thumbnail_height = $max_dimension * ($orig_height/$orig_width);
		}
		else
		{
			$thumbnail_height = $max_dimension;
			$thumbnail_width = $max_dimension * ($orig_width/$orig_height);
		}
	
		$thumbnail = ImageCreate($thumbnail_width, $thumbnail_height);
		//$thumbnail = ImageCreatetruecolor($thumbnail_width, $thumbnail_height);
	
		ImageCopyResized($thumbnail, $src, 0, 0, 0, 0, $thumbnail_width, $thumbnail_height, $orig_width, $orig_height);	
	}
	else
	{
		$thumbnail = $src;
	}

	// Send to browser
	switch ( $file_ext )
	{
		case '.png':
			ImagePNG($thumbnail);break;
		default:
			ImageJPEG($thumbnail, '', $album_config['thumbnail_quality']);break;
	}
}

?>