<?php
/***************************************************************************
 *                              album_view.php
 *                           -------------------
 *   begin                : Saturday, July 13, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor_xp@hotmail.com
 *
 *   $Id: album_view.php,v 1.0.0 2002/7/14, 13:49:56 hnt Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'album_mod/album_common.'.$phpEx);

error_reporting(E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

// Check View Level
$sql = "SELECT * FROM " . TABLE_ALBUM_CONFIG;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album config information", "", __LINE__, __FILE__, $sql);
}

while( $row = $db->sql_fetchrow($result) )
{
	$config_name = $row['config_name'];
	$config_value = $row['config_value'];
	$config[$config_name] = $config_value;
}

$user_level = $userdata['user_level'];

if ($user_level == 2)
{
	$user_level = 0;
}

if ($config['view_level'] > -1)
{
	if (!$userdata['session_logged_in'])
	{
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=album.$phpEx", true));
		exit;
	}

	if ($user_level < $config['view_level'])
	{
		message_die(GENERAL_MESSAGE, $lang['Not_allowed_to_view_album']);
	}
}

if ( !isset($HTTP_GET_VARS['id']) )
{
	message_die(GENERAL_ERROR, 'Bad Request');
}

//////////////////////////// īװ  
$sql = "SELECT *  FROM ".TABLE_ALBUM_CAT." ORDER BY cat_id ASC";
if(!$result = $db->sql_query($sql)) {
	message_die(GENERAL_ERROR, "Could not query Album Category information", "", __LINE__, __FILE__, $sql);
}
$cat_list = $db->sql_numrows($result);
$cat_row = $db->sql_fetchrowset($result);
for ($i = 0; $i < $cat_list; $i++) {

$cat_id = $cat_row[$i]['cat_id'];
$cat_title = "<a href='".append_sid("album.$phpEx?cat_id=$cat_id")."'>".$cat_row[$i]['cat_title']."</a>";
//////////////////////////////////////////////īװ ũ 
$sql = "SELECT cat_id FROM ".TABLE_ALBUM." WHERE cat_id = '".$cat_row[$i]['cat_id']."' ";
if(!$result = $db->sql_query($sql)) { 
   message_die(GENERAL_ERROR, "ũ ...", "", __LINE__, __FILE__, $sql); 
}
$cat_img_num = $db->sql_numrows($result);
///////////////////////////////////////////////////////////////
$template->assign_block_vars('cat_list', array(  
        'CAT_IMG_NUM' => $cat_img_num,			
		'CAT_TITLE'   => $cat_title)
	);   
$template->assign_vars(array(  
        'CAT_ID'      => $cat_id,
        'CAT_NUM'     => $cat_list,)
	);
}      
/////////////////////////////// īװ  

// Get Pic Information
$sql = "SELECT * FROM " . TABLE_ALBUM . " WHERE id=" . $HTTP_GET_VARS['id'];

if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
}

$pic = $db->sql_fetchrow($result);

// If this ID not found
if (empty($pic))
{
	$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
	header($header_location . append_sid("album.$phpEx", true));
	exit;
}

// Found pic then output the page
$page_title = $lang['Album'] . ' - ' . $pic['title'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'album_view_body.tpl')
);
make_jumpbox('viewforum.'.$phpEx);

$pic_id = $pic['id'];
$pic_filename= ALBUM_UPLOAD_PATH . $pic['filename'];
$pic_user_id = $pic['user_id'];

if ($pic_user_id > 0)
{
	$pic_username = "<a href='".append_sid("profile.$phpEx?mode=viewprofile&amp;u=$pic_user_id")."'>".$pic['username']."</a>";
}
else
{
	$pic_username = $lang['Guest'];
}

 /////////////////////////// ȸ
if(!$mode) 
{
mysql_query("update phpbb_album SET view_time = view_time+1 where id ='$id'");
}
 /////////////////////////// ȸ 

///////////////////////////  ε  5
$sql = "SELECT user_id,username, COUNT(username) as number FROM ".TABLE_ALBUM." WHERE  username <> '' GROUP BY username  ORDER BY number DESC LIMIT 5";
if(!$result = $db->sql_query($sql)) {
	message_die(GENERAL_ERROR, "ٹ  Ҽ Դϴ.", "", __LINE__, __FILE__, $sql);
}
$user_pics = $db->sql_numrows($result);
$user_name = $db->sql_fetchrowset($result);

for ($i = 0; $i < $user_pics; $i++) 
{
$pic_user_id = $user_name[$i]['user_id'];
$template->assign_block_vars('top_img_user', array(
        'USER_RANK' => $i+1,
		'USER_PIC_COUNT' => $user_name[$i]['number'],			
		'USER_NAME'   => "<a href='".append_sid("profile.$phpEx?mode=viewprofile&amp;u=$pic_user_id")."'>".$user_name[$i]['username']."</a>")
	);
}
//////////////////////////////  ε  5 

////////////////////////////// α ȸ ̹  5
$sql = "SELECT id,title,view_time FROM ".TABLE_ALBUM." WHERE id ORDER BY view_time DESC LIMIT 5";
if(!$result = $db->sql_query($sql)) {
	message_die(GENERAL_ERROR, "ڸƮ  Ҽ Դϴ.", "", __LINE__, __FILE__, $sql);
}
$pic_views = $db->sql_numrows($result);
$view_data = $db->sql_fetchrowset($result);
for ($i = 0; $i < $pic_views; $i++) 
{
$pic_title_id = $view_data[$i]['id'];
$template->assign_block_vars('top_img_views', array(  
        'PIC_RANK' => $i+1,
		'PIC_VIEW_COUNT' => $view_data[$i]['view_time'],			
		'PIC_TITLE'   => "<a href='".append_sid("album_view.$phpEx?id=$pic_title_id")."'>".$view_data[$i]['title']."</a>")
	);
}       
///////////////////////////// α ȸ ̹  5 

/////////////////////////////ڸƮ 
$sql = "SELECT * FROM ".TABLE_ALBUM_COMMENT." WHERE id = $pic_id ORDER BY time DESC";
if(!$result = $db->sql_query($sql)) 
{
	message_die(GENERAL_ERROR, "ڸƮ  Ҽ Դϴ.", "", __LINE__, __FILE__, $sql);
}
$comments = $db->sql_numrows($result);
$pic_comment = $db->sql_fetchrowset($result);  
for ($i = 0; $i < $comments; $i++) 
{ 
   ////////////// ȸ   ũ ƴҰ쿡 մμ ũ  ʴ´.
   if ($pic_comment[$i]['user_id'] != '-1') 
   {
   $username = '<a href="' . append_sid("profile.php?mode=viewprofile&u=".$pic_comment[$i]['user_id']) . '">' . $pic_comment[$i]['username'] . '</a>';
   }
   else 
   {
   $username = $lang['Guest'];
   }
$template->assign_block_vars("comment", array(
    'COMMENT'  => nl2br(stripslashes($pic_comment[$i]['comment'])),
    'USERNAME' => '<a href="' . append_sid("album_comment.$phpEx?mode=com_del&no=".$pic_comment[$i]['no']) . '">'.'<img src="' . $images['icon_latest_reply'] . '" border="0" alt="̹ ڸƮ" />'.'</a>' . '&nbsp;'.$username,
    'COM_TIME' => date("Y m d",$pic_comment[$i]['time'])
  )  
 ); 
    
} 
///////////////////////////ڸƮ  

$template->assign_vars(array(
    'ACTION'  => append_sid("album_comment.$phpEx?action=write"),
	'L_ALBUM' => $lang['Album'],
	'U_ALBUM' => append_sid('album.'.$phpEx),
	'ALBUM_NOTE' => __ALBUM__,
	'TITLE' => $pic['title'],
	'IMAGE' => append_sid("album_see.$phpEx?id=$pic_id"),
    'PIC_IMAGE' => $pic_filename,
	'POSTER' => $pic_username,
	'L_UPLOADED_BY' => $lang['Uploaded_by'],
	'PIC_ID' => $pic['id'],
	'UPLOAD_PIC_IMG' => $images['upload_pic'],
	'U_UPLOAD_PIC' => append_sid('album_upload.'.$phpEx),
	'L_UPLOAD_PIC' => $lang['Upload_New_Pic'],
	)
);


$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>