<?php
/***************************************************************************
 *							   attachment_mod.php
 *                            -------------------
 *   begin                : Monday, Jan 07, 2002
 *   copyright            : (C) 2002 Meik Sievertsen
 *   email                : acyd.burn@gmx.de
 *
 *   $Id: attachment_mod.php,v 1.13 2002/11/21 16:45:54 acydburn Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
	exit;
}

include($phpbb_root_path . 'attach_mod/includes/constants.'.$phpEx);
include($phpbb_root_path . 'attach_mod/includes/functions_includes.'.$phpEx);
include($phpbb_root_path . 'attach_mod/includes/functions_attach.'.$phpEx);
include($phpbb_root_path . 'attach_mod/includes/functions_delete.'.$phpEx);
include($phpbb_root_path . 'attach_mod/includes/functions_thumbs.'.$phpEx);
include($phpbb_root_path . 'attach_mod/includes/functions_filetypes.'.$phpEx);

if ( defined('ATTACH_INSTALL') )
{
	return;
}

function include_attach_lang()
{
	global $phpbb_root_path, $phpEx, $lang, $board_config;
	
	//
	// Include Language
	//
	$language = $board_config['default_lang'];

	if ( !@file_exists(@realpath($phpbb_root_path . 'language/lang_' . $language . '/lang_main_attach.'.$phpEx)) )
	{
		$language = 'english';
	}

	include($phpbb_root_path . 'language/lang_' . $language . '/lang_main_attach.' . $phpEx);

	if ( defined('IN_ADMIN') )
	{
		if( !@file_exists(@realpath($phpbb_root_path . 'language/lang_' . $language . '/lang_admin_attach.'.$phpEx)) )
		{
			$language = 'english';
		}

		include($phpbb_root_path . 'language/lang_' . $language . '/lang_admin_attach.' . $phpEx);
	}

}

//
// Get Attachment Config
//
$attach_config = array();

$sql = 'SELECT *
FROM ' . ATTACH_CONFIG_TABLE;
	 
if ( !($result = attach_sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query attachment information', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$attach_config[$row['config_name']] = trim($row['config_value']);
}

// Please do not change the include-order, it is valuable for proper execution.
// Functions for displaying Attachment Things
include($phpbb_root_path . 'attach_mod/displaying.'.$phpEx);
// Posting Attachments Class (HAVE TO BE BEFORE PM)
include($phpbb_root_path . 'attach_mod/posting_attachments.'.$phpEx);
// PM Attachments Class
include($phpbb_root_path . 'attach_mod/pm_attachments.'.$phpEx);

if ( defined('IN_ADMIN') )
{
	if (!$attach_config['allow_ftp_upload'])
	{
		if ( ($attach_config['upload_dir'][0] == '/') || ( ($attach_config['upload_dir'][0] != '/') && ($attach_config['upload_dir'][1] == ':') ) )
		{
			$upload_dir = $attach_config['upload_dir'];
		}
		else
		{
			$upload_dir = '../' . $attach_config['upload_dir'];
		}
	}
	else
	{
		$upload_dir = $attach_config['download_path'];
	}

	include($phpbb_root_path . 'attach_mod/includes/functions_selects.' . $phpEx);
	include($phpbb_root_path . 'attach_mod/includes/functions_admin.' . $phpEx);
}
else
{
	if (!$attach_config['allow_ftp_upload'])
	{
		$upload_dir = $attach_config['upload_dir'];
	}
	else
	{
		$upload_dir = $attach_config['download_path'];
	}
}

?>