<?php

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);


//
// Parameters
//
$start = (!empty($HTTP_GET_VARS['start'])) ? intval ($HTTP_GET_VARS['start']) : 0;
$cancel = (isset ($HTTP_POST_VARS['cancel'])) ? TRUE : 0;
$confirm = (isset ($HTTP_POST_VARS['confirm'])) ? TRUE : 0;
$add = (isset ($HTTP_POST_VARS['add'])) ? TRUE : 0;
$remove = (isset ($HTTP_POST_VARS['remove'])) ? TRUE : 0;
$remove_all = (isset ($HTTP_POST_VARS['removeall'])) ? TRUE : 0;
$username = (isset ($HTTP_POST_VARS['username'])) ? $HTTP_POST_VARS['username'] : '';

$mark_list = (!empty ($HTTP_POST_VARS['mark'])) ? $HTTP_POST_VARS['mark'] : 0;


//
// Start session management
//
$userdata = session_pagestart ($user_ip, PAGE_BUDDIES);
init_userprefs ($userdata);
//
// End session management
//


if (!$userdata['session_logged_in']) {
	$header_location = (@preg_match ('/Microsoft|WebSTAR|Xitami/', getenv ('SERVER_SOFTWARE')) ) ? 'Refresh: 0; URL=' : 'Location: ';
	header ($header_location . append_sid ("login.$phpEx?redirect=buddylist.$phpEx", true));
	exit;
	}


//
// Cancel 
//
if ($cancel) {
	$header_location = (@preg_match ('/Microsoft|WebSTAR|Xitami/', getenv ('SERVER_SOFTWARE'))) ? 'Refresh: 0; URL=' : 'Location: ';
	header ($header_location . append_sid ("buddylist.$phpEx", true));
	exit;
	}


if (($remove && $mark_list) || $remove_all) {
	if (isset ($mark_list) && !is_array ($mark_list)) {
		$mark_list = array ();
		}
	
	if (!$confirm) {
		$s_hidden_fields = (isset($HTTP_POST_VARS['remove'])) ? '<input type="hidden" name="remove" value="true" />' : '<input type="hidden" name="removeall" value="true" />';
		
		for($i = 0; $i < count($mark_list); $i++) {
			$s_hidden_fields .= '<input type="hidden" name="mark[]" value="' . $mark_list[$i] . '" />';
			}

		//
		// Output confirmation page
		//
		include ($phpbb_root_path . 'includes/page_header.'.$phpEx);

		$template->set_filenames (
			array (
				'confirm_body' => 'confirm_body.tpl'
				)
			);
		$template->assign_vars (
			array (
				'MESSAGE_TITLE' => $lang['Information'],
				'MESSAGE_TEXT' => (count($mark_list) == 1) ? $lang['Confirm_remove_buddy'] : $lang['Confirm_remove_buddies'], 

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid ("buddylist.$phpEx"),
				'S_HIDDEN_FIELDS' => $s_hidden_fields
				)
			);

		$template->pparse ('confirm_body');
		include ($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}

	else if ($confirm) {
		if ($remove_all) {
			$sql = "DELETE FROM " . BUDDIES_TABLE . " WHERE user_id = '" . $userdata['user_id'] . "';";
			if (!($result = $db->sql_query ($sql))) {
				message_die (GENERAL_ERROR, 'Could not remove the buddies from the list', '', __LINE__, __FILE__, $sql);
				}
			}

		if (count($mark_list)) {
			$delete_sql_id = implode (', ', $mark_list);
			$sql = "DELETE FROM " . BUDDIES_TABLE . " WHERE buddy_id IN ($delete_sql_id) AND user_id = '" . $userdata['user_id'] . "';";
			if (!($result = $db->sql_query ($sql))) {
				message_die (GENERAL_ERROR, 'Could not remove the buddies from the list', '', __LINE__, __FILE__, $sql);
				}
			}

		$template->assign_vars (
			array (
				'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid ("buddylist.$phpEx") . '">'
				)
			);

		$message = $lang['Buddy_removed'] . '<br /><br />' . sprintf ($lang['Click_return_buddy_list'], '<a href="' . append_sid ("buddylist.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf ($lang['Click_return_index'], '<a href="' . append_sid ("index.$phpEx") . '">', '</a>');
		message_die (GENERAL_MESSAGE, $message);
		}
	}


if ($add) {
	$sql = "SELECT * FROM " . USERS_TABLE . " WHERE username = '$username'";
	if (!($result = $db->sql_query($sql))) {
		message_die (GENERAL_ERROR, 'Could not query user information', '', __LINE__, __FILE__, $sql);
		}
	if (!($row = $db->sql_fetchrow($result))) {
		message_die (GENERAL_MESSAGE, 'User does not exist');
		}
	$buddy_id = $row['user_id'];

	if ($buddy_id == $userdata['user_id']) {
		message_die (GENERAL_MESSAGE, ' 𸮽Ʈ Ҽ ϴ.');
		}


	$sql = "SELECT * FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
	if (!($result = $db->sql_query($sql))) {
		message_die (GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
		}
	if ($row = $db->sql_fetchrow($result)) {
		message_die (GENERAL_MESSAGE, 'User is already in your buddylist');
		}


	$sql = "INSERT INTO " . BUDDIES_TABLE . " VALUES (" . $userdata['user_id'] . "," . $buddy_id . ");";
	if (!($result = $db->sql_query($sql))) {
		message_die (GENERAL_ERROR, 'Could not add the user to your buddylist', '', __LINE__, __FILE__, $sql);
		}

	$template->assign_vars (
		array (
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid ("buddylist.$phpEx") . '">'
			)
		);

	$message = $lang['Buddy_added'] . '<br /><br />' . sprintf ($lang['Click_return_buddy_list'], '<a href="' . append_sid ("buddylist.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf ($lang['Click_return_index'], '<a href="' . append_sid ("index.$phpEx") . '">', '</a>');
	message_die (GENERAL_MESSAGE, $message);
	}


//
// Default page
//
$page_title = $lang['Buddy_list'];
include ($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames (
	array (
		'body' => 'buddylist_body.tpl'
		)
	);
make_jumpbox ('viewforum.'.$phpEx);


//
// General SQL to obtain buddies
//
// Edit $sessiontime to the value set in the configuration
// You can find the session length in Administration Panel => Configuration => Cookie Settings => Session Length
//
$sessiontime = 3600;
$sql_online = "SELECT b.buddy_id, u.username AS buddy_name, u.user_email AS buddy_email, u.user_viewemail
				FROM " . BUDDIES_TABLE . " b, " . USERS_TABLE . " u
				WHERE b.user_id = " . $userdata['user_id'] . "
				AND u.user_id = b.buddy_id
				AND u.user_session_time >= " . (time() - $sessiontime) . "
				ORDER BY u.username";
$sql_offline = "SELECT b.buddy_id, u.username AS buddy_name, u.user_email AS buddy_email, u.user_viewemail
				FROM " . BUDDIES_TABLE . " b, " . USERS_TABLE . " u
				WHERE b.user_id = " . $userdata['user_id'] . "
				AND u.user_id = b.buddy_id
				AND u.user_session_time < " . (time() - $sessiontime) . "
				ORDER BY u.username";

if (!($result = $db->sql_query ($sql_online))) {
	message_die (GENERAL_ERROR, 'Could not query online buddies', '', __LINE__, __FILE__, $sql);
	}
$buddies_online = array ();
while ($row = $db->sql_fetchrow ($result)) {
	$buddies_online[] = $row;
	}
$db->sql_freeresult ($result);

if (!($result = $db->sql_query ($sql_offline))) {
	message_die (GENERAL_ERROR, 'Could not query offline buddies', '', __LINE__, __FILE__, $sql);
	}
$buddies_offline = array ();
while ($row = $db->sql_fetchrow ($result)) {
	$buddies_offline[] = $row;
	}
$db->sql_freeresult ($result);


//
// Dump vars to template
//
$template->assign_vars (
	array (
		'L_NO_BUDDIES_ONLINE' => $lang['No_buddies_online'],
		'L_NO_BUDDIES_OFFLINE' => $lang['No_buddies_offline'],
		'L_ONLINE' => $lang['Online'] . $images['Online'],
		'L_OFFLINE' => $lang['Offline'] . $images['Offline'],

		'L_BUDDY' => $lang['Username'],
		'L_PM' => $lang['Private_Messaging'],
		'L_EMAIL' => $lang['Email'],

		'L_MARK' => $lang['Mark'],
		'L_MARK_ALL' => $lang['Mark_all'], 
		'L_UNMARK_ALL' => $lang['Unmark_all'], 
		'L_REMOVE_MARKED' => $lang['Remove_marked'], 
		'L_REMOVE_ALL' => $lang['Remove_all'],

		'L_ADD_MEMBER' => $lang['Add_member'],
		'L_FIND_USERNAME' => $lang['Find_username'],

		'U_SEARCH_USER' => append_sid("search.$phpEx?mode=searchuser"),
		'S_BUDDYLIST_ACTION' => append_sid ("buddylist.$phpEx"),
		'S_HIDDEN_FIELDS' => ''
		)
	);


//
// Okay, let's build the online buddies list
//
if (count($buddies_online) == 0) {
	$template->assign_block_vars ("switch_no_buddies_online", array ());
	}
else {
	for ($i = 0; $i < count($buddies_online); $i++) {
		$buddy_id = $buddies_online[$i]['buddy_id'];
		$buddy_name = $buddies_online[$i]['buddy_name'];
		$buddy_email = $buddies_online[$i]['buddy_email'];
		$buddy_profile = append_sid ("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $buddy_id);
		$buddy_url = '<a href="' . $buddy_profile . '">' . $buddy_name . '</a>';

		$buddy_temp_url = append_sid ("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $buddy_id);
		$buddy_pm_img = '<a href="' . $buddy_temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
		$buddy_pm = '<a href="' . $buddy_temp_url . '">' . $lang['Send_private_message'] . '</a>';

		if (!empty ($row['user_viewemail']) || ($userdata['user_level'] == ADMIN)) {
			$buddy_email_uri = ($board_config['board_email_form']) ? append_sid ("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $buddy_id) : 'mailto:' . $buddy_email;
			$buddy_email_img = '<a href="' . $buddy_email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
			$buddy_email = '<a href="' . $buddy_email_uri . '">' . $lang['Send_email'] . '</a>';
			}
		else {
			$buddy_email_img = '&nbsp;';
			$buddy_email = '&nbsp;';
			}

		$row_color = (!($i % 2)) ? $theme['td_color1'] : $theme['td_color2'];
		$row_class = (!($i % 2)) ? $theme['td_class1'] : $theme['td_class2'];

		$template->assign_block_vars ('listrow_online',
			array (
				'ROW_COLOR' => '#' . $row_color,
				'ROW_CLASS' => $row_class,
				'BUDDY_URL' => $buddy_url,
				'PM_IMG' => $buddy_pm_img,
				'PM' => $buddy_pm,
				'EMAIL_IMG' => $buddy_email_img,
				'EMAIL' => $buddy_email,

				'S_MARK_ID' => $buddy_id
				)
			);
		}
	}


//
// Okay, let's build the offline buddies list
//
if (count($buddies_offline) == 0) {
	$template->assign_block_vars ("switch_no_buddies_offline", array ());
	}
else {
	for ($i = 0; $i < count($buddies_offline); $i++) {
		$buddy_id = $buddies_offline[$i]['buddy_id'];
		$buddy_name = $buddies_offline[$i]['buddy_name'];
		$buddy_email = $buddies_offline[$i]['buddy_email'];
		$buddy_profile = append_sid ("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $buddy_id);
		$buddy_url = '<a href="' . $buddy_profile . '">' . $buddy_name . '</a>';

		$buddy_temp_url = append_sid ("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $buddy_id);
		$buddy_pm_img = '<a href="' . $buddy_temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
		$buddy_pm = '<a href="' . $buddy_temp_url . '">' . $lang['Send_private_message'] . '</a>';

		if (!empty ($row['user_viewemail']) || ($userdata['user_level'] == ADMIN)) {
			$buddy_email_uri = ($board_config['board_email_form']) ? append_sid ("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $buddy_id) : 'mailto:' . $buddy_email;
			$buddy_email_img = '<a href="' . $buddy_email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
			$buddy_email = '<a href="' . $buddy_email_uri . '">' . $lang['Send_email'] . '</a>';
			}
		else {
			$buddy_email_img = '&nbsp;';
			$buddy_email = '&nbsp;';
			}

		$row_color = (!($i % 2)) ? $theme['td_color1'] : $theme['td_color2'];
		$row_class = (!($i % 2)) ? $theme['td_class1'] : $theme['td_class2'];

		$template->assign_block_vars ('listrow_offline',
			array (
				'ROW_COLOR' => '#' . $row_color,
				'ROW_CLASS' => $row_class,
				'BUDDY_URL' => $buddy_url,
				'PM_IMG' => $buddy_pm_img,
				'PM' => $buddy_pm,
				'EMAIL_IMG' => $buddy_email_img,
				'EMAIL' => $buddy_email,

				'S_MARK_ID' => $buddy_id
				)
			);
		}
	}

$template->pparse ('body');
include ($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>
