<?php
/***************************************************************************
 *                           usercp_viewprofile.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: usercp_viewprofile.php,v 1.5 2002/03/31 00:06:34 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
	exit;
}

if ( empty($HTTP_GET_VARS[POST_USERS_URL]) || $HTTP_GET_VARS[POST_USERS_URL] == ANONYMOUS )
{
	message_die(GENERAL_MESSAGE, $lang['No_user_id_specified']);
}
$profiledata = get_userdata(intval($HTTP_GET_VARS[POST_USERS_URL]));

// Some parameters for the buddylist
//
$buddy_id = ( isset($HTTP_GET_VARS['b']) ) ? $HTTP_GET_VARS['b'] : 0;
$buddy_action = ( isset($HTTP_GET_VARS['buddy_action']) ) ? ( ($HTTP_GET_VARS['buddy_action'] == 'add') ? 'add' : ( ($HTTP_GET_VARS['buddy_action'] == 'remove') ? 'remove' : '') ) : '';

//
// Add to/remove from buddylist
//
if ( $buddy_id )
{
	$redirect = POST_USERS_URL . "=" . $profiledata['user_id'];
	$redirect .= "&mode=viewprofile";

	if( !$userdata['session_logged_in'] )
	{
		$redirect .= ( isset($buddy_id) ) ? '&b=$buddy_id' : '';
		$redirect .= ( isset($buddy_action) ) ? '&buddy_action=$buddy_action' : '';
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=profile.$phpEx&$redirect", true));
		exit;
	}

	if ( $buddy_action == 'add' )
	{
		if ( $buddy_id == $userdata['user_id'] )
		{
			message_die(GENERAL_MESSAGE, 'You cannot add yourself to your buddylist');
		}

		$sql = "SELECT * FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
		}
		if ( $row = $db->sql_fetchrow($result) )
		{
			message_die(GENERAL_MESSAGE, 'User is already in your buddylist');
		}

		$sql = "INSERT INTO " . BUDDIES_TABLE . " VALUES (" . $userdata['user_id'] . "," . $buddy_id . ");";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not add the user to your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("profile.$phpEx?$redirect") . '">')
			);
		$message = $lang['Buddy_added'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid ("profile.$phpEx?$redirect") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}

	if ( $buddy_action == 'remove' )
	{
		if ( $buddy_id == $userdata['user_id'] )
		{
			message_die(GENERAL_MESSAGE, 'You cannot remove yourself from your buddylist');
		}

		$sql = "SELECT * FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
		}
		if( !($row = $db->sql_fetchrow($result)) )
		{
			message_die(GENERAL_MESSAGE, 'User is not in your buddylist');
		}

		$sql = "DELETE FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not remove the user from your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("profile.$phpEx?$redirect") . '">')
			);
		$message = $lang['Buddy_removed'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid("profile.$phpEx?$redirect") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}
}


//Add to show member of mod
// Fist find all non hidden groups
$groups ='';
$sql = "SELECT g.group_name, g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug 
   WHERE ug.user_id = '" . $profiledata['user_id'] . "' 
      AND g.group_id = ug.group_id 
      AND g.group_single_user <> " . TRUE . " 
      AND ug.user_pending <> ".TRUE . " AND g.group_type <> '".GROUP_HIDDEN."'
   ORDER BY g.group_name";
if(!$result = $db->sql_query($sql)) 
   message_die(GENERAL_ERROR, "Error getting group information", "", __LINE__, __FILE__, $sql); 
if($group_list = $db->sql_fetchrowset($result)) 
{ 
   for($j = 0; $j < count($group_list); $j++) 
	$groups .= '<a href="' . append_sid("groupcp.$phpEx?g=".$group_list[$j]['group_id']).'">'.$group_list[$j]['group_name'].'</a>, '; 
}
// Then find hidden user groups in witch the viewing user are a member
$sql = "SELECT  g.group_name, g.group_id, count(ug.user_id = '".$userdata[user_id]."') as hits FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug 
 WHERE  g.group_id = ug.group_id 
      AND g.group_single_user <> " . TRUE . " 
      AND ug.user_pending <> ".TRUE . "
	AND g.group_type = '".GROUP_HIDDEN."'
	AND ug.user_id IN ('".$userdata[user_id]."','".$profiledata[user_id]."')
GROUP BY ug.group_id ORDER BY g.group_name ";
if(!$result = $db->sql_query($sql)) 
   message_die(GENERAL_ERROR, "Error getting group information", "", __LINE__, __FILE__, $sql); 
if($group_list = $db->sql_fetchrowset($result)) 
{ 
   for($j = 0; $j < count($group_list); $j++) 
	if ($group_list[$j]['hits']==2 || $profiledata['user_id']==$userdata['user_id'])
	$groups .= '<i><a href="' . append_sid("groupcp.$phpEx?g=".$group_list[$j]['group_id']).'">'.$group_list[$j]['group_name'].'</a></i>, '; 
}
$sql = "SELECT *
	FROM " . RANKS_TABLE . "
	ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not obtain ranks information', '', __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
	$ranksrow[] = $row;
}
$db->sql_freeresult($result);

if ( $userdata['session_logged_in'] )
{
	$sql = "SELECT buddy_id FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = " . $profiledata['user_id'];
}
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain buddies information.", '', __LINE__, __FILE__, $sql);
}

if ( $row = $db->sql_fetchrow($result) )
{
	$buddy_id = $row['buddy_id'];
}
//
// Output page header and profile_view template
//
$template->set_filenames(array(
	'body' => 'profile_view_body.tpl')
);
make_jumpbox('viewforum.'.$phpEx);

//
// Calculate the number of days this user has been a member ($memberdays)
// Then calculate their posts per day
//
$regdate = $profiledata['user_regdate'];
$memberdays = max(1, round( ( time() - $regdate ) / 86400 ));
$posts_per_day = $profiledata['user_posts'] / $memberdays;

// Get the users percentage of total posts
if ( $profiledata['user_posts'] != 0  )
{
	$total_posts = get_db_stat('postcount');
	$percentage = ( $total_posts ) ? min(100, ($profiledata['user_posts'] / $total_posts) * 100) : 0;
}
else
{
	$percentage = 0;
}

$avatar_img = '';
if ( $profiledata['user_avatar_type'] && $profiledata['user_allowavatar'] )
{
	switch( $profiledata['user_avatar_type'] )
	{
		case USER_AVATAR_UPLOAD:
			$avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_REMOTE:
			$avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_GALLERY:
			$avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
	}
}

// Default Avatar MOD - Begin
//
if ( empty($avatar_img) )
{
	$avatar_img = '<img src="'.  $images['default_avatar'] .'" alt="" border="0" />';
} 
//
// Default Avatar MOD - End

$poster_rank = '';
$rank_image = '';
if ( $profiledata['user_rank'] )
{
	for($i = 0; $i < count($ranksrow); $i++)
	{
		if ( $profiledata['user_rank'] == $ranksrow[$i]['rank_id'] && $ranksrow[$i]['rank_special'] )
		{
			$poster_rank = $ranksrow[$i]['rank_title'];
			$rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}
else
{
	for($i = 0; $i < count($ranksrow); $i++)
	{
		if ( $profiledata['user_posts'] >= $ranksrow[$i]['rank_min'] && !$ranksrow[$i]['rank_special'] )
		{
			$poster_rank = $ranksrow[$i]['rank_title'];
			$rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}

// Set buddy items
//
$buddy_img = '';
$buddy = '';

if ( $userdata['session_logged_in'] && ( $userdata['user_id'] != $profiledata['user_id'] ) )
{
	$redirect = POST_USERS_URL . "=" . $profiledata['user_id'];
	$redirect .= "&mode=viewprofile";
	$redirect .= "&b=" . $profiledata['user_id'];
	
	if ( $buddy_id )
	{
		$redirect .= "&buddy_action=remove";
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy_remove'] . '" alt="' . $lang['Remove_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Remove_buddy_list'] . '</a>';
	}
	else
	{
		$redirect .= "&buddy_action=add";
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy'] . '" alt="' . $lang['Add_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Add_buddy_list'] . '</a>';
	}
}

$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']);
$pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';

/* BEGIN LEVEL HACK
 * Note: all new variables are prefixed with level_ to
 * be sure of not overwriting other variables.
 */
 
/* Determine Level
 * 
 * A users level is determined by their total number of posts.
 * We use a nice mathmatical formula to translate a post count
 * into a level.
 * Note, a user with zero posts is level 0
 *
 */

if($profiledata['user_posts'] < 1)
{
	$level_level = 0;
}
else
{
	$level_level = floor( pow( log10( $profiledata['user_posts'] ), 3 ) ) + 1; 
}

/* Determine HP
 * 
 * HP is based on user activity.
 * Max HP is based on the users level, and will be the same for
 * all users of the same level.
 *
 * Current HP is based on the users posts per day.
 * The higher the users posts per day (ppd), the more hp
 * they will have. A user with average ppd (as set below)
 * will have 50% of their hp. As a user goes over the average
 * ppd, they will have more hp, but the gains will lessen
 * as the users ppd goes up. This makes it difficult, but not
 * impossible to have 100% hp.
 *
 * For users with under the average ppd, they will have
 * hp equal to 1/2 the percentage their ppd is of average.
 * ie- a user with 2.5 ppd, and an average ppd of 5
 * will have 25% hp.
 *
 * Users who miraculously manage to get higher than 100%
 * of their max health. (by posting far more than average)
 * will get a bonus to their max hp.
 *
 * Note that a user with a level of zero, has 0 / 0 hp.
 *
 */
 
/* 
 * This value determines what the 'average' posts per day is
 * Users above this value will have more hp, and users below
 * will have less. A user with exactly this posts per day
 * will have 50% of his max hp.
 * 
 * This variable should NOT be zero.
 * You may set this to a decimal amount (eg 5.1, 2.35)
 */
	$level_avg_ppd = 5;

/* 
 * this value sets how hard it is to achieve 100%
 * hp. The higher you set it, the harder it is to
 * get full hp.
 *
 * to judge how high to set it, a user must have
 * posts per day equal to the $level_avg_ppd plus
 * the number set below.
 * 
 * This should NOT be zero.
 */
	$level_bonus_redux = 5;


if($level_level < 1)
{
	$level_hp = "0 / 0";
	$level_hp_percent = 0;
}
else
{
	$level_max_hp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (1.5) );
	
	if($posts_per_day >= $level_avg_ppd)
	{
		$level_hp_percent = floor( (.5 + (($posts_per_day - $level_avg_ppd) / ($level_bonus_redux * 2)) ) * 100);
	}
	else
	{
		$level_hp_percent = floor( $posts_per_day / ($level_avg_ppd / 50) );
	}
	
	if($level_hp_percent > 100)
	{
		//Give the User bonus max HP if they have more than 100% hp
		$level_max_hp += floor( ($level_hp_percent - 100) * pi() );
		$level_hp_percent = 100;
	}
	else
	{
		$level_hp_percent = max(0, $level_hp_percent);
	}
	
	$level_cur_hp = floor($level_max_hp * ($level_hp_percent / 100) );
	
	//Be sure that a user has no more than max
	//and no less than zero hp.
	$level_cur_hp = max(0, $level_cur_hp);
	$level_cur_hp = min($level_max_hp, $level_cur_hp);
	
	$level_hp = $level_cur_hp . " / " . $level_max_hp;
}


/* Determine MP
 * 
 * MP is calculated by how long the user has been around
 * and how often they post.
 * 
 * Max MP is based on level, and increases with level
 * Each post a user makes costs them mp,
 * and a user regenerates mp proportional to how
 * many days they have been registered
 *
 */

//Number of days the user has been at the forums.
$level_user_days = max(1, round( ( time() - $profiledata['user_regdate'] ) / 86400 ));

//The mp cost for one post.
//Raising this value will generally decrease the current
// mp for most posters.
//This may be set to a decimal value (eg, 2, 2.1, 3.141596)
//This should NOT be set to 0
$level_post_mp_cost = 2.5;

//This determines how much mp a user regenerates per day
//Raising this value will generally increase the current
// mp for most posters.
//This may be set to a decimal value (eg, 3, 3.5, 2.71828)
//This should NOT be set to 0
$level_mp_regen_per_day = 4;

if($level_level < 1)
{
	$level_mp = "0 / 0";
	$level_mp_percent = 0;
}
else
{
	$level_max_mp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (pi()) );
	
	$level_mp_cost = $profiledata['user_posts'] * $level_post_mp_cost;
	
	$level_mp_regen = max(1, $level_user_days * $level_mp_regen_per_day);
	
	$level_cur_mp = floor($level_max_mp - $level_mp_cost + $level_mp_regen);
	$level_cur_mp = max(0, $level_cur_mp);
	$level_cur_mp = min($level_max_mp, $level_cur_mp);
	
	$level_mp = $level_cur_mp . " / " . $level_max_mp;
	
	$level_mp_percent = floor($level_cur_mp / $level_max_mp * 100);
}

 
/* Determine EXP percentage
 *
 * Experience is determined by how far the user is away
 * from the next level. This is expressed as a percentage.
 * 
 * Note, a user of level 0 has 100% experience. Making one post
 * will put them at level 1. Also, a user that is shown to have 100%
 * experience, will go up a level on their next post.
 *
 */

if($level_level == 0)
{
	$level_exp = "0 / 0";
	$level_exp_percent = 100;
}
else
{
	$level_posts_for_next = floor( pow( 10, pow( $level_level, (1/3) ) ) );
	$level_posts_for_this = floor( pow( 10, pow( ($level_level - 1), (1/3) ) ) );

	$level_exp = $profiledata['user_posts'] . " / " . $level_posts_for_next;
	$level_exp_percent = floor( ($profiledata['user_posts'] - $level_posts_for_this) / 
								max(1,($level_posts_for_next - $level_posts_for_this)) * 100);
}

/* END LEVEL HACK */

$pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';

if ( !empty($profiledata['user_viewemail']) || $userdata['user_level'] == ADMIN )
{
	$email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $profiledata['user_id']) : 'mailto:' . $profiledata['user_email'];

	$email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
	$email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
}
else
{
	$email_img = '&nbsp;';
	$email = '&nbsp;';
}

$www_img = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '&nbsp;';
$www = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww">' . $profiledata['user_website'] . '</a>' : '&nbsp;';

if ( !empty($profiledata['user_icq']) )
{
	$icq_status_img = '<a href="http://wwp.icq.com/' . $profiledata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $profiledata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
	$icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
	$icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '">' . $lang['ICQ'] . '</a>';
}
else
{
	$icq_status_img = '&nbsp;';
	$icq_img = '&nbsp;';
	$icq = '&nbsp;';
}

$aim_img = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '&nbsp;';
$aim = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '&nbsp;';

$msn_img = ( $profiledata['user_msnm'] ) ? $profiledata['user_msnm'] : '&nbsp;';
$msn = $msn_img;

$yim_img = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
$yim = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';

$temp_url = append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username']) . "&amp;showresults=posts");
$search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . $lang['Search_user_posts'] . '" title="' . $lang['Search_user_posts'] . '" border="0" /></a>';
$search = '<a href="' . $temp_url . '">' . $lang['Search_user_posts'] . '</a>';
$user_points = ( $userdata['user_level'] == ADMIN || $userdata['user_level'] == MOD ) ? '<a href="' . append_sid("pointscp.$phpEx?user_id=" . $profiledata['user_id']) . '" class="gen" title="' . sprintf($lang['Points_link_title'], $board_config['points_name']) . '">' . $profiledata['user_points'] . '</a>' : $profiledata['user_points'];

if(	$board_config['points_donate'] && $userdata['session_logged_in'] )
{
	$donate_points = '<br />' . sprintf($lang['Points_donate'], '<a href="' . append_sid("pointscp.$phpEx?mode=donate&amp;user_id=" . $profiledata['user_id']) . '" class="genmed" title="' . sprintf($lang['Points_link_title_2'], $board_config['points_name']) . '">', '</a>');
}
else
{
	$donate_points = '';
}


if ( !empty($profiledata['user_gender'])) 
{ 
           switch ($profiledata['user_gender']) 
           { 
                      case 1: $gender=$lang['Male'];break; 
                      case 2: $gender=$lang['Female'];break; 
                      default:$gender=$lang['No_gender_specify']; 
           } 
} else $gender=$lang['No_gender_specify']; 

//
// Generate page
//
   $page_title = $lang['Viewing_profile']; 
    include($phpbb_root_path . 'includes/page_header.'.$phpEx); 
    display_upload_attach_box_limits($profiledata['user_id']);

if( $userdata['user_level'] == ADMIN )
{
	$template->assign_vars(array(
		'L_USER_ADMIN' => sprintf($lang['User_admin_for'], $profiledata['username']),
		'U_ADMIN_PROFILE' => append_sid("admin/admin_users.$phpEx?mode=edit&amp;" . POST_USERS_URL . '=' . $profiledata['user_id']))
	);
	$template->assign_block_vars("switch_user_admin", array());
}


    $template->assign_vars(array( 
    'USERNAME' => $profiledata['username'], 
    'ONLINE_STATUS' => $online_status[ is_user_online($profiledata['user_id'], $profiledata['user_allow_viewonline'] ) ], 
    'L_USER_GROUP' => $lang['Usergroups'], 
    'USER_GROUPS' => ($groups) ? $groups : $lang['None'], 
	'JOINED' => create_date($lang['DATE_FORMAT'], $profiledata['user_regdate'], $board_config['board_timezone']),
    'L_LOGON' => $lang['Last_logon'], 
    'LAST_LOGON' => ($userdata['user_level'] == ADMIN || (!$board_config['hidde_last_logon'] && $profiledata['user_allow_viewonline'])) ? (($profiledata['user_lastlogon'])? create_date($board_config['default_dateformat'], $profiledata['user_lastlogon'], $board_config['board_timezone']):$lang['Never_last_logon']):$lang['Hidde_last_logon'], 
	'POSTER_RANK' => $poster_rank,
	'RANK_IMAGE' => $rank_image,
	'POSTS_PER_DAY' => $posts_per_day,
	'POSTS' => $profiledata['user_posts'],
	'PERCENTAGE' => $percentage . '%', 
	'POST_DAY_STATS' => sprintf($lang['User_post_day_stats'], $posts_per_day), 
	'POST_PERCENT_STATS' => sprintf($lang['User_post_pct_stats'], $percentage), 

	'SEARCH_IMG' => $search_img,
	'SEARCH' => $search,
	'PM_IMG' => $pm_img,
	'PM' => $pm,
	'EMAIL_IMG' => $email_img,
	'EMAIL' => $email,
	'WWW_IMG' => $www_img,
	'WWW' => $www,
	'BUDDY_IMG' => $buddy_img,
	'BUDDY' => $buddy,
	'ICQ_STATUS_IMG' => $icq_status_img,
	'ICQ_IMG' => $icq_img, 
	'ICQ' => $icq, 
	'AIM_IMG' => $aim_img,
	'AIM' => $aim,
	'MSN_IMG' => $msn_img,
	'MSN' => $msn,
	'YIM_IMG' => $yim_img,
	'YIM' => $yim,
	'L_POINTS' => $board_config['points_name'],
	'POINTS' => $user_points,
	'DONATE_POINTS' => $donate_points,

	'LOCATION' => ( $profiledata['user_from'] ) ? $profiledata['user_from'] : '&nbsp;',
	'OCCUPATION' => ( $profiledata['user_occ'] ) ? $profiledata['user_occ'] : '&nbsp;',
	'INTERESTS' => ( $profiledata['user_interests'] ) ? $profiledata['user_interests'] : '&nbsp;',
    'BIRTHDAY' => ($profiledata['user_birthday']!=999999) ? $poster_birthday=realdate($lang['DATE_FORMAT'], $profiledata['user_birthday']) : $poster_birthday=$lang['No_birthday_specify'], 
    'GENDER' => $gender, 
	'AVATAR_IMG' => $avatar_img,

	'L_VIEWING_PROFILE' => sprintf($lang['Viewing_user_profile'], $profiledata['username']), 
	'L_ABOUT_USER' => sprintf($lang['About_user'], $profiledata['username']), 
	'L_AVATAR' => $lang['Avatar'], 
	'L_POSTER_RANK' => $lang['Poster_rank'], 
	'L_JOINED' => $lang['Joined'], 
	'L_TOTAL_POSTS' => $lang['Total_posts'], 
	'L_SEARCH_USER_POSTS' => sprintf($lang['Search_user_posts'], $profiledata['username']), 
	'L_CONTACT' => $lang['Contact'],
	'L_EMAIL_ADDRESS' => $lang['Email_address'],
	'L_EMAIL' => $lang['Email'],
	'L_PM' => $lang['Private_Message'],
	'L_ICQ_NUMBER' => $lang['ICQ'],
	'L_YAHOO' => $lang['YIM'],
	'L_AIM' => $lang['AIM'],
	'L_MESSENGER' => $lang['MSNM'],
	'L_WEBSITE' => $lang['Website'],
	'L_BUDDY' => $lang['Buddy'],
	'L_LOCATION' => $lang['Location'],
	'L_OCCUPATION' => $lang['Occupation'],
	'L_INTERESTS' => $lang['Interests'],
    'L_BIRTHDAY' => $lang['Birthday'], 
    'L_GENDER' => $lang['Gender'], 
	'L_P_LEVEL' => $lang['P_level'],
	'U_SEARCH_USER' => append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username'])),

			/* BEGIN LEVEL MOD */
			"HP" => $level_hp,
			"HP_WIDTH" => $level_hp_percent,
			"HP_EMPTY" => ( 100 - $level_hp_percent ),
			"MP" => $level_mp,
			"MP_WIDTH" => $level_mp_percent,
			"MP_EMPTY" => ( 100 - $level_mp_percent ),
			"EXP" => $level_exp,
			"EXP_WIDTH" => $level_exp_percent,
			"EXP_EMPTY" => ( 100 - $level_exp_percent ),
			"LEVEL" => $level_level,
			/* END LEVEL MOD */

	'S_PROFILE_ACTION' => append_sid("profile.$phpEx"))
);

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>