<?php
/***************************************************************************
 *                                index.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: index.php,v 1.99 2002/03/31 13:58:01 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path . 'includes/auth.php'); 

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

//cookie domain mod -_-;; 
if ( $board_config['cookie_domain'] != $HTTP_HOST ) 
{ 
echo ("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0;URL=http://$board_config[cookie_domain]$board_config[script_path]\">"); 
exit; 
} 
//cookie domain end -_-;

//
// End session management
//
if( $userdata['session_logged_in'] ) 
{ 
$sql = "SELECT COUNT(post_id) as total 
FROM " . POSTS_TABLE . " 
WHERE post_time >= " . $userdata['user_lastvisit']; 
$result = $db->sql_query($sql); 
if( $result ) 
{ 
$row = $db->sql_fetchrow($result); 
$lang['Search_new'] = $lang['Search_new'] . " (" . $row['total'] . ")"; 
} 
} 

$viewcat = ( !empty($HTTP_GET_VARS[POST_CAT_URL]) ) ? $HTTP_GET_VARS[POST_CAT_URL] : -1;

// DJ-Begin, 22.3.02
$hierarchie_level = ( !empty($HTTP_GET_VARS[POST_HIERARCHIE_URL]) ) ? $HTTP_GET_VARS[POST_HIERARCHIE_URL] : 0;
$parent_forum = ( !empty($HTTP_GET_VARS[POST_PARENTFORUM_URL]) ) ? $HTTP_GET_VARS[POST_PARENTFORUM_URL] : 0;
// DJ-End, 22.3.02

if( isset($HTTP_GET_VARS['mark']) || isset($HTTP_POST_VARS['mark']) )
{
	$mark_read = ( isset($HTTP_POST_VARS['mark']) ) ? $HTTP_POST_VARS['mark'] : $HTTP_GET_VARS['mark'];
}
else
{
	$mark_read = '';
}

//
// Handle marking posts
//
if( $mark_read == 'forums' )
{
	if( $userdata['session_logged_in'] )
	{
		setcookie($board_config['cookie_name'] . '_f_all', time(), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
	}

	$template->assign_vars(array(
		"META" => '<meta http-equiv="refresh" content="3;url='  .append_sid("index.$phpEx") . '">')
	);

	$message = $lang['Forums_marked_read'] . '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . append_sid("index.$phpEx") . '">', '</a> ');

	message_die(GENERAL_MESSAGE, $message);
}
//
// End handle marking posts
//

$tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_t"]) : array();
$tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_f"]) : array();

//
// If you don't use these stats on your index you may want to consider
// removing them
//
$total_posts = get_db_stat('postcount');
$total_users = get_db_stat('usercount');
$total_topics = get_db_stat('topiccount'); // Total Topics MOD 
$newest_userdata = get_db_stat('newestuser');
$newest_user = $newest_userdata['username'];
$newest_uid = $newest_userdata['user_id'];

if( $total_posts == 0 )
{
	$l_total_post_s = $lang['Posted_articles_zero_total'];
}
else if( $total_posts == 1 )
{
	$l_total_post_s = $lang['Posted_article_total'];
}
else
{
	$l_total_post_s = $lang['Posted_articles_total'];
}

if( $total_users == 0 )
{
	$l_total_user_s = $lang['Registered_users_zero_total'];
}
else if( $total_users == 1 )
{
	$l_total_user_s = $lang['Registered_user_total'];
}
else
{
	$l_total_user_s = $lang['Registered_users_total'];
}


//
// Start page proper
//

// DJ-Begin, 21.3.02
$sql = "SELECT c.*, c.cat_id, c.cat_title, c.cat_order
	FROM " . CATEGORIES_TABLE . " c 
    WHERE c.cat_hier_level = " . $hierarchie_level . "
    AND c.parent_forum_id = " . $parent_forum . "
	ORDER BY c.cat_order";
// DJ-End

if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query categories list', '', __LINE__, __FILE__, $sql);
}

while( $category_rows[] = $db->sql_fetchrow($result) );

if( ( $total_categories = count($category_rows) ) )
{
	//
	// Define appropriate SQL
	//
	switch(SQL_LAYER)
	{
		case 'postgresql':
			$sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id 
				FROM " . FORUMS_TABLE . " f, " . POSTS_TABLE . " p, " . USERS_TABLE . " u
				WHERE p.post_id = f.forum_last_post_id 
					AND u.user_id = p.poster_id  
					UNION (
						SELECT f.*, NULL, NULL, NULL, NULL
						FROM " . FORUMS_TABLE . " f
						WHERE NOT EXISTS (
							SELECT p.post_time
							FROM " . POSTS_TABLE . " p
							WHERE p.post_id = f.forum_last_post_id  
						)
					)
					ORDER BY cat_id, forum_order";
			break;

		case 'oracle':
			$sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id 
				FROM " . FORUMS_TABLE . " f, " . POSTS_TABLE . " p, " . USERS_TABLE . " u
				WHERE p.post_id = f.forum_last_post_id(+)
					AND u.user_id = p.poster_id(+)
				ORDER BY f.cat_id, f.forum_order";
			break;

		default:
			$sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id, t.topic_title, t.topic_id
				FROM ((( " . FORUMS_TABLE . " f
				LEFT JOIN " . POSTS_TABLE . " p ON p.post_id = f.forum_last_post_id )
				LEFT JOIN " . TOPICS_TABLE . " t ON t.topic_id = p.topic_id ) 
				LEFT JOIN " . USERS_TABLE . " u ON u.user_id = p.poster_id )
				ORDER BY f.cat_id, f.forum_order";
			break;
	}
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forums information', '', __LINE__, __FILE__, $sql);
	}

	$forum_data = array();
	while( $row = $db->sql_fetchrow($result) )
	{
		$forum_data[] = $row;
	}

	if ( !($total_forums = count($forum_data)) )
	{
		message_die(GENERAL_MESSAGE, $lang['No_forums']);
	}

	// DJ-Begin, 31.05.02
	//
	// Obtain a list of topic ids which contain
	// posts made since user last visited
	//
	// first we get only the forums containing the topic
	//
	if ( $userdata['session_logged_in'] )
	{
		$sql = "SELECT t.forum_id, t.topic_id, p.post_time 
			FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p 
			WHERE p.post_id = t.topic_last_post_id 
				AND p.post_time > " . $userdata['user_lastvisit'] . "
				AND t.topic_moved_id = 0"; 

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query new topic information', '', __LINE__, __FILE__, $sql);
		}

		$new_topic_forum_ids = "";
		$new_topic_data = array();
		while( $topic_data = $db->sql_fetchrow($result) )
		{
			$new_topic_forum_ids .= ", " . $topic_data['forum_id'] . " ";
			$new_topic_data[$topic_data['forum_id']][$topic_data['topic_id']] = $topic_data['post_time'];
		}

		//
		// now we go and get all forums superior to the result above
		// but do it only if its necassary
		if(strlen($new_topic_forum_ids) > 0)
		{
			$new_topic_forum_ids = substr($new_topic_forum_ids, 1);
		
			$sql = "SELECT f.forum_id, cfp.parent_forum_id
				FROM " . FORUMS_TABLE . " f, " . CAT_REL_FORUM_PARENTS_TABLE . " cfp
				WHERE f.forum_id IN (" . $new_topic_forum_ids . ")
					AND f.cat_id = cfp.cat_id"; 

			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not query superior forums of new topic information', '', __LINE__, __FILE__, $sql);
			}

			while( $topic_data = $db->sql_fetchrow($result) )
			{
				$pfid = $topic_data['parent_forum_id'];
				$fid = $topic_data['forum_id'];
				foreach ($new_topic_data[$fid] as $key => $value) {
					$new_topic_data[$pfid][$key] = $value;
				}
				reset($new_topic_data[$fid]);
			}
		}
	}
	// DJ-End, 31.05.02

	//
	// Obtain list of moderators of each forum
	// First users, then groups ... broken into two queries
	//
	$sql = "SELECT aa.forum_id, u.user_id, u.username 
		FROM " . AUTH_ACCESS_TABLE . " aa, " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g, " . USERS_TABLE . " u
		WHERE aa.auth_mod = " . TRUE . " 
			AND g.group_single_user = 1 
			AND ug.group_id = aa.group_id 
			AND g.group_id = aa.group_id 
			AND u.user_id = ug.user_id 
		GROUP BY u.user_id, u.username, aa.forum_id 
		ORDER BY aa.forum_id, u.user_id";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum moderator information', '', __LINE__, __FILE__, $sql);
	}

	$forum_moderators = array();
	while( $row = $db->sql_fetchrow($result) )
	{
		$forum_moderators[$row['forum_id']][] = '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '">' . $row['username'] . '</a>';
	}

	$sql = "SELECT aa.forum_id, g.group_id, g.group_name 
		FROM " . AUTH_ACCESS_TABLE . " aa, " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g 
		WHERE aa.auth_mod = " . TRUE . " 
			AND g.group_single_user = 0 
			AND g.group_type <> " . GROUP_HIDDEN . "
			AND ug.group_id = aa.group_id 
			AND g.group_id = aa.group_id 
		GROUP BY g.group_id, g.group_name, aa.forum_id 
		ORDER BY aa.forum_id, g.group_id";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum moderator information', '', __LINE__, __FILE__, $sql);
	}

	while( $row = $db->sql_fetchrow($result) )
	{
		$forum_moderators[$row['forum_id']][] = '<a href="' . append_sid("groupcp.$phpEx?" . POST_GROUPS_URL . "=" . $row['group_id']) . '">' . $row['group_name'] . '</a>';
	}

	//
	// Find which forums are visible for this user
	//
	$is_auth_ary = array();
		$is_auth_ary = auth(AUTH_ALL, AUTH_LIST_ALL, $userdata, $forum_data);
    if (!isset($board_config['topic_title_index_size'])){
    	$board_config['topic_title_index_size'] = 25;  //Set this to size limit
    } 

//show dayly users mod 
$current_time=time();
$time1Hour=$current_time-3600;
$minutes = date('is', $current_time);
$hour_now = $current_time - (60*($minutes[0].$minutes[1])) - ($minutes[2].$minutes[3]); 
$dato=create_date('H', $current_time,$board_config['board_timezone']);
$timetoday = $hour_now - (3600*$dato); 
$sql = 'SELECT session_ip, MAX(session_time) as session_time FROM '.SESSIONS_TABLE.' WHERE session_user_id="'.ANONYMOUS.'" GROUP BY session_ip';
if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, "Couldn't retrieve guest user today data", "", __LINE__, __FILE__, $sql); 
while( $guest_list = $db->sql_fetchrow($result))
{ 
	if ($guest_list['session_time'] >$time1Hour) $users_lasthour++;
}
$guests_today = $db->sql_numrows($result);
$sql = 'SELECT user_id,username,user_allow_viewonline,user_level,user_lastlogon FROM ' . USERS_TABLE . ' WHERE user_lastlogon >= '.$timetoday.' AND user_lastlogon< '.($timetoday+86399).' ORDER BY username'; 
if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, "Couldn't retrieve user today data", "", __LINE__, __FILE__, $sql); 
while( $todayrow = $db->sql_fetchrow($result)) 
{ 
   $style_color = ""; 
   if( $todayrow['user_level'] == ADMIN ) 
   { 
      $todayrow['username'] = '<b>' . $todayrow['username'] . '</b>'; 
      $style_color = 'style="color:#' . $theme['fontcolor3'] . '"'; 
   } 
//THIS IS FOR WHO VISITED BOARD TODAY MOD
   else if( $todayrow['user_level'] == LESS_ADMIN ) 
   { 
      $todayrow['username'] = '<b>' . $todayrow['username'] . '</b>'; 
      $style_color = 'style="color:#' . $theme['fontcolor4'] . '"'; 
   }
   else if( $todayrow['user_level'] == MOD ) 
   { 
      $todayrow['username'] = '<b>' . $todayrow['username'] . '</b>'; 
      $style_color = 'style="color:#' . $theme['fontcolor2'] . '"'; 
   }
if ($todayrow['user_lastlogon']>=$time1Hour)
{
	$users_lasthour++;
}
	$users_today_list .= ($users_today_list&& ($todayrow['user_allow_viewonline'] || $userdata[user_level]==ADMIN))? ', ':'';
	$users_today_list.=( $todayrow['user_allow_viewonline'])?' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $todayrow['user_id']) . '"' . $style_color .'>' . $todayrow['username'] . '</a>':(($userdata[user_level]==ADMIN)?' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $todayrow['user_id']) . '"' . $style_color .'>' . $todayrow['username'] . '</a>':'');
	if (!$todayrow['user_allow_viewonline']) $logged_hidden_today++;
	else $logged_visible_today++;
} 
$total_users_today = $db->sql_numrows($result)+$guests_today;
if ( empty($total_users_today) )
{
	$users_today_list = $lang['None'];
}
$users_today_list = $lang['Registered_users'].' ' . $users_today_list;
$l_today_user_s = ($total_users_today) ? ( ( $total_users_today == 1 )? $lang['User_today_total'] : $lang['Users_today_total'] ) : $lang['Users_today_zero_total'];
$l_today_r_user_s = ($logged_visible_today) ? ( ( $logged_visible_today == 1 ) ? $lang['Reg_user_total'] : $lang['Reg_users_total'] ) : $lang['Reg_users_zero_total'];
$l_today_h_user_s = ($logged_hidden_today) ? (($logged_hidden_today == 1) ? $lang['Hidden_user_total'] : $lang['Hidden_users_total'] ) : $lang['Hidden_users_zero_total'];
$l_today_g_user_s = ($guests_today) ? (($guests_today == 1) ? $lang['Guest_user_total'] : $lang['Guest_users_total']) : $lang['Guest_users_zero_total'];
$l_today_users = sprintf($l_today_user_s, $total_users_today);
$l_today_users .= sprintf($l_today_r_user_s, $logged_visible_today); 
$l_today_users .= sprintf($l_today_h_user_s, $logged_hidden_today); 

// ⼮   **
$l_today_regtotal_s = ($logged_visible_today) ? ( ( $logged_visible_today == 1 ) ? $lang['Today_reg_total'] : $lang['Today_reg_totals'] ) : $lang['Reg_users_zero_total'];
$l_today_regtotal = sprintf($l_today_regtotal_s, $logged_visible_today); 

// added for site History mod
$sql='SELECT reg, hidden, guests FROM '.SITE_HISTORY_TABLE.' WHERE date='.$hour_now;
if ( !($result = $db->sql_query($sql)) )
{
	message_die(CRITICAL_ERROR, 'Error checking old user_hitory', '', __LINE__, __FILE__, $sql);
}
if ($old_history = $db->sql_fetchrow($result))
{
	if ($old_history['reg']!= $logged_visible_today || $old_history['hidden']!=$logged_hidden_today || $old_history['guests']!=$guests_today)
	{
		//DATA CHANGED UPDATE db
		$sql='UPDATE '.SITE_HISTORY_TABLE.' SET reg="'.$logged_visible_today.'", hidden="'.$logged_hidden_today.'", guests="'.$guests_today.'" WHERE date='.$hour_now;
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, 'Error updateing site_hitory', '', __LINE__, __FILE__, $sql);
		}
	}
} else 
{	// NO OLD DATA, MAKE NEW
	$sql = 'INSERT INTO '.SITE_HISTORY_TABLE.' (date, reg, hidden, guests)
		VALUES ('.$hour_now.', "'.$logged_visible_today.'", "'.$logged_hidden_today.'", "'.$guests_today.'")';
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(CRITICAL_ERROR, 'Error createing new site_hitory', '', __LINE__, __FILE__, $sql);
	}
}
$db->sql_freeresult($result);

$l_today_users .= sprintf($l_today_g_user_s, $guests_today); 

// Birthday Mod, Show users with birthday 
$sql = "SELECT user_id, username, user_birthday,user_level FROM " . USERS_TABLE. " WHERE user_birthday!=999999 ORDER BY username"; 
if($result = $db->sql_query($sql)) 
{ 
$birthdayrow = $db->sql_fetchrowset($result); 
if (!empty($birthdayrow)) 
{ 
	$year=create_date('Y', time(), $board_config['board_timezone']); 
	$date_today = create_date('Ymd', time(), $board_config['board_timezone']); 
	$date_forward = create_date('Ymd', time()+($board_config['birthday_check_day']*86400), $board_config['board_timezone']); 
      for($i = 0; $i < count($birthdayrow); $i++) 
      { 
	    $user_birthday=realdate("md",$birthdayrow[$i]['user_birthday']); 
      	$user_birthday2=(($year.$user_birthday<$date_today)? $year+1:$year).$user_birthday; 
		if ($user_birthday2==$date_today) 
      	{ 
			//user have birthday today 
			$user_age=$year- realdate ('Y',$birthdayrow[$i]['user_birthday']); 
			$style_color = ($birthdayrow[$i]['user_level'] == ADMIN )?'style="color:#' . $theme['fontcolor3'] . '"':(( $birthdayrow[$i]['user_level'] == MOD )?'style="color:#' . $theme['fontcolor2'] . '"':''); 
			$birthday_today_list .= ' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow[$i]['user_id']) . '"' . $style_color .'>' . $birthdayrow[$i]['username'] . ' ('.$user_age.')</a>,'; 
	      }
		else if ($user_birthday2>$date_today  && $user_birthday2<=$date_forward) 
		{ 
			// user are having birthday within the next days 
			$user_age=($year.$user_birthday<$date_today)?$year- realdate ('Y',$birthdayrow[$i]['user_birthday'])+1:$year- realdate ('Y',$birthdayrow[$i]['user_birthday']); 
			$style_color = ($birthdayrow[$i]['user_level'] == ADMIN )?'style="color:#' . $theme['fontcolor3'] . '"':(( $birthdayrow[$i]['user_level'] == MOD )?'style="color:#' . $theme['fontcolor2'] . '"':''); 
			$birthday_week_list .= ' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow[$i]['user_id']) . '"' . $style_color .'>' . $birthdayrow[$i]['username'] . '-' . $user_birthday=realdate("Md",$birthdayrow[$i]['user_birthday']) . ' ('.$user_age.')</a>,'; 
		} 
	} 
} 
}
$db->sql_freeresult($result);

	// DJ-Begin, 01.06.02
	//
	// Use different body-templates for the main and the subpages
	//
	if( $hierarchie_level == 0 )
		$index_body_fn = 'index_body.tpl';
	else
		$index_body_fn = 'index_body_sub.tpl';
	
	//
	// Start output of page
	//
	$page_title = $lang['Index'];
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	$template->set_filenames(array(
		'body' => $index_body_fn)
	);
	// DJ-End, 01.06.02

// Avatar On Index MOD
//
$avatar_img = '';
if ( $userdata['user_avatar_type'] && $userdata['user_allowavatar'] )
{
	switch( $userdata['user_avatar_type'] )
	{
		case USER_AVATAR_UPLOAD:
			$avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_REMOTE:
			$avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_GALLERY:
			$avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
	}
}
if ($avatar_img == '')
{
    $avatar_img = '<marquee style="background: url(templates/Ez_Skyblue/images/guest_avatar.jpg); background-attachment: fixed; border:#FFFFFF 0 solid; width:160; height:130;" scrollamount="1" direction="up"><pre style="margin-left: 10; color: gray; font-size: 9pt; line-height: 120%;">

   Ǵ  

ƴϴ.

   

 Ǵ  ƴϴ.... 

   

ߵ   

ϴ   

 ø.

ö  鸮

 ο  

 .
</pre></marquee>';
}
// Check For Anonymous User
if ($userdata['user_id'] != '-1')
{
    $name_link = '<a href="' . append_sid("profile.$phpEx?mode=editprofile&amp;" . $userdata['user_id']) . '">' . $userdata['username'] . '</a>';
}
else
{
    $name_link = $lang['Guest'];
}
//
// END: Avatar On Index MOD

// ChatBox Mod
    require_once($phpbb_root_path . 'chatbox_front.php');

	$template->assign_vars(array(
		'TOTAL_POSTS' => sprintf($l_total_post_s, $total_posts),
		'TOTAL_USERS' => sprintf($l_total_user_s, $total_users),
        'TOTAL_TOPICS' => sprintf($lang['total_topics'], $total_topics),  // Total Topics MOD 
		'NEWEST_USER' => sprintf($lang['Newest_user'], '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$newest_uid") . '">', $newest_user, '</a>'), 

		'FORUM_IMG' => $images['forum'],
		'FORUM_NEW_IMG' => $images['forum_new'],
		'FORUM_LOCKED_IMG' => $images['forum_locked'],
// Forum 
        'FLIST_OPEN'  =>  $lang['Flist_open'],
        'FLIST_CLOSE' =>  $lang['Flist_close'],
//last visit
        'USERS_TODAY_LIST' => $users_today_list,
        'L_USERS_LASTHOUR' =>($users_lasthour)?sprintf($lang['Users_lasthour_explain'],$users_lasthour):$lang['Users_lasthour_none_explain'],
        'L_USERS_TODAY' =>$l_today_users,
// ⼮   **
        'TODAY_REGTOTAL' =>$l_today_regtotal,

//avatar
        'L_NAME_WELCOME' => $lang['Welcome'],
        'U_NAME_LINK' => $name_link,
    	'AVATAR_IMG' => $avatar_img,

        'L_WHOSBIRTHDAY_WEEK' => sprintf((($birthday_week_list)? $lang ['Birthday_week'].$birthday_week_list:$lang ['Nobirthday_week']),$board_config['birthday_check_day']), 
        'L_WHOSBIRTHDAY_TODAY' =>($birthday_today_list&&$board_config['birthday_check_day'])? $lang ['Birthday_today'].$birthday_today_list:$lang ['Nobirthday_today'], 
        'L_BIRTHDAY_WEEKS' => sprintf($board_config['birthday_check_day']).$lang ['Birthday_weeks'],
        'L_BIRTHDAY_TODAYS' =>  $lang ['Birthday_todays'],

		'L_FORUM' => $lang['Forum'],
		'L_TOPICS' => $lang['Topics'],
		'L_REPLIES' => $lang['Replies'],
		'L_VIEWS' => $lang['Views'],
		'L_POSTS' => $lang['Posts'],
		'L_LASTPOST' => $lang['Last_Post'], 
		'L_NO_NEW_POSTS' => $lang['No_new_posts'],
		'L_NEW_POSTS' => $lang['New_posts'],
		'L_NO_NEW_POSTS_LOCKED' => $lang['No_new_posts_locked'], 
		'L_NEW_POSTS_LOCKED' => $lang['New_posts_locked'], 
		'L_ONLINE_EXPLAIN' => $lang['Online_explain'], 
        'L_TODAY_COUNTER' => $lang['Today_counter'],

		'L_MODERATOR' => $lang['Moderators'], 
		'L_FORUM_LOCKED' => $lang['Forum_is_locked'],
		'L_MARK_FORUMS_READ' => $lang['Mark_all_forums'], 

      // ChatBox Mod
        'TOTAL_CHATTERS_ONLINE' => sprintf($lang['How_Many_Chatters'], $howmanychat),
        'CHATTERS_LIST' => sprintf($lang['Who_Are_Chatting' ],$chatters),
        'L_CLICK_TO_JOIN_CHAT' => $lang['Click_to_join_chat'],
        'S_JOIN_CHAT' => append_sid("chatbox_mod/chatbox.$phpEx"),
        'CHATBOX_NAME' => $userdata['user_id'] . '_ChatBox', // To make easier to test on my PC
        'L_LOGIN_TO_JOIN_CHAT' => $lang['Login_to_join_chat'], // v1.16a fixed


		'U_MARK_READ' => append_sid("index.$phpEx?mark=forums"))
	);

	// ¾      
	$howmuchnews = "5";
	$whichforumid = "1";
	$news_time_format = "m-d";
	$trim_symbol = "";
	$do_sig = true;
	$do_edit_info = true;
	include("newsmod.php");
	// ¾    

	// DJ-Begin, 22.3.02
	// get the hierarchie if necessary
	//

	if($hierarchie_level > 0 && $total_categories > 0)
	{
	
		$cat_id = $category_rows[0]['cat_id'];

		$sql = "SELECT concat(c.cat_title, ', ', f.forum_name) AS hierarchie_title, f.forum_id, f.forum_hier_level + 1 AS hierarchie_level
			FROM " . CATEGORIES_TABLE . " c, " . CAT_REL_CAT_PARENTS_TABLE . " ccp, " . FORUMS_TABLE . " f, " . CAT_REL_FORUM_PARENTS_TABLE . " cfp
			WHERE ccp.parent_cat_id = c.cat_id
			AND ccp.cat_id = $cat_id
			AND cfp.parent_forum_id = f.forum_id
			AND cfp.cat_id = $cat_id
			AND f.cat_id = c.cat_id
			ORDER BY c.cat_hier_level, f.forum_hier_level";
		
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query hierarchie title', '', __LINE__, __FILE__, $sql);
		}
		while( $row = $db->sql_fetchrow($result) )
		{
			$template->assign_block_vars("navrow", array(
				"U_SUBINDEX" => append_sid("index.$phpEx?" . POST_HIERARCHIE_URL . "=" . $row['hierarchie_level'] . "&" . POST_PARENTFORUM_URL . "=" . $row['forum_id']),
				"L_SUBINDEX" => $row['hierarchie_title'])
			);
		}
	}
	// DJ-End, 22.3.02

	//
	// Okay, let's build the index
	//
	for($i = 0; $i < $total_categories; $i++)
	{
		$cat_id = $category_rows[$i]['cat_id'];
        $cat_on = isset($category_rows[$i]['cat_on']) ? $category_rows[$i]['cat_on'] : true;

		//
		// Should we display this category/forum set?
		//
		$display_forums = false;
		for($j = 0; $j < $total_forums; $j++)
		{
			if ( $is_auth_ary[$forum_data[$j]['forum_id']]['auth_view'] && $forum_data[$j]['cat_id'] == $cat_id )
			{
				$display_forums = true;
			}
		}

		//
		// Yes, we should, so first dump out the category
		// title, then, if appropriate the forum list
		//
		if ( $display_forums )
		{
			// DJ-Begin, 22.3.02
			$template->assign_block_vars('catrow', array(
				'CAT_ID' => $cat_id,
				'CAT_DESC' => $category_rows[$i]['cat_title'],
				'U_VIEWCAT' => append_sid("index.$phpEx?" . POST_HIERARCHIE_URL . "=$hierarchie_level&" . POST_PARENTFORUM_URL . "=$parent_forum&" . POST_CAT_URL . "=$cat_id"))
			);
			// DJ-End, 22.3.02

			if( $cat_on )
			{
				$template->assign_block_vars('catrow.switch_cat_on', array());
			}
			else
			{
				$template->assign_block_vars('catrow.switch_cat_off', array());
			}

			if ( $viewcat == $cat_id || $viewcat == -1 )
			{
				for($j = 0; $j < $total_forums; $j++)
				{
					if ( $forum_data[$j]['cat_id'] == $cat_id )
					{
						$forum_id = $forum_data[$j]['forum_id'];

						if ( $is_auth_ary[$forum_id]['auth_view'] )
						{
							if ( $forum_data[$j]['forum_status'] == FORUM_LOCKED )
							{
								$folder_image = $images['forum_locked']; 
								$folder_alt = $lang['Forum_locked'];
							}
							else
							{
								$unread_topics = false;
								if ( $userdata['session_logged_in'] )
								{
									if ( !empty($new_topic_data[$forum_id]) )
									{
										$forum_last_post_time = 0;

										while( list($check_topic_id, $check_post_time) = @each($new_topic_data[$forum_id]) )
										{
											if ( empty($tracking_topics[$check_topic_id]) )
											{
												$unread_topics = true;
												$forum_last_post_time = max($check_post_time, $forum_last_post_time);

											}
											else
											{
												if ( $tracking_topics[$check_topic_id] < $check_post_time )
												{
													$unread_topics = true;
													$forum_last_post_time = max($check_post_time, $forum_last_post_time);
												}
											}
										}

										if ( !empty($tracking_forums[$forum_id]) )
										{
											if ( $tracking_forums[$forum_id] > $forum_last_post_time )
											{
												$unread_topics = false;
											}
										}

										if ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all']) )
										{
											if ( $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all'] > $forum_last_post_time )
											{
												$unread_topics = false;
											}
										}

									}
								}

								// DJ-Begin, 22.3.02
	  						$forum_is_sub = $forum_data[$j]['forum_issub'];
								if ( $forum_is_sub == TRUE)
								{
									$folder_image = ( $unread_topics ) ? $images['forum_subforum_new'] : $images['forum_subforum'];
									$folder_alt = ( $unread_topics ) ? $lang['New_posts'] : $lang['No_new_posts'];
								}
								else
								{
									$folder_image = ( $unread_topics ) ? $images['forum_new'] : $images['forum'] ;
									$folder_alt = ( $unread_topics ) ? $lang['New_posts'] : $lang['No_new_posts'];
								}	
								// DJ-End, 22.3.02
							}

							$posts = $forum_data[$j]['forum_posts'];
							$topics = $forum_data[$j]['forum_topics'];

							if ( $forum_data[$j]['forum_last_post_id'] )
							{

								$last_post_time = create_date($board_config['default_dateformat'], $forum_data[$j]['post_time'], $board_config['board_timezone']);

								// OLD
								// $last_post = $last_post_time . '<br />';
								//
								// TODAY AT MOD
								//
								if ( $board_config['time_today'] < $forum_data[$j]['post_time'])
								{ 
									$last_post = sprintf($lang['Today_at'], create_date($board_config['default_timeformat'], $forum_data[$j]['post_time'], $board_config['board_timezone'])) . '<br />'; 
								}
								else if ( $board_config['time_yesterday'] < $forum_data[$j]['post_time'])
								{ 
									$last_post = sprintf($lang['Yesterday_at'], create_date($board_config['default_timeformat'], $forum_data[$j]['post_time'], $board_config['board_timezone'])) . '<br />'; 
								}
								else
								{ 
									$last_post = $last_post_time . '<br />'; 
								} 
         								// END MOD

								$last_post .= ( $forum_data[$j]['user_id'] == ANONYMOUS ) ? ( ($forum_data[$j]['post_username'] != '' ) ? $forum_data[$j]['post_username'] . ' ' : $lang['Guest'] . ' ' ) : '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '='  . $forum_data[$j]['user_id']) . '">' . $forum_data[$j]['username'] . '</a> ';
								
								$last_post .= '<a href="' . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $forum_data[$j]['forum_last_post_id']) . '#' . $forum_data[$j]['forum_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" border="0" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" /></a>';
							}
							else
							{
								$last_post = $lang['No_Posts'];
							}

							if ( count($forum_moderators[$forum_id]) > 0 )
							{
								$l_moderators = ( count($forum_moderators[$forum_id]) == 1 ) ? $lang['Moderator'] : $lang['Moderators'];
								$moderator_list = implode(', ', $forum_moderators[$forum_id]);
							}
							else
							{
								$l_moderators = '&nbsp;';
								$moderator_list = '&nbsp;';
							}

							$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
							$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

							// DJ-Begin, 21.3.02
							$view_forum_url = $forum_is_sub ? append_sid("index.$phpEx?" . POST_HIERARCHIE_URL . "=" . ($hierarchie_level+1) . "&" . POST_PARENTFORUM_URL . "=$forum_id") : append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id");
							$template->assign_block_vars("catrow.forumrow",	array(
	                        
								'ROW_COLOR' => '#' . $row_color,
								'ROW_CLASS' => $row_class,
								'FORUM_FOLDER_IMG' => $folder_image, 
								'FORUM_ID' => $forum_data[$j]['forum_id'],
								'FORUM_NAME' => $forum_data[$j]['forum_name'],
                             	'FORUM_NAVNAME' => $cf_title,
								'FORUM_DESC' => $forum_data[$j]['forum_desc'],
								'POSTS' => $forum_data[$j]['forum_posts'],
								'TOPICS' => $forum_data[$j]['forum_topics'],
								'LAST_POST' => $last_post,
								'MODERATORS' => $moderator_list,
					
								'LAST_TOPIC' => $is_auth_ary[$forum_data[$j]['forum_id']]['auth_read'] ? (strlen($forum_data[$j]['topic_title']) > $board_config['topic_title_index_size']) ? substr($forum_data[$j]['topic_title'], 0, ($board_config['topic_title_index_size'] - 2)) . "..." : $forum_data[$j]['topic_title'] : "",
								'U_LAST_TOPIC' => append_sid("viewtopic.$phpEx?"  . POST_TOPIC_URL . "=" . $forum_data[$j]['topic_id']), 

								'L_MODERATOR' => $l_moderators, 
								'L_FORUM_FOLDER_ALT' => $folder_alt, 

								'U_VIEWFORUM' => $view_forum_url)
							);
							// DJ-End, 21.3.02
						}
					}
				}
			}
		}
	} // for ... categories

}// if ... total_categories
else
{
	message_die(GENERAL_MESSAGE, $lang['No_forums']);
}

// ****************** Top 5 User start ***********************

$last_topic_replies_sql="SELECT topic_id,topic_title,topic_views,topic_icon  
      FROM " . TOPICS_TABLE . " where topic_id>0 and topic_type ='0' 
      ORDER BY topic_id DESC LIMIT 7"; 
$last_replies = $db->sql_query($last_topic_replies_sql); 

$top_reply_sql="SELECT topic_title,topic_views,topic_id,topic_replies 
      FROM " . TOPICS_TABLE . "  
      ORDER BY topic_replies 
      DESC,topic_views DESC LIMIT 7"; 
$top_reply = $db->sql_query($top_reply_sql); 

$topic_views_sql="SELECT topic_title,topic_views,topic_id 
      FROM " . TOPICS_TABLE . "  
      ORDER BY topic_views 
      DESC LIMIT 7"; 
$more_views = $db->sql_query($topic_views_sql); 

// preparation of billposting (top 5 users ) 
while ($line3 = mysql_fetch_array($last_replies) 
      AND $line4 = mysql_fetch_array($top_reply) 
      AND $line5 = mysql_fetch_array($more_views))
	 { 
	$topic = append_sid("viewtopic.php?t=".$line3['topic_id']); 
	$topic4 = append_sid("viewtopic.php?t=".$line4['topic_id']); 
	$topic5 = append_sid("viewtopic.php?t=".$line5['topic_id']); 
	$t2_title = substr($line3['topic_title'],0,30)."...";
	$t4_title = substr($line4['topic_title'],0,30)."...";
	$t5_title = substr($line5['topic_title'],0,30)."...";
    $topic_icon = $line3['topic_icon'];

$template->assign_block_vars('mini', array( 
            'TOPIC' => $topic, 
            'TOPIC_ICON' => $topic_icon,
            'ID' => $line3['topic_views'], 
            'ROW' => $class, 
            'NOM' => $t2_title,

            'R_NOM' => $t4_title,
            'R_ID' => $line4['topic_views'],
            'R_REPLY' => $line4['topic_replies'],
            'R_VIEWS' => $line4['topic_views'],
            'R_TOPIC' => $topic4,

            'H_NOM' => $t5_title,
            'H_ID' => $line5['topic_views'],
            'H_REPLY' => $line5['topic_replies'],
            'H_VIEWS' => $line5['topic_views'],
            'H_TOPIC' => $topic5
			
			) 
        ); 
}; 
// ****************end  top 5 users ********************** 

// ************* Last poll start *************************
// include($phpbb_root_path . 'last_poll.'.$phpEx); 
// ************* Last poll End ***************************

// ************* Rating start *************************
include('rate_index.'.$phpEx);
// ************* Rating end   *************************

// BEGIN - board msg MOD
//

if ($board_config['board_msg_enable'] == '1')
{
	$template->assign_block_vars('switch_enable_board_msg_index', array()); 
}

//
// END - board msg MOD

//
// Generate the page
//
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>