<?
/*************************************************************************** 
*                               last_pool.php 
*                            ------------------- 
*   begin                : Wednesday, May 29, 2002 
*   copyright            : (C) 2002 The phpBB BR Group 
*   email                : rs_junior@hotmail.com 
* 
*   $Id: last_pool.php,v 1.0 2002/29/05 17:30:00 JuniorZ Exp $ 
* 
* 
***************************************************************************/ 

/*************************************************************************** 
* 
*   This program is free software; you can redistribute it and/or modify 
*   it under the terms of the GNU General Public License as published by 
*   the Free Software Foundation; either version 2 of the License, or 
*   (at your option) any later version. 
* 
* 
***************************************************************************/ 

if ( !defined('IN_PHPBB') ) 
{ 
   die('Hacking attempt'); 
   exit; 
} 

// Lenght of the Poll
$poll_lenght = "50";

$sql = "SELECT * FROM " . 
   TOPICS_TABLE . " 
   WHERE topic_vote = '1' 
   ORDER BY topic_time DESC 
   LIMIT 1"; 

if (! $result1 = $db->sql_query($sql) )
{ 
   message_die(GENERAL_ERROR, "Could not obtain last pool information", '', __LINE__, __FILE__, $sql); 
} 

$last_poll_info = $db->sql_fetchrow($result1);
 
// START OF POLL 

$forum_id = $last_poll_info['forum_id'];

$sql = "SELECT * 
   FROM " . FORUMS_TABLE . " 
   WHERE forum_id = ". $forum_id ; 
if ( !($result = $db->sql_query($sql)) ) 
{ 
   message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql); 
} 

if ( !($forum_row = $db->sql_fetchrow($result)) ) 
{ 
   message_die(GENERAL_MESSAGE, 'Topic_post_not_exist'); 
} 

// 
// Start auth check 
// 
$is_auth = array(); 
$is_auth = auth(AUTH_ALL, $forum_id, $userdata, $forum_row); 


$s_auth_can .= ( ( $is_auth['auth_vote'] ) ? $lang['Rules_vote_can'] : $lang['Rules_vote_cannot'] ) . '<br />'; 

$sql = "SELECT vd.vote_id, vd.topic_id 
   FROM " . VOTE_DESC_TABLE . " as vd, " . TOPICS_TABLE . " as t 
   WHERE vd.topic_id = t.topic_id 
      AND t.forum_id=" . $forum_id . " 
   ORDER BY vd.vote_id desc limit 1"; 

if ( !($result = $db->sql_query($sql)) ) 
{ 
   message_die(GENERAL_ERROR, "Could not obtain vote data for this topic :" . $sql, '', __LINE__, __FILE__, $sql); 
} 
if ( !($row = $db->sql_fetchrow($result)) ) 
{ 
   message_die(GENERAL_MESSAGE, 'Topic_post_not_exist'); 
} 
$vote_id = $row['vote_id']; 
$topic_id = $row['topic_id']; 



   $sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vr.vote_option_id, vr.vote_option_text, vr.vote_result 
      FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr 
      WHERE vd.topic_id = $topic_id 
         AND vr.vote_id = vd.vote_id 
      ORDER BY vr.vote_option_id ASC"; 
   if ( !($result = $db->sql_query($sql)) ) 
   { 
      message_die(GENERAL_ERROR, "Could not obtain vote data for this topic", '', __LINE__, __FILE__, $sql); 
   } 

   if ( $vote_info = $db->sql_fetchrowset($result) ) 
   { 
      $db->sql_freeresult($result); 
      $vote_options = count($vote_info); 
        
      $vote_id = $vote_info[0]['vote_id']; 
      $vote_title = $vote_info[0]['vote_text']; 

      $sql = "SELECT username, user_id FROM " . VOTE_USERS_TABLE . ", " . USERS_TABLE . " WHERE vote_id = $vote_id AND vote_user_id = user_id GROUP BY username ORDER BY username"; 
      if ( !($result = $db->sql_query($sql)) ) 
      { 
         message_die(GENERAL_ERROR, "Could not obtain user vote data for this topic", '', __LINE__, __FILE__, $sql); 
      } 

      $user_voted = false; 
      $who_voted = ''; 
      $first_row = true; 

      while( $row = $db->sql_fetchrow($result) ) 
      { 
         $who_voted .= ($first_row ? '' : '') . '<OPTION value="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '">' . $row['username'];  
         if ( $row['user_id'] == $userdata['user_id'] ) 
         { 
            $user_voted = true; 
         } 
         $first_row = false; 
      } 

      $db->sql_freeresult($result); 

      if ( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) ) 
      { 
         $view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == 'viewresult' ) ? TRUE : 0; 
      } 
      else 
      { 
         $view_result = 0; 
      } 

      $poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0; 

      if ( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $forum_row['topic_status'] == TOPIC_LOCKED ) 
      { 
         $template->set_filenames(array( 
            'pollbox' => 'viewtopic_poll_result.tpl') 
         ); 

         $vote_results_sum = 0; 

         for($i = 0; $i < $vote_options; $i++) 
         { 
            $vote_results_sum += $vote_info[$i]['vote_result']; 
         } 

         $vote_graphic = 0; 
         $vote_graphic_max = count($images['voting_graphic']); 

         for($i = 0; $i < $vote_options; $i++) 
         { 
            $vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0; 
            $vote_graphic_length = round($vote_percent * $poll_lenght);

            $vote_graphic_img = $images['voting_graphic'][$vote_graphic]; 
            $vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0; 

            if ( count($orig_word) ) 
            { 
               $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']); 
            } 

            $template->assign_block_vars("poll_option", array( 
               'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'], 
               'POLL_OPTION_RESULT' => $vote_info[$i]['vote_result'], 
               'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)), 

               'POLL_OPTION_IMG' => $vote_graphic_img, 
               'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length) 
            ); 
         } 

         $template->assign_vars(array( 
            'L_TOTAL_VOTES' => $lang['Total_votes'], 
            'TOTAL_VOTES' => $vote_results_sum, 
            'L_WHO_VOTED' => $lang['Who_Voted'], 
            'WHO_VOTED' => $who_voted) 
         ); 

      } 
      else 
      { 
         $template->set_filenames(array( 
            'pollbox' => 'viewtopic_poll_ballot.tpl') 
         ); 

         for($i = 0; $i < $vote_options; $i++) 
         { 
            if ( count($orig_word) ) 
            { 
               $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']); 
            } 

            $template->assign_block_vars("poll_option", array( 
               'POLL_OPTION_ID' => $vote_info[$i]['vote_option_id'], 
               'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text']) 
            ); 
         } 

         $template->assign_vars(array( 
            'L_SUBMIT_VOTE' => $lang['Submit_vote'], 
            'L_VIEW_RESULTS' => $lang['View_results'], 

            'U_VIEW_RESULTS' => append_sid("index.$phpEx?vote=viewresult")) 
         ); 

         $s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '"><input type="hidden" name="mode" value="vote">'; 
      } 

      if ( count($orig_word) ) 
      { 
         $vote_title = preg_replace($orig_word, $replacement_word, $vote_title); 
      } 

      $sql_votes = mysql_query("SELECT * FROM ".$table_prefix."vote_desc ORDER BY vote_id"); 
      for ($v = 0; $v < mysql_num_rows($sql_votes); $v++) 
      if (mysql_result($sql_votes, $v, "vote_id") == $vote_id) $vote_nr = $v; 
      $vote_end = mysql_result($sql_votes, $vote_nr, "vote_start") + mysql_result($sql_votes, $vote_nr, "vote_length"); 
      if (time() < $vote_end) { $vote_end = sprintf($lang['VOTE_UNTIL']) . ": " . date ("ymd",$vote_end); } 
      else if (mysql_result($sql_votes, $vote_nr, "vote_length") == 0) { $vote_end = sprintf($lang['VOTE_ENDLESS']) ; } 
      else { $vote_end = sprintf($lang['VOTE_CLOSED']) ; } 

      $template->assign_vars(array( 
         'POLL_QUESTION' => $vote_title, 

         'S_HIDDEN_FIELDS' => ( !empty($s_hidden_fields) ) ? $s_hidden_fields : '', 
         'S_POLL_ACTION' => append_sid("posting.$phpEx?" . POST_TOPIC_URL . "=$topic_id"), 
         'VOTE_END' => $vote_end) 
      ); 

      $template->assign_var_from_handle('LAST_POLL_DISPLAY', 'pollbox'); 
   } 

// END OF POLL
?>
