<?
#################################################################
## Mod Title:   NEWS MOD                                       ##
## Mod Version: 2.0.4                                          ##
## Author:      Carl Dornieden < info@nexus-innovations.com >  ##
## Description: Will retrieve the newest topics from a         ##
##              specific forum and display them on the front   ##
##              page. And you can view news seperatly in       ##
##              news.php.                                      ##
##                                                             ##
## Installation Level:  Intermediate                           ##
## Installation Time:   1-5 Minutes                            ##
## Files To Edit:       Four (4)                               ##
## Included Files:      newsmod.php                            ##
##                      news.php                               ##
##                      news_body.tpl                          ##
##                      INSTALLATION.txt                       ##
#################################################################
##                                                             ##
## Copyright:                                                  ##
##                                                             ##
## - Special thanks to the author of the javascript,           ##
##   unfortunatly he is UNKNOWN!                               ##
## - If you feel like modifying my mod go ahead and do that,   ##
##   there is no real copyright on this (except the javascript)##
##                                                             ##
#################################################################

////////////////////////////
//       NEWS SETUP       //
////////////////////////////

// Style Settings of +/- Button (not really important):
   $buttonstyle = "text-align: center;" .
                  "width: 12;" .
				  "height: 10;" .
				  "font-family: Verdana;" .
				  "font-size: 7pt;" .
				  "border-style: solid;" .
				  "border-width: 1;" .
				  "cursor: hand;" .
				  "color: #003344;" .
				  "background-color: #FFFFFF;";


////////////////////////////
//         BEGIN          //
////////////////////////////
$display_mode = $HTTP_GET_VARS['display_mode'];

if(!$display_mode || $display_mode == "")
{
	include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
	
	$sql = "SELECT topic_id,topic_title,topic_time,topic_replies,topic_last_post_id,topic_views,topic_vote
		FROM ". $table_prefix  ."topics
		WHERE forum_id='$whichforumid'
		ORDER BY topic_time DESC
		LIMIT 0,$howmuchnews";
	
	if( !$news_info = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't obtain news data", "", __LINE__, __FILE__, $sql);
	}
	else
	{
		$news_info = $db->sql_fetchrowset($news_info);
		for($i = 0; $i < count($news_info); $i++)
		{
			$sql = "SELECT u.username, u.user_id, u.user_rank, u.user_sig, u.user_sig_bbcode_uid, u.user_allowsmile, p.*,  pt.post_text, pt.post_subject, pt.bbcode_uid
				FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u, " . POSTS_TEXT_TABLE . " pt
				WHERE p.topic_id = " .$news_info[$i]['topic_id'] ."
					AND p.poster_id = u.user_id
					AND p.post_id = pt.post_id
				ORDER BY p.post_time ASC
				LIMIT 0,1";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Couldn't obtain post/user information.", "", __LINE__, __FILE__, $sql);
			}
			$postrow = $db->sql_fetchrowset($result);

			//
			// Does this topic contain a voting element? (not tested in NEWS MOD yet)
			//
			if( $news_poll_allow )
			{
				if( !empty($news_info[$i]['topic_vote']) )
				{
					$sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vr.vote_option_id, vr.vote_option_text, vr.vote_result
						FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
						WHERE vd.topic_id = " .$news_info[$i]['topic_id'] ."
							AND vr.vote_id = vd.vote_id
						ORDER BY vr.vote_option_id ASC";
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, "Couldn't obtain vote data for this topic", "", __LINE__, __FILE__, $sql);
					}
					if( $vote_options = $db->sql_numrows($result) )
					{
						$vote_info = $db->sql_fetchrowset($result);
						$vote_id = $vote_info[0]['vote_id'];
						$vote_title = $vote_info[0]['vote_text'];
						
						$sql = "SELECT vote_id
							FROM " . VOTE_USERS_TABLE . "
							WHERE vote_id = $vote_id
								AND vote_user_id = " . $userdata['user_id'];
						if( !$result = $db->sql_query($sql) )
						{
							message_die(GENERAL_ERROR, "Couldn't obtain user vote data for this topic", "", __LINE__, __FILE__, $sql);
						}
						$user_voted = ( $db->sql_numrows($result) ) ? TRUE : 0;
						if( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) )
						{
							$view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == "viewresult" ) ? TRUE : 0;
						}
						else
						{
							$view_result = 0;
						}
						$poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0;
						if( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $news_info[$i]['topic_status'] == TOPIC_LOCKED )
						{
							$template->set_filenames(array(
								"news_pollbox" => "viewtopic_poll_result.tpl")
							);
							$vote_results_sum = 0;
							
							for($i = 0; $i < $vote_options; $i++)
							{
								$vote_results_sum += $vote_info[$i]['vote_result'];
							}
							$vote_graphic = 0;
							$vote_graphic_max = count($images['voting_graphic']);
							
							for($i = 0; $i < $vote_options; $i++)
							{
								$vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0;
								$vote_graphic_length = round($vote_percent * $board_config['vote_graphic_length']);
								$vote_graphic_img = $images['voting_graphic'][$vote_graphic];
								$vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;
								if( count($orig_word) )
								{
									$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
								}
								$template->assign_block_vars("poll_option", array(
									"POLL_OPTION_CAPTION" => $vote_info[$i]['vote_option_text'],
									"POLL_OPTION_RESULT" => $vote_info[$i]['vote_result'],
									"POLL_OPTION_PERCENT" => sprintf("%.1d%%", ($vote_percent * 100)),
									"POLL_OPTION_IMG" => $vote_graphic_img,
									"POLL_OPTION_IMG_WIDTH" => $vote_graphic_length)
								);
							}
							$template->assign_vars(array(
								"TOTAL_VOTES" => $vote_results_sum)
							);
						}
						else
						{
							$template->set_filenames(array(
								"news_pollbox" => "viewtopic_poll_ballot.tpl")
							);
							for($i = 0; $i < $vote_options; $i++)
							{
								if( count($orig_word) )
								{
									$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
								}
								$template->assign_block_vars("poll_option", array(
									"POLL_OPTION_ID" => $vote_info[$i]['vote_option_id'],
									"POLL_OPTION_CAPTION" => $vote_info[$i]['vote_option_text'])
								);
							}
							$template->assign_vars(array(
								"L_SUBMIT_VOTE" => $lang['Submit_vote'],
								"L_VIEW_RESULTS" => $lang['View_results'],
								"U_VIEW_RESULTS" => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;vote=viewresult"))
							);
							$s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '"><input type="hidden" name="mode" value="vote">';
						}
						if( count($orig_word) )
						{
							$vote_title = preg_replace($orig_word, $replacement_word, $vote_title);
						}
						$template->assign_vars(array(
							"POLL_QUESTION" => $vote_title,
							"S_HIDDEN_FIELDS" => $s_hidden_fields,
							"S_VOTE_ACTION" => append_sid("posting.$phpEx?" . POST_TOPIC_URL . "=$topic_id"))
						);
						$template->assign_var_from_handle("NEWS_POLL_DISPLAY", "news_pollbox");
					}
				}
			}

			//
			// Handle anon users posting with usernames
			// This is where it generates all the button data like reply, IP, edit, ICQ, AIM, WWW, etc.
			// I disabled it, but some people might like it
			//
			/*if($poster_id == ANONYMOUS && $postrow[0]['post_username'] != '')
			{
				$poster = $postrow[0]['post_username'];
				$poster_rank = $lang['Guest'];
			}
			if( $poster_id != ANONYMOUS )
			{
				$profile_img = "<a href=\"" . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id") . "\"><img src=\"" . $images['icon_profile'] . "\" alt=\"" . $lang['Read_profile'] . "\" title=\"" . $lang['Read_profile'] . "\" border=\"0\" /></a>";
				$pm_img = "<a href=\"" . append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$poster_id") . "\"><img src=\"". $images['icon_pm'] . "\" alt=\"" . $lang['Send_private_message'] . "\" title=\"" . $lang['Send_private_message'] . "\" border=\"0\" /></a>";
				if( !empty($postrow[0]['user_viewemail']) || $is_auth['auth_mod'] )
				{
					$email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL ."=" . $poster_id) : "mailto:" . $postrow[0]['user_email'];
					$email_img = "<a href=\"$email_uri\"><img src=\"" . $images['icon_email'] . "\" alt=\"" . $lang['Send_email'] . "\" title=\"" . $lang['Send_email'] . "\" border=\"0\" /></a>";
				}
				else
				{
					$email_img = "";
				}
				$www_img = ($postrow[0]['user_website']) ? "<a href=\"" . $postrow[0]['user_website'] . "\" target=\"_userwww\"><img src=\"" . $images['icon_www'] . "\" alt=\"" . $lang['Visit_website'] . "\" title=\"" . $lang['Visit_website'] . "\" border=\"0\" /></a>" : "";
				if( !empty($postrow[0]['user_icq']) )
				{
					$icq_status_img = "<a href=\"http://wwp.icq.com/" . $postrow[0]['user_icq'] . "#pager\"><img src=\"http://web.icq.com/whitepages/online?icq=" . $postrow[0]['user_icq'] . "&amp;img=5\" width=\"18\" height=\"18\" border=\"0\" /></a>";
					$icq_add_img = "<a href=\"http://wwp.icq.com/scripts/search.dll?to=" . $postrow[0]['user_icq'] . "\"><img src=\"" . $images['icon_icq'] . "\" alt=\"" . $lang['ICQ'] . "\" title=\"" . $lang['ICQ'] . "\" border=\"0\" /></a>";
				}
				else
				{
					$icq_status_img = "";
					$icq_add_img = "";
				}
				$aim_img = ( $postrow[0]['user_aim'] ) ? "<a href=\"aim:goim?screenname=" . $postrow[0]['user_aim'] . "&amp;message=Hello+Are+you+there?\"><img src=\"" . $images['icon_aim'] . "\" alt=\"" . $lang['AIM'] . "\" title=\"" . $lang['AIM'] . "\" border=\"0\" /></a>" : "";
				$msn_img = ( $postrow[0]['user_msnm'] ) ? "<a href=\"" . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id") . "\"><img src=\"" . $images['icon_msnm'] . "\" alt=\"" . $lang['MSNM'] . "\" title=\"" . $lang['MSNM'] . "\" border=\"0\" /></a>" : "";
				$yim_img = ( $postrow[0]['user_yim'] ) ? "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=" . $postrow[0]['user_yim'] . "&amp;.src=pg\"><img src=\"" . $images['icon_yim'] . "\" alt=\"" . $lang['YIM'] . "\" title=\"" . $lang['YIM'] . "\" border=\"0\" /></a>" : "";
			}
			else
			{
				$profile_img = "";
				$pm_img = "";
				$email_img = "";
				$www_img = "";
				$icq_status_img = "";
				$icq_add_img = "";
				$aim_img = "";
				$msn_img = "";
				$yim_img = "";
			}
			$quote_img = "<a href=\"" . append_sid("posting.$phpEx?mode=quote&amp;" . POST_POST_URL . "=" . $postrow[0]['post_id']) . "\"><img src=\"" . $images['icon_quote'] . "\" alt=\"" . $lang['Reply_with_quote'] ."\" title=\"" . $lang['Reply_with_quote'] ."\" border=\"0\" /></a>";
			$search_img = "<a href=\"" . append_sid("search.$phpEx?search_author=" . urlencode($poster)) . "\"><img src=\"" . $images['icon_search'] . "\" border=\"0\" /></a>";
			if( ( $userdata['user_id'] == $poster_id && $is_auth['auth_edit'] ) || $is_auth['auth_mod'] )
			{
				$edit_img = "<a href=\"" . append_sid("posting.$phpEx?mode=editpost&amp;" . POST_POST_URL . "=" . $postrow[0]['post_id']) . "\"><img src=\"" . $images['icon_edit'] . "\" alt=\"" . $lang['Edit_delete_post'] . "\" title=\"" . $lang['Edit_delete_post'] . "\" border=\"0\" /></a>";
			}
			else
			{
				$edit_img = "";
			}
			if( $is_auth['auth_mod'] )
			{
				$ip_img = "<a href=\"" . append_sid("modcp.$phpEx?mode=ip&amp;" . POST_POST_URL . "=" . $postrow[0]['post_id'] . "&amp;" . POST_TOPIC_URL . "=" . $topic_id) . "\"><img src=\"" . $images['icon_ip'] . "\" alt=\"" . $lang['View_IP'] . "\" title=\"" . $lang['View_IP'] . "\" border=\"0\" /></a>";
				$delpost_img = "<a href=\"" . append_sid("posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[0]['post_id']) . "\"><img src=\"" . $images['icon_delpost'] . "\" alt=\"" . $lang['Delete_post'] . "\" title=\"" . $lang['Delete_post'] . "\" border=\"0\" /></a>";
			}
			else
			{
				$ip_img = "";
				if( $userdata['user_id'] == $poster_id && $is_auth['auth_delete'] && $i == $total_replies - 1 )
				{
					$delpost_img = "<a href=\"" . append_sid("posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[0]['post_id']) . "\"><img src=\"" . $images['icon_delpost'] . "\" alt=\"" . $lang['Delete_post'] . "\" title=\"" . $lang['Delete_post'] . "\" border=\"0\" /></a>";
				}
				else
				{
					$delpost_img = "";
				}
			}*/

			//
			// Main part where bbcode is parsed and stuff like that regarding the post text
			//
			$message = $postrow[0]['post_text'];
			$bbcode_uid = $postrow[0]['bbcode_uid'];
			
			$user_sig = ( $postrow[0]['enable_sig'] && $postrow[0]['user_sig'] != "" && $do_sig ) ? $postrow[0]['user_sig'] : "";
			$user_sig_bbcode_uid = $postrow[0]['user_sig_bbcode_uid'];

			//
			// Define censored word matches
			//
			$orig_word = array();
			$replacement_word = array();
			obtain_word_list($orig_word, $replacement_word);
			
			$poster_id = $postrow[0]['user_id'];
			$poster = $postrow[0]['username'];

			//
			// If the board has HTML off but the post has HTML
			// on then we process it, else leave it alone
			//
			if( !$board_config['allow_html'] )
			{
				if( $user_sig != "" && $userdata['user_allowhtml'] )
				{
					$user_sig = preg_replace("#(<)([\/]?.*?)(>)#is", "&lt;\\2&gt;", $user_sig);
				}
				if( $postrow[0]['enable_html'] )
				{
					$message = preg_replace("#(<)([\/]?.*?)(>)#is", "&lt;\\2&gt;", $message);
				}
			}

			//
			// Parse message and/or sig for BBCode if reqd
			//
			if( $board_config['allow_bbcode'] )
			{
				if( $user_sig != "" && $user_sig_bbcode_uid != "" )
				{
					$user_sig = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($user_sig, $user_sig_bbcode_uid) : preg_replace("/\:[0-9a-z\:]+\]/si", "]", $user_sig);
				}
				if( $bbcode_uid != "" )
				{
					$message = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace("/\:[0-9a-z\:]+\]/si", "]", $message);
				}
			}
			if( $user_sig != "" )
			{
				$user_sig = make_clickable($user_sig);
			}
			$message = make_clickable($message);

			//
			// Replace naughty words
			//
			if( count($orig_word) )
			{
				if( $user_sig != "" )
				{
					$user_sig = preg_replace($orig_word, $replacement_word, $user_sig);
				}
				$post_subject = preg_replace($orig_word, $replacement_word, $post_subject);
				$message = preg_replace($orig_word, $replacement_word, $message);
			}

			//
			// Parse smilies
			//
			if( $board_config['allow_smilies'] )
			{
				if( $postrow[0]['user_allowsmile'] && $user_sig != "" )
				{
					$user_sig = smilies_pass($user_sig);
				}
				if( $postrow[0]['enable_smilies'] )
				{
					$message = smilies_pass($message);
				}
			}

			//
			// Replace newlines (we use this rather than nl2br because
			// till recently it wasn't XHTML compliant)
			//
			if( $user_sig != "" )
			{
				$user_sig = "<br />_________________<br />" . str_replace("\n", "\n<br />", $user_sig);
			}

			if( $do_edit_info )
			{
				//
				// Editing information
				//
				if( $postrow[0]['post_edit_count'] )
				{
					$l_edit_time_total = ( $postrow[0]['post_edit_count'] == 1 ) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];
					
					$l_edited_by = "<br /><br />" . sprintf($l_edit_time_total, $poster, create_date($board_config['default_dateformat'], $postrow[0]['post_edit_time'], $board_config['board_timezone']), $postrow[0]['post_edit_count']);
				}
				else
				{
					$l_edited_by = "";
				}
			}

			$message = str_replace("\n", "\n<br />\n", $message);

			if( $trim_symbol != "" )
			{
				$message = explode($trim_symbol, $message);
				$message = $message[0];
				$message .= " ...<br /><p align=\"right\"><a href=\"" . $phpbb_root_path . "viewtopic.php?t=" . $news_info[$i]['topic_id'] . "\">б...</a>&nbsp;</p>";
			}

			$l_comment = ($news_info[$i]['topic_replies'] == "1") ? "comment" : "ǰ";

			//
			// Assign replacement variables to template
			//
			$template->assign_vars(array(
				"FORUM_LINK" => append_sid("viewforum.$phpEx?f=$whichforumid"))
			);
         	$cut_title = substr($news_info[$i]['topic_title'],0,22)."...";
			$template->assign_block_vars("newsrow",	array(
				"TOPIC_ID" => $news_info[$i]['topic_id'],
				"TOPIC_TITLE" => $cut_title,
				"TOPIC_TIME" => create_date($news_time_format, $news_info[$i]['topic_time'], $board_config['board_timezone']),
				"TOPIC_REPLIES" => $news_info[$i]['topic_replies'],
				"TOPIC_VIEWS" => $news_info[$i]['topic_views'],
				
				"TOPIC_LINK" => append_sid("viewtopic.$phpEx?t=" . $news_info[$i]['topic_id']),
				"TOPIC_LAST_POST_LINK" => append_sid("viewtopic.$phpEx?p=" . $news_info[$i]['topic_last_post_id'] . "#" . $news_info[$i]['topic_last_post_id']),
				
				"POSTER_NAME" => "<a href=\"" . append_sid("profile.$phpEx?mode=viewprofile&amp;id=" . $postrow[0]['user_id']) . "\">$poster</a>",
				
				"POST_SUBJECT" => $post_subject,
				"MESSAGE" => $message,
				"SIGNATURE" => $user_sig,
				"EDITED_MESSAGE" => $l_edited_by,
				
				"L_COMMENT" => $l_comment)
			);
		}
	}
}
if ($display_mode == "showjs")
{

//
// This is the javascript used for the showing and hiding of news
//
?>
<!--
function __off(n)
{
	if(n && n.style)
	{
		if('none' != n.style.display)
		{
			n.style.display = 'none';
		}
	}
}

function __on(n)
{
	if(n && n.style)
	{
		if('none' == n.style.display)
		{
		n.style.display = '';
		}
	}
}

function __toggle(n)
{
	if(n && n.style)
	{
		if('none' == n.style.display)
		{
			n.style.display = '';
		}
		else
		{
			n.style.display = 'none';
		}
	}
}

//&#149;

function onoff(objName,bObjState)
{
	var sVar = ''+objName;
	var sOn  = ''+objName+'_on';
	var sOff = ''+objName+'_off';
	var sOnStyle  =  bObjState ? ' style="display:none;" ':'';
	var sOffStyle = !bObjState ? ' style="display:none;" ':'';
	var sSymStyle = ' style="<?echo $buttonstyle?>" ';
	
	if( (navigator.userAgent.indexOf("MSIE") >= 0) && document && document.body && document.body.style)
	{
		document.write( '<span '+sOnStyle+'onclick="__on('+sVar+');__off('+sOn+');__on('+sOff+');" id="'+sOn+'" title="Click here to show this post"'+sSymStyle+'>+<\/span>' +
		'<span '+sOffStyle+'onclick="__off('+sVar+');__off('+sOff+');__on('+sOn+');" id="'+sOff+'" title="Click here to hide this post"'+sSymStyle+'>-<\/span>' );
	}
}

// -->
<?}?>