<?php 
// File Edited by Joseph Rawlinson 10/06/2002 Added Super Moderator Support
define('IN_PHPBB', true); 
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$userdata = session_pagestart($user_ip, PAGE_STAFF, $session_length); 
init_userprefs($userdata); 

include('includes/page_header.'.$phpEx); 

	$template->set_filenames(array(
		'body' => 'staff_body.tpl')
	);

// ũ̹ *** 
$sql = "SELECT *
	FROM " . RANKS_TABLE . "
	ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain ranks information.", '', __LINE__, __FILE__, $sql);
}
$ranksrow = array();
while ( $row = $db->sql_fetchrow($result) )
{
	$ranksrow[] = $row;
}
$db->sql_freeresult($result);
// ũ̹ ****

$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_level !='0' ORDER BY user_level"; 

        if ( !($results = $db->sql_query($sql)) ) 
        { 
           message_die(GENERAL_ERROR, 'Could not obtain user information', '', __LINE__, __FILE__, $sql); 
        } 

while($m = $db->sql_fetchrow($results)) 
   { 
        if ( $m['user_avatar'] )
        {
                	switch( $m['user_avatar_type'] )
                	{
	                	case USER_AVATAR_UPLOAD:
		         	$avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $m['user_avatar'] . '" height="40" width="40" alt="" border="0" />' : '';
			break;
                		case USER_AVATAR_REMOTE:
			$avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $m['user_avatar'] . '" alt="" border="0" />' : '';
			break;
	                	case USER_AVATAR_GALLERY:
			$avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $m['user_avatar'] . '" alt="" border="0" />' : '';
			break;
                	}
        }

        else
        {
                             $avatar = '';
        }

                if ( $m['user_level'] == ADMIN )
                        {
                                $level = '<b style="color:#' . $theme['fontcolor3'] . '"></b>';
                        }
                elseif ( $m['user_level'] == LESS_ADMIN)
                        {
                                $level = '<b style="color:#' . $theme['fontcolor4'] . '"> </b>';
                        }
		else
                        {
                                $level = '<b style="color:#' . $theme['fontcolor2'] . '"></b>';
                        }

                if ( $m['user_icq'] )
                {
                                     $icq = '<a href="http://wwp.icq.com/scripts/contact.dll?msgto=' . $m['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
                }
                else
                {
                                     $icq = '';
                }

                if ( $m['user_email'] )
                {
                                     $mail = '<a href="mailto:' . $m['user_email'] . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
                }
                else
                {
                                     $mail = '';
                }
                if ( $m['user_yim'] )
                {
                                     $yim = '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $m['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>';
                }
                else
                {
                                     $yim = '';
                }
                if ( $m['user_aim'] )
                {
                                     $aim = '<a href="aim:goim?screenname=' . $m['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>';
                }
                else
                {
                                     $aim = '';
                }
// ũ̹ ****
$user_rank = '';
$rank_image = '';
if ( $m['user_rank'] )
{
	for($j = 0; $j < count($ranksrow); $j++)
	{
		if ( $m['user_rank'] == $ranksrow[$j]['rank_id'] && $ranksrow[$j]['rank_special'] )
		{
			$user_rank = $ranksrow[$j]['rank_title'];
			$rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}
else
{
	for($j = 0; $j < count($ranksrow); $j++)
	{
		if ( $m['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] )
		{
			$user_rank = $ranksrow[$j]['rank_title'];
			$rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}
// ũ̹ ****



		$template->assign_block_vars('staff',	array(
                        'AVATAR' => $avatar,
                        'NAME' => $m[username],
                        'LEVEL' => $level,
                        'MAIL' => $mail,
                        'PM' => '<a href="privmsg.'.$phpEx.'?mode=post&u='. $m['user_id'] .'"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>',
                        'MSN' => $m['user_msnm'],
                        'YIM' => $yim,
                        'AIM' => $aim,
                        'USER_RANK' => $user_rank,
                        'USER_RANK_IMG' => $rank_image,
                        'ICQ' => $icq)
		);
   }

                      $template->assign_vars(array( 
                        'L_AVATAR' => $lang['Avatar'], 
                        'L_USERNAME' => $lang['Username'], 
                        'L_EMAIL' => $lang['Email'],
                        'L_PM' => $lang['Private_Message'],
                        'L_MESSENGER' => $lang['MSNM'],
                        'L_YAHOO' => $lang['YIM'],
                        'L_AIM' => $lang['AIM'],
                        'L_USER_RANK' => $lang['Poster_rank'],
                        'L_ICQ_NUMBER' => $lang['ICQ'])
                      );

$template->pparse('body');

include('includes/page_tail.'.$phpEx); 
?>
