<?php
/***************************************************************************
 *								  admin_album.php
 *								-------------------
 *   begin                : Thursday, July 11, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor@zapo.net
 *
 *   $Id: admin_album.php,v 1.5.0 2002/7/21, 14:11:35 hnt Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Album']['ַ '] = $filename;
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'album_mod/album_common.' . $phpEx);

if ( !isset($HTTP_GET_VARS['id']) or !isset($HTTP_GET_VARS['action']) )
{
	//
	// Set Variables
	//
	$start = (isset($HTTP_GET_VARS['start'])) ? $HTTP_GET_VARS['start'] : 0;

	//
	// Get Category Information
	//
	$sql = "SELECT * FROM ".TABLE_ALBUM_CAT." ORDER BY cat_title";
	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Could not query Album Category information", "", __LINE__, __FILE__, $sql);
	}
	$total_cat = 0;
	$first_cat_id = 0;
	while ( $row = $db->sql_fetchrow($result) )
	{
		$catrow[] = $row;
		if ($first_cat_id == 0)
		{
			$first_cat_id = $row['cat_id'];
		}
		$total_cat++;
	}

	if ($total_cat == 0)
	{
		message_die(GENERAL_MESSAGE, ' ַ īװ ϴ');
	}

	// Set Current Category ID
	$cat_id = (isset($HTTP_POST_VARS['cat_id'])) ? $HTTP_POST_VARS['cat_id'] : $first_cat_id;
	$cat_id = (isset($HTTP_GET_VARS['cat_id'])) ? $HTTP_GET_VARS['cat_id'] : $cat_id;

	$template->set_filenames(array(
		'body' => 'admin/album_manager_body.tpl')
	);

	$template->assign_vars(array(
		'L_ALBUM_MANAGER_TITLE' => $lang['Album_Manager_Title'],
		'L_ALBUM_MANAGER_EXPLAIN' => $lang['Album_Manager_Explain'],
		'L_SELECT_CATEGORY' => $lang['Select_category'],
		'L_GO' => $lang['Go'],
		'S_ALBUM_MANAGER' => append_sid("admin_album.$phpEx"),
		) // end array
	);

	// Generate Category Selector
	for ($i = 0; $i < $total_cat; $i++)
	{
		$template->assign_block_vars('cat_select', array(
			'ID' => $catrow[$i]['cat_id'],
			'TITLE' => $catrow[$i]['cat_title'],
			'SELECTED' => ($catrow[$i]['cat_id'] == $cat_id) ? 'selected' : '',
			)
		);
	}

	// Get information all uploaded pics from database
	$sql = "SELECT * FROM " . TABLE_ALBUM . " WHERE cat_id = '".$cat_id."' ORDER BY `title`";

	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
	}


	$total_pics = 0;
	while( $row = $db->sql_fetchrow($result) )
	{
		$picrow[] = $row;
		$total_pics++;
	}

	if ($total_pics == 0)
	{
		$template->assign_vars(array(
			'L_NO_PICS' => 'Album Empty')
		);

		$template->assign_block_vars('switch_no_pics', array() );
	}
	else
	{
		for ($i = 0; $i <= $total_pics - 1; $i++)
		{
			$pic_id = $picrow[$i]['id'];
			$pic_filename = $picrow[$i]['filename'];
			$pic_title = $picrow[$i]['title'];
			$pic_time = create_date('M d Y, G:i', $picrow[$i]['timestamp'], $board_config['board_timezone']);
			$pic_user_id = $picrow[$i]['user_id'];
			if ($pic_user_id > 0)
			{
				$pic_username = $picrow[$i]['username'];
			}
			else
			{
				$pic_username = 'Guest';
			}

			$template->assign_block_vars('picrow', array(
				'U_PIC_SEE' => $phpbb_root_path . ALBUM_UPLOAD_PATH . $pic_filename,
				'U_EDIT' => append_sid("admin_album.$phpEx?action=edit&amp;id=".$pic_id),
				'U_DELETE' => append_sid("admin_album.$phpEx?action=delete&amp;id=".$pic_id),
				'U_MOVE' => append_sid("admin_album.$phpEx?action=move&amp;id=".$pic_id),
				'TITLE' => $pic_title,
				'POSTER' => $pic_username,
				'TIME' => $pic_time
				) //end array
			);
		} // end for
	}
	$template->pparse('body');

	include('./page_footer_admin.'.$phpEx);
}
else
{
	$id = $HTTP_GET_VARS['id'];

	if ($HTTP_GET_VARS['action'] == 'edit')
	{
		if (!isset($HTTP_POST_VARS['new_title']))
		{			
			$template->set_filenames(array(
				'body' => 'admin/album_edit_body.tpl')
			);

			$template->assign_vars(array(
				'L_ALBUM_MANAGER_TITLE' => $lang['Album_Manager_Title'],
				'L_ALBUM_MANAGER_EXPLAIN' => $lang['Album_Manager_Explain'],
				'L_RESET' => $lang['Reset'],
				'L_SUBMIT' => $lang['Submit'],
				'S_EDIT_ACTION' => append_sid("admin_album.$phpEx?action=edit&amp;id=".$id)
				) // end array
			);
			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);

		}
		else // process edit
		{
			$sql = "UPDATE " . TABLE_ALBUM . " SET title = '" . htmlspecialchars(trim($HTTP_POST_VARS['new_title'])) . "' WHERE id = '" . $id . "'";

			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
			}
			else
			{
				$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 3; URL=" : "Location: ";
				header($header_location . append_sid("admin_album.$phpEx", true));

				$message = "The pic title has been updated successfully<br /><br />" . sprintf($lang['Click_return_album_manager'], "<a href=\"" . append_sid("admin_album.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

				message_die(GENERAL_MESSAGE, $message);
			}
		} // END - process edit
	}
	elseif ($HTTP_GET_VARS['action'] == 'delete')
	{
		$sql = "SELECT * FROM " . TABLE_ALBUM . "  WHERE id = '" . $id . "' LIMIT 1";
		
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
		}
		$picrow = $db->sql_fetchrow($result);
		$pic_filename = $picrow['filename'];
		if ( !@unlink($phpbb_root_path . ALBUM_UPLOAD_PATH . $pic_filename) )
		{
			echo "NOTE: Cannot delete file in upload folder";
		}

		$sql = "DELETE FROM " . TABLE_ALBUM . " WHERE id = '" . $id . "'";

		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
		}

		$message = "This pic has been deleted successfully<br /><br />" . sprintf($lang['Click_return_album_manager'], "<a href=\"" . append_sid("admin_album.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);

	}
	elseif ($HTTP_GET_VARS['action'] == 'move')
	{
		if (!isset($HTTP_POST_VARS['new_cat_id']))
		{
			$template->set_filenames(array(
				'body' => 'admin/album_move_body.tpl')
			);

			$template->assign_vars(array(
				'L_ALBUM_MANAGER_TITLE' => $lang['Album_Manager_Title'],
				'L_ALBUM_MANAGER_EXPLAIN' => $lang['Album_Manager_Explain'],
				'S_MOVE_ACTION' => append_sid("admin_album.$phpEx?action=move&amp;id=".$id),
				'L_SELECT_CATEGORY' => $lang['Select_category'],
				'L_GO' => $lang['Go']
				) // end array
			);

			//
			// Get Category Information
			//
			$sql = "SELECT * FROM ".TABLE_ALBUM_CAT." ORDER BY cat_title";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Could not query Album Category information", "", __LINE__, __FILE__, $sql);
			}
			$total_cat = 0;
			while ( $row = $db->sql_fetchrow($result) )
			{
				$catrow[] = $row;
				$total_cat++;
			}

			if ($total_cat == 0)
			{
				message_die(GENERAL_MESSAGE, ' ַ īװ ϴ');
			}

			// Generate Category Selector
			for ($i = 0; $i < $total_cat; $i++)
			{
				$template->assign_block_vars('cat_select', array(
					'ID' => $catrow[$i]['cat_id'],
					'TITLE' => $catrow[$i]['cat_title'],
					)
				);
			}

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		else
		{
			$sql = "UPDATE ".TABLE_ALBUM." SET cat_id = '".$HTTP_POST_VARS['new_cat_id']."' WHERE id = '".$HTTP_GET_VARS['id']."'";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Could not update Album information", "", __LINE__, __FILE__, $sql);
			}
			
			$message = "This pic has been moved successfully<br /><br />" . sprintf($lang['Click_return_album_manager'], "<a href=\"" . append_sid("admin_album.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

			message_die(GENERAL_MESSAGE, $message);
			
		}
	}
}

?>