<?php
/***************************************************************************
 *                               album.php
 *                           -------------------
 *   begin                : Monday, July 15, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor_xp@hotmail.com
 *
 *   $Id: album.php,v 1.5.0 2002/7/20, 20:10:21 hnt Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'album_mod/album_common.'.$phpEx);

error_reporting(E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

//
// Get Album Configuration
//
$sql = "SELECT * FROM " . TABLE_ALBUM_CONFIG;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album config information", "", __LINE__, __FILE__, $sql);
}
while( $row = $db->sql_fetchrow($result) )
{
	$album_config_name = $row['config_name'];
	$album_config_value = $row['config_value'];
	$album_config[$album_config_name] = $album_config_value;
}
$pics_per_page = $album_config['rows_per_page'] * 4;

// Check View Level
$user_level = $userdata['user_level'];

if ($user_level == 2)
{
	$user_level = 0;
}

if ($album_config['view_level'] > -1)
{
	if (!$userdata['session_logged_in'])
	{
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=album.$phpEx", true));
		exit;
	}

	if ($user_level < $album_config['view_level'])
	{
		message_die(GENERAL_MESSAGE, $lang['Not_allowed_to_view_album']);
	}
}

//
// Set Variables
//
$start = (isset($HTTP_GET_VARS['start'])) ? $HTTP_GET_VARS['start'] : 0;

$sort_method = (isset($HTTP_POST_VARS['sort_method'])) ? $HTTP_POST_VARS['sort_method'] : 'title';

$sort_order = (isset($HTTP_POST_VARS['sort_order'])) ? $HTTP_POST_VARS['sort_order'] : '';

//
// Get Category Information
//
$sql = "SELECT * FROM ".TABLE_ALBUM_CAT." ORDER BY cat_title";
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album Category information", "", __LINE__, __FILE__, $sql);
}
$total_cat = 0;
$first_cat_id = 0;
while ( $row = $db->sql_fetchrow($result) )
{
	$catrow[] = $row;
	if ($first_cat_id == 0)
	{
		$first_cat_id = $row['cat_id'];
	}
	$total_cat++;
}

if ($total_cat == 0)
{
	message_die(GENERAL_MESSAGE, 'ַ īװ  ʾҽϴ..  ϼż īװ Ͻñ ٶϴ.');
}

// Set Current Category ID
$cat_id = (isset($HTTP_POST_VARS['cat_id'])) ? $HTTP_POST_VARS['cat_id'] : $first_cat_id;
$cat_id = (isset($HTTP_GET_VARS['cat_id'])) ? $HTTP_GET_VARS['cat_id'] : $cat_id;

// Get Current Category
for ($i = 0; $i < $total_cat; $i++)
{
	if ($catrow[$i]['cat_id'] == $cat_id)
	{
		$this_cat = $catrow[$i];
		break;
	}
}

if ($this_cat['cat_title'] == '')
{
	message_die(GENERAL_MESSAGE, ' ʴ īװ Դϴ.');
}

// Output the page
$page_title = $lang['Album'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'album_body.tpl')
);
make_jumpbox('viewforum.'.$phpEx);

$template->assign_vars(array(
	'L_ALBUM' => $lang['Album'],
	'U_ALBUM' => append_sid('album.'.$phpEx),
	'ALBUM_NOTE' => __ALBUM__,
	'UPLOAD_PIC_IMG' => $images['upload_pic'],
	'U_UPLOAD_PIC' => append_sid("album_upload.$phpEx?cat_id=$cat_id"),
	'L_UPLOAD_PIC' => $lang['Upload_New_Pic'],
	'L_SELECT_CATEGORY' => $lang['Select_category']
	) // end array
);

// Generate Category Selector
for ($i = 0; $i < $total_cat; $i++)
{
	$template->assign_block_vars('cat_select', array(
		'ID' => $catrow[$i]['cat_id'],
		'TITLE' => $catrow[$i]['cat_title'],
		'SELECTED' => ( $catrow[$i]['cat_id'] == $cat_id ) ? 'selected' : '',
		)
	);
}

$template->assign_vars(array(
	'L_SELECT_SORT_METHOD' => $lang['Select_sort_method'],
	'L_PIC_TITLE' => $lang['Pic_Title'],
	'L_USERNAME' => $lang['Username'],
	'L_TIME' => $lang['Time'],
	'L_ORDER' => $lang['Order'],
	'L_ASCENDING' => $lang['Sort_Ascending'],
	'L_DESCENDING' => $lang['Sort_Descending'],
	'L_GO' => $lang['Go'],
	'S_CAT_TITLE' => $this_cat['cat_title']
	)
);

// Count Pics
$sql = "SELECT id FROM ".TABLE_ALBUM." WHERE cat_id = '".$cat_id."'";;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
}
$total_pics = $db->sql_numrows($result);

// Get information of uploaded pics from database
$sql = "SELECT * FROM " . TABLE_ALBUM . " WHERE cat_id = '".$cat_id."' ORDER BY " . $sort_method . " " . $sort_order . " LIMIT " . $start . "," . $pics_per_page;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
}
while( $row = $db->sql_fetchrow($result) )
{
	$picrow[] = $row;
}

// Check Album Empty
if ($total_pics == 0)
{
	$template->assign_vars(array(
		'L_NO_PICS' => $lang['Album_empty'])
	);

	$template->assign_block_vars('switch_no_pics', array() );
}
else
{
	$pic_break = 0;

	for ($row = 0; $row < $album_config['rows_per_page']; $row++)
	{
		$template->assign_block_vars("pic_row", array());

		for ($col = 1; $col <= 4; $col++)
		{
			$i = ($row * 4) + $col - 1;

			if ( empty($picrow[$i]) )
			{
				$pic_break = 1;
				break;
			}

			$pic_id = $picrow[$i]['id'];
			$pic_title = $picrow[$i]['title'];
			$pic_title = str_cut($picrow[$i]['title'], "30", "...");
			$pic_time = create_date($board_config['default_dateformat'], $picrow[$i]['timestamp'], $board_config['board_timezone']);
			$pic_user_id = $picrow[$i]['user_id'];
			if ($pic_user_id > 0)
			{
				$pic_username = "<a href='".append_sid("profile.$phpEx?mode=viewprofile&amp;u=$pic_user_id")."'>".$picrow[$i]['username']."</a>";
			}
			else
			{
				$pic_username = $lang['Guest'];
			}
            $user_count = $user_pics[$i]['username'];

	        $img_pixel = GetImageSize(ALBUM_UPLOAD_PATH . $picrow[$i]['filename']);
	        $img_width = $img_pixel[0];
	        $img_height = $img_pixel[1];

            $img_size = filesize(ALBUM_UPLOAD_PATH . $picrow[$i]['filename']);
            if($img_size < 1024) $img_size = $img_size." B"; 
            else if ($img_size>1024 && $img_size< 1024 *1024) $img_size=sprintf("%0.1f KB",$img_size / 1024); 
            else $img_size=sprintf("%0.2f MB",$img_size / (1024*1024)); 

            $view_count = $picrow[$i]['view_time'];

           if ($userdata['session_logged_in']) {
               $del_img = '<a href="' . append_sid("album_modify.$phpEx?mode=del_con&id=".$pic_id) . '">' . '[]' . '</a>';
               $edit_img = '<a href="' . append_sid("album_modify.$phpEx?mode=edit&id=".$pic_id) . '">' . '[]' . '</a>';
           }

           /////////////////// ڸƮ  ̱
           $sql = "SELECT COUNT(id) FROM ".TABLE_ALBUM_COMMENT." WHERE id = $pic_id ORDER BY id ";
           if(!$result = $db->sql_query($sql)) 
           { 
              message_die(GENERAL_ERROR, "ڸƮ ...", "", __LINE__, __FILE__, $sql); 
           }  
           $com_count = $db->sql_numrows($result);
           $com_data = $db->sql_fetchrow($result);  
           for ($i = 0; $i < $com_count; $i++) 
           { 
            $comment_number = $com_data[$i]['id'];
           }
           /////////////////// ڸƮ  ̱ 

			$template->assign_block_vars('pic_row.pic_col', array(
                'COMMENT_COUNT' => $comment_number,
                'DEL_IMG' => $del_img,
                'EDIT_IMG' => $edit_img,
				'U_PIC_SEE' => append_sid("album_view.$phpEx?id=".$pic_id),
				'U_IMAGE' => append_sid("album_thumbnail.$phpEx?id=".$pic_id),
				'S_TITLE' => $pic_title,
				'S_USER' => $pic_username,
				'S_TIME' => $pic_time,
                'IMG_SIZE' => $img_size,
                'VIEW_COUNT' => $view_count,
                'IMG_PIXEL' => $img_width . '&nbsp;' . 'x' . '&nbsp;' . $img_height,
				'L_UPLOADED_BY' => $lang['Uploaded_by']
				) //end array
			);

		} // END for $col

		if ($pic_break == 1)
		{
			break;
		}

	} // END for $row

// Ż̹
$sql = "SELECT id FROM ".TABLE_ALBUM." WHERE id";
if(!$result = $db->sql_query($sql)) {
	message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
}
$total_img = $db->sql_numrows($result);

//  ε  5
$sql = "SELECT user_id,username, COUNT(username) as number FROM ".TABLE_ALBUM."  WHERE  username <> '' GROUP BY username  ORDER BY number DESC LIMIT 5";
if(!$result = $db->sql_query($sql)) 
{
	message_die(GENERAL_ERROR, "ٹ  Ҽ Դϴ.", "", __LINE__, __FILE__, $sql);
}
$user_pics = $db->sql_numrows($result);
$user_name = $db->sql_fetchrowset($result);
for ($i = 0; $i < $user_pics; $i++) 
{
$pic_user_url = $user_name[$i]['user_id'];
$pic_user = "<a href='".append_sid("profile.$phpEx?mode=viewprofile&amp;u=$pic_user_url")."'>".$user_name[$i]['username']."</a>";

$template->assign_block_vars('top_img_user', array(
        'USER_RANK' => $i+1,
		'USER_PIC_COUNT' => $user_name[$i]['number'],			
		'USER_NAME'   => $pic_user)
	);
}
//  ε  5 

// α ȸ ̹  5
$sql = "SELECT id,title,view_time FROM ".TABLE_ALBUM." WHERE id ORDER BY view_time DESC LIMIT 5";
if(!$result = $db->sql_query($sql)) 
{
	message_die(GENERAL_ERROR, "ٹ  Ҽ Դϴ.", "", __LINE__, __FILE__, $sql);
}
$pic_views = $db->sql_numrows($result);
$view_data = $db->sql_fetchrowset($result);

for ($i = 0; $i < $pic_views; $i++) 
{
$pic_title_id = $view_data[$i]['id'];
$template->assign_block_vars('top_img_views', array(  
        'PIC_RANK' => $i+1,
		'PIC_VIEW_COUNT' => $view_data[$i]['view_time'],			
		'PIC_TITLE'   => "<a href='".append_sid("album_view.$phpEx?id=$pic_title_id")."'>".$view_data[$i]['title']."</a>")
	);
}       
// α ȸ ̹  5 

	$template->assign_vars(array(
        'TOTAL_IMG' =>  ' : '.$total_img.'',
        'TOTAL_PICS' => '('.$total_pics.')',
		'PAGINATION' => generate_pagination(append_sid("album.$phpEx?cat_id=$cat_id"), $total_pics, $pics_per_page, $start),
		'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $pics_per_page ) + 1 ), ceil( $total_pics / $pics_per_page )),
		) //end array
	);
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>