<?php 
/*************************************************************************** 
*                            card.php 
*             php Script needed for Yellow card mod 
*
*		giving the rigth POST actions, this file can:
*		ban, unban and warn postes 
*		or repport a post to the forums moderators 
*
*                       ------------------- 
*   begin                : Feb 05, 2002 
*   email                : ncr@db9.dk 
*      ver.1.2.8
* 
*   History:
*	ver 0.9.0. - initial beta for RC-2
*	ver 1.0.0. - initial release for RC-2
*	ver 1.2.0. - initial release for phpBB2 ver 2.0.0.
*	ver 1.2.4. - history started, major rechange on how this file works, now uses POST action, for improved security
*	ver 1.2.5. - fixed that post report was send out evry time, regardless of the admin settings
*	ver 1.2.6. - allow admin to warn, ban outside a forum (e.g. in viewprofile/memberlist)
*	ver 1.2.7. - fixed that after ver 1.2.4. users was not banned when reatched the warn limit
*	ver 1.2.8. - fixed that the first post report was not sendt out
*
* 
***************************************************************************/ 

/*************************************************************************** 
* 
*   This program is free software; you can redistribute it and/or modify 
*   it under the terms of the GNU General Public License as published by 
*   the Free Software Foundation; either version 2 of the License, or 
*   (at your option) any later version. 
* 
***************************************************************************/ 
define('IN_PHPBB', true); 
// 
// Load default header 
// 
$phpbb_root_path = "./"; 
include($phpbb_root_path . 'extension.inc'); 
include($phpbb_root_path . 'common.'.$phpEx); 

// Find what we are to do
$mode = ( isset($HTTP_POST_VARS['rapport_x'] )) ? 'rapport' : 
		((isset($HTTP_POST_VARS['rapport_reset_x'] )) ? 'rapport_reset' : 
			((isset($HTTP_POST_VARS['ban_x'] )) ? 'ban' : 
				((isset($HTTP_POST_VARS['unban_x'] )) ? 'unban' : 
					((isset($HTTP_POST_VARS['warn_x'] )) ? 'warn' : ''
					)

				)
			)
		);
$post_id = ( isset($HTTP_POST_VARS['post_id']) ) ? $HTTP_POST_VARS['post_id'] : '';
$poster_id = ( isset($HTTP_POST_VARS['poster_id']) ) ? $HTTP_POST_VARS['poster_id'] : '';

// check that we have all what is needed to know
if (empty($post_id))
	message_die(GENERAL_ERROR, "No post specified", "", __LINE__, __FILE__,'post_id='.$post_id.'"'); 
if (empty($mode))
	message_die(GENERAL_ERROR, "No action specified", "", __LINE__, __FILE__,'mode="'.$mode.'"'); 
if (empty($poster_id))
	message_die(GENERAL_ERROR, "No poster specified", "", __LINE__, __FILE__,'poster_id="'.$poster_id.'"'); 

$sql = 'SELECT DISTINCT forum_id, post_bluecard FROM ' . POSTS_TABLE . ' WHERE post_id = "'.$post_id.'"'; 
if( !$result = $db->sql_query($sql) ) 
      message_die(GENERAL_ERROR, "Couldn't obtain forums information.", "", __LINE__, __FILE__, $sql); 
$result = $db->sql_fetchrow($result);
$forum_id=$result['forum_id'];
$blue_card=$result['post_bluecard'];

$userdata = session_pagestart($user_ip, PAGE_CARD);
init_userprefs($userdata);

//
// Start auth check
//
$is_auth = array(); 
$is_auth = auth(AUTH_ALL, $forum_id, $userdata);

if ($mode=="rapport_reset") 
{ 
	if (! $is_auth['auth_mod'])
		message_die(GENERAL_ERROR, $lang['Not_Authorised']);

 	$sql = 'UPDATE ' . POSTS_TABLE . ' SET post_bluecard="0" WHERE post_id="'.$post_id.'"'; 
		if( !$result = $db->sql_query($sql) ) 
	      	message_die(GENERAL_ERROR, "Couldn't update blue card information"); 
	message_die(GENERAL_MESSAGE, $lang['Post_reset']."<br /><br />". sprintf($lang['Click_return_viewtopic'], "<a href=\"" . append_sid("viewtopic.$phpEx?p=".$post_id."#".$post_id). "\">", "</a>")); 

} else 
if ($mode=="rapport") 
{ 
	if (!$is_auth['auth_bluecard']) message_die(GENERAL_ERROR, $lang['Not_Authorised']); 
	$blue_card++;
	$sql = 'UPDATE ' . POSTS_TABLE . ' SET post_bluecard="'.$blue_card.'" WHERE post_id="'.$post_id.'"'; 
	if( !$result = $db->sql_query($sql) ) 
	     	message_die(GENERAL_ERROR, "Couldn't update blue card information"); 
	// 
      // Obtain list of moderators of this forum 
     	$sql = "SELECT g.group_name, u.username, u.user_email, u.user_lang 
     		FROM " . AUTH_ACCESS_TABLE . " aa,  " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g, " . USERS_TABLE . " u 
	      WHERE aa.forum_id = $forum_id   AND aa.auth_mod = " . TRUE . " 
     		AND ug.group_id = aa.group_id   AND g.group_id = aa.group_id AND u.user_id = ug.user_id"; 
      if( !$result_mods = $db->sql_query($sql) ) 
		message_die(GENERAL_ERROR, "Couldn't obtain moderators information.", "", __LINE__, __FILE__, $sql); 
	$total_mods = $db->sql_numrows($result_mods); 
	$i=0; 
      if (!$total_mods) 
     		message_die(GENERAL_MESSAGE, $lang['No_moderators']."<br /><br />". sprintf($lang['Click_return_viewtopic'], "<a href=\"" . append_sid("viewtopic.$phpEx?p=".$p."#".$p). "\">", "</a>")); 
      if ((	$blue_card>=$board_config['bluecard_limit_2'] && (!(($blue_card-$board_config['bluecard_limit_2'])%$board_config['bluecard_limit']))) || $blue_card==$board_config['bluecard_limit_2']) 
	{ 
		$mods_rowset = $db->sql_fetchrowset($result_mods); 
	      include($phpbb_root_path . 'includes/emailer.'.$phpEx); 
	      while ($i<$total_mods) 
      	{ 
			$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path'])). '/viewtopic.'.$phpEx;
			$server_name = trim($board_config['server_name']);
			$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
			$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';
            	$emailer = new emailer($board_config['smtp_delivery']); 
	            $emailer->email_address($mods_rowset[$i]['user_email']); 
      	      $email_headers = "To: ".$mods_rowset[$i]['username']." <".$mods_rowset[$i]['user_email']. ">\r\n"; 
	            $email_headers .= "From: ".$board_config['sitename']." <".$board_config['board_email'].">\r\n"; 
      	      $email_headers .= "Return-Path: " . (($userdata['user_email']&&$userdata['user_viewemail'])? $userdata['user_email']."\r\n":"\r\n"); 
            	$email_headers .= "X-AntiAbuse: Board servername - " . $server_name . "\r\n"; 
	            $email_headers .= "X-AntiAbuse: User_id - " . $userdata['user_id'] . "\r\n"; 
      	      $email_headers .= "X-AntiAbuse: Username - " . $userdata['username'] . "\r\n"; 
            	$email_headers .= "X-AntiAbuse: User IP - " . decode_ip($user_ip) . "\r\n"; 
	            $emailer->use_template("repport_post",(file_exists($phpbb_root_path . "language/lang_" . $mods_rowset[$i]['user_lang'] . "/email/repport_post.tpl"))?$mods_rowset[$i]['user_lang'] : ""); 
      	      $i++;
            	$emailer->set_subject($lang['Post_repport']); 
	            $emailer->extra_headers($email_headers); 
      	      $emailer->assign_vars(array( 
			   'POST_URL' => $server_protocol . $server_name . $server_port . $script_name . '?' . POST_POST_URL . "=$post_id#$post_id",
	               'USER' => '"'.$userdata['username'].'"', 
            	   'NUMBER_OF_REPPORTS' => $blue_card, 
	               'SITENAME' => $board_config['sitename'], 
      	         'BOARD_EMAIL' => $board_config['board_email'])); 
            	$emailer->send(); 
	            $emailer->reset(); 
		} 
	} 
	message_die(GENERAL_MESSAGE, (($total_mods)?sprintf($lang['Post_repported'],$total_mods):$lang['Post_repported_1'])."<br /><br />". sprintf($lang['Click_return_viewtopic'], "<a href=\"" . append_sid("viewtopic.$phpEx?p=".$post_id."#".$post_id). "\">", "</a>")); 
} else

if ( $mode == 'unban' )
{
      $no_error_ban=FALSE; 
	if (! $is_auth['auth_greencard'] && $userdata['user_level'] != ADMIN  )
		message_die(GENERAL_ERROR, $lang['Not_Authorised']); 
	// look up the user 
	$sql = 'SELECT user_active FROM ' . USERS_TABLE . ' WHERE user_id="'.$poster_id.'"'; 
	if( !$result = $db->sql_query($sql) ) 
      	message_die(GENERAL_ERROR, "Couldn't obtain judge information.", "", __LINE__, __FILE__, $sql); 
	$the_user = $db->sql_fetchrow($result); 
      // remove the user from ban list 
      $sql = 'DELETE FROM ' . BANLIST_TABLE . ' WHERE ban_userid="'.$poster_id.'"'; 
      if (! $result = $db->sql_query($sql) ) 
            message_die(GENERAL_ERROR, "Couldn't remove ban_userid info into database", "", __LINE__, __FILE__, $sql); 
      // update the user table with new status 
      $sql = 'UPDATE ' . USERS_TABLE . ' SET user_active="1" WHERE user_id="'.$poster_id.'"';
      if(! $result = $db->sql_query($sql) ) 
		message_die(GENERAL_ERROR, "Couldn't update user status information", "", __LINE__, __FILE__, $sql);
	$message = $lang['Ban_update_green']; 
      $e_temp="ban_reactivated"; 
      $e_subj=$lang['Ban_reactivate']; 
      $no_error_ban=true; 
} else

if ( $mode == 'ban' )
{
      $no_error_ban=FALSE; 
	if (! $is_auth['auth_ban'] && $userdata['user_level'] != ADMIN )
		message_die(GENERAL_ERROR, $lang['Not_Authorised']); 
	// look up the user 
	$sql = 'SELECT user_active, user_level FROM ' . USERS_TABLE . ' WHERE user_id="'.$poster_id.'"'; 
	if( !$result = $db->sql_query($sql) ) 
      	message_die(GENERAL_ERROR, "Couldn't obtain judge information.", "", __LINE__, __FILE__, $sql); 
	$the_user = $db->sql_fetchrow($result); 
	if ($the_user['user_level']== ADMIN )
		message_die(GENERAL_ERROR, $lang['Ban_no_admin']); 

	// insert the user in the ban list 
      $sql = 'SELECT ban_userid FROM ' . BANLIST_TABLE . ' WHERE ban_userid="'.$poster_id.'"'; 
      if( $result = $db->sql_query($sql) ) 
      { 
		if (!$db->sql_fetchrowset($result)) 
		{ 
			// insert the user in the ban list 
			$sql = "INSERT INTO " . BANLIST_TABLE . " (ban_userid) VALUES ($poster_id)"; 
			if (!$result = $db->sql_query($sql) ) 
				message_die(GENERAL_ERROR, "Couldn't insert ban_userid info into database", "", __LINE__, __FILE__, $sql); 
			// update the user table with new status 
 			$sql = 'UPDATE ' . USERS_TABLE . ' SET user_active="0" WHERE user_id="'.$poster_id.'"'; 
			if(! $result = $db->sql_query($sql) ) 
				message_die(GENERAL_ERROR, "Couldn't update user status information", "", __LINE__, __FILE__, $sql);
			$no_error_ban=true; 
			$message = $lang['Ban_update_red'] . "<br /><br />"; 
			$e_temp="ban_block"; 
			$e_subj=$lang['Ban_blocked']; 
		} else 
      	{ 
      		$no_error_ban = true; 
			$message = $lang['user_already_banned']; 
      	} 
	} else message_die(GENERAL_ERROR, "Couldn't obtain banlist information", "", __LINE__, __FILE__, $sql); 
} else

if ( $mode == 'warn' )
{
      $no_error_ban=FALSE; 
	if (! $is_auth['auth_ban'] && $userdata['user_level'] != ADMIN )
		message_die(GENERAL_ERROR, $lang['Not_Authorised']); 
	// look up the user 
	$sql = 'SELECT user_active, user_level FROM ' . USERS_TABLE . ' WHERE user_id="'.$poster_id.'"'; 
	if( !$result = $db->sql_query($sql) ) 
      	message_die(GENERAL_ERROR, "Couldn't obtain judge information.", "", __LINE__, __FILE__, $sql); 
	$the_user = $db->sql_fetchrow($result); 
	if ($the_user['user_level']== ADMIN )
		message_die(GENERAL_ERROR, $lang['Ban_no_admin']); 

      // se if the user are to be banned, if so do it ... 
      if ($the_user['user_active']>=$board_config['max_user_bancard']) 
      { 
	$sql = 'SELECT ban_userid FROM ' . BANLIST_TABLE . ' WHERE ban_userid="'.$poster_id.'"'; 
	if( $result = $db->sql_query($sql) ) 
	{ 
		if (!$db->sql_fetchrowset($result)) 
		{ 
			// insert the user in the ban list 
			$sql = "INSERT INTO " . BANLIST_TABLE . " (ban_userid) VALUES ($poster_id)"; 
			if (!$result = $db->sql_query($sql) ) 
				message_die(GENERAL_ERROR, "Couldn't insert ban_userid info into database", "", __LINE__, __FILE__, $sql); 
			// update the user table with new status 
 			$sql = 'UPDATE ' . USERS_TABLE . ' SET user_active="0" WHERE user_id="'.$poster_id.'"'; 
			if(! $result = $db->sql_query($sql) ) 
				message_die(GENERAL_ERROR, "Couldn't update user status information", "", __LINE__, __FILE__, $sql);
			$no_error_ban=true; 
			$message = $lang['Ban_update_red'] . "<br /><br />"; 
			$e_temp="ban_block"; 
			$e_subj=$lang['Ban_blocked']; 
            } else 
            { 	
			$no_error_ban = true; 
			$message = $lang['user_already_banned']; 
            } 
         } else message_die(GENERAL_ERROR, "Couldn't obtain banlist information", "", __LINE__, __FILE__, $sql); 
	} else
	{
		// the user shall not be baned this time, update the counter
		$sql = 'UPDATE ' . USERS_TABLE . ' SET user_active=user_active+1 WHERE user_id="'.$poster_id.'"'; 
		if(! $result = $db->sql_query($sql) ) 
			message_die(GENERAL_ERROR, "Couldn't update user status information", "", __LINE__, __FILE__, $sql);

	      $message = sprintf($lang['Ban_update_yellow'],$the_user['user_active'],$board_config['max_user_bancard']);
		$no_error_ban=true; 
	      $e_temp="ban_warning"; 
	      $e_subj=$lang['Ban_warning']; 
	}
}

if ($no_error_ban) 
{ 
	$sql = 'SELECT username, user_active, user_email, user_lang FROM ' . USERS_TABLE . ' WHERE user_id="'.$poster_id.'"'; 
      if( !$result = $db->sql_query($sql) ) 
		message_die(GENERAL_ERROR, "Couldn't find the users personal information", "", __LINE__, __FILE__, $sql); 
	$warning_data=$db->sql_fetchrow($result); 
      if (!empty($warning_data['user_email'])) 
      { 
		include($phpbb_root_path . 'includes/emailer.'.$phpEx); 
		$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path'])). '/viewtopic.'.$phpEx;
		$server_name = trim($board_config['server_name']);
		$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
		$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';
            $emailer = new emailer($board_config['smtp_delivery']);
            $email_headers = "To:".$warning_data['username']." <".$warning_data['user_email']. ">\r\nFrom: " . (($userdata['user_email']&&$userdata['user_viewemail'])? $userdata['username']." <".$userdata['user_email'].">":$board_config['sitename']) . "\r\n"; 
	      if ($e_subj) $emailer->use_template($e_temp, stripslashes($warning_data['user_lang'])); 
            $emailer->email_address($warning_data['user_email']); 
            $emailer->set_subject($e_subj); 
            $emailer->extra_headers($email_headers); 
            $emailer->assign_vars(array( 
            	'SITENAME' => $board_config['sitename'], 
	            'WARNINGS' => $warning_data['user_active']-1, 
      	      'TOTAL_WARN' => $board_config['max_user_bancard'], 
			'POST_URL' => $server_protocol . $server_name . $server_port . $script_name . '?' . POST_POST_URL . "=$post_id#$post_id",
      	      'EMAIL_SIG' => str_replace("<br />", "\n", "-- \n" . $board_config['board_email_sig']), 
            	'WARNER' => $userdata['username'], 
	            'WARNED_POSTER' => $warning_data['username'])
		); 
            if ($e_subj)
		{
			$emailer->send(); 
		}
            $emailer->reset(); 
	}
	else
	{
	 	$message .= "<br/><br/>".$lang['user_no_email']; 
	}
} 
else 
{
	$message = 'Error card.php file'; 
}

$message .= ( $post_id != '-1' ) ? "<br /><br />". sprintf($lang['Click_return_viewtopic'], "<a href=\"" . append_sid("viewtopic.$phpEx?p=".$post_id."#".$post_id). "\">", "</a>"):"<br /><br />". sprintf($lang['Click_return_index'], "<a href=\"" . append_sid("index.".$phpEx). "\">", "</a>"); 
message_die(GENERAL_MESSAGE, $message); 
include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 

?>