<?php
/***************************************************************************
 *                               favorites.php
 *                            -------------------
 *   begin                : Monday, Mar 15, 2002
 *   copyright            : (C) 2002 CNBoxES WorkShop
 *   email                : webmaster@cnboxes.com
 *
 *   $Id: favorites.php,v 1.000 2002/04/15 13:59:25 the_systech Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

if (!empty($board_config['favorite_disable']))
{
	message_die(GENERAL_MESSAGE, 'Collection_Disabled');
}

if (isset($HTTP_GET_VARS['openfolder']) || isset($HTTP_POST_VARS['openfolder']))
{
	$open = intval((isset($HTTP_POST_VARS['openfolder'])) ? $HTTP_POST_VARS['openfolder'] : $HTTP_GET_VARS['openfolder']);
}
else
{
	$open = 0;
}

if (isset($HTTP_GET_VARS['topic_id']))
{
	$topic_id = intval($HTTP_GET_VARS['topic_id']);
}

$confirm = ( $HTTP_POST_VARS['confirm'] ) ? TRUE : 0;

//
// Check if user did or did not confirm
// If they did not, forward them to the last page they were on
//
if ( isset($HTTP_POST_VARS['cancel']) )
{
	$redirect = "index.$phpEx";
	
	$header_location = ( @preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')) ) ? 'Refresh: 0; URL=' : 'Location: ';
	header($header_location . append_sid($redirect, true));
}

$D_create = ( isset($HTTP_POST_VARS['D_create_folder']) ) ? TRUE : FALSE;
$D_del_all = ( isset($HTTP_POST_VARS['D_del_all']) ) ? TRUE : FALSE;
$F_del_all = ( isset($HTTP_POST_VARS['F_del_all']) ) ? TRUE : FALSE;
$D_del_sel = ( isset($HTTP_POST_VARS['D_del_select']) ) ? TRUE : FALSE;
$F_del_sel = ( isset($HTTP_POST_VARS['F_del_select']) ) ? TRUE : FALSE;
$F_move = (isset($HTTP_POST_VARS['F_move']) ) ? TRUE : FALSE;

if ( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
}
else
{
	if ($D_create)
	{
		$mode="create";
	}
	else if ($D_del_all)
	{
		$mode="D_del_all";
	}
	else if ($D_del_sel)
	{
		$mode="D_del_sel";
	}
	else if ($F_del_all)
	{
		$mode="F_del_all";
	}
	else if ($F_del_sel)
	{
		$mode="F_del_sel";
	}
	else if ($F_move)
	{
		$mode="move";
	}
	else
	{
		$mode="";
	}
}

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

if ( !$userdata['session_logged_in'] )
{
	switch ($mode)
	{
		case 'add':
			$redirect_page="login.$phpEx?redirect=favorites.$phpEx&mode=add&topic_id=".$topic_id;
			break;
		default:
			$redirect_page="login.$phpEx?redirect=favorites.$phpEx";
			break;
	}

	$header_location = ( @preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')) ) ? 'Refresh: 0; URL=' : 'Location: ';
	header($header_location . append_sid($redirect_page, true));
}

switch ($mode)
{
	case 'create':
		$page_title = $lang['Create_Folder'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		$template->assign_vars(array(
			'S_FAVORITE_ACTION' => append_sid("favorites.$phpEx"),
			'U_VIEW_FRVORITE' => append_sid("favorites.$phpEx"),
			'FRVORITE_NAME' => $lang['Favorite_Box'],
			'L_CREATE_FOLDER' => $lang['Create_Folder'],
			'L_ABOUT_CREATE_FOLDER' => $lang['About_Create_Folder'])
		);
		$template->set_filenames(array(

			"body" => "favorites_create_folder.tpl")
		);
		$template->pparse('body');
		break;
	case 's_Create':
		$create_time = time();
		$sql= "INSERT INTO " . FAVORITE_FOLDER_TABLE . " (folder_name,owner_id,collections,create_time) VALUES('" . str_replace("\'", "''", $folder_name) . "'," . $userdata['user_id'] . ",0," . $create_time . ")";
		if (!$db->sql_query($sql,END_TRANSACTION))
		{
			message_die(GENERAL_ERROR, "Could not insert new folder name", "", __LINE__, __FILE__, $sql);
		}
		
		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("favorites.$phpEx") . '">')
		);
	
		$message = $lang['Folder_Created'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . append_sid("favorites.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_forum'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
		break;
	case 'add':
		if ( !empty($topic_id) )
		{
			$sql = "SELECT * FROM " . TOPICS_TABLE . " WHERE topic_id = $topic_id";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain topics information', '', __LINE__, __FILE__, $sql);
			}
			else
			{
				$topic_rows = array();
				while ( $row = $db->sql_fetchrow($result) )
				{	$topic_rows[] = $row;	}

				if(!count($topic_rows))
				{
					message_die(GENERAL_MESSAGE, 'Can not Find this Topic');
				}
			}
			$db->sql_freeresult($result);
		}
		else
		{
			message_die(GENERAL_MESSAGE, 'Topic_not_exist');
		}

		$sql="SELECT * FROM " . FAVORITES_TABLE . " WHERE topic_id=" . $topic_id . " AND user_id=" . $userdata['user_id'];
		if ( !($result = $db->sql_query($sql)) )
		{ 
			message_die(GENERAL_ERROR, 'Could not obtain favorite information', '', __LINE__, __FILE__, $sql);
		}

		$adds = 0;
		while( $row = $db->sql_fetchrow($result))
		{ 
			$adds++; 
		}
		$db->sql_freeresult($result);

		if ($adds)
		{
			message_die(GENERAL_ERROR, $lang['Has_Added']);
		}

		$page_title = $lang['Create_Folder'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		$sql="SELECT * FROM " . FAVORITE_FOLDER_TABLE . " where owner_id=" . $userdata['user_id'];
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, 'Could not obtain folder name from favorite folder table', '', __LINE__, __FILE__, $sql);
		}
		$boxstring = '<select name="folder_id"><option value="-1">' . $lang['Select_Folder'] . '</option><option value="0">' . $lang['Root'] . '</option>';
		
		$folder_rows = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$folder_rows[] = $row;
		}
		$db->sql_freeresult($result);

		if ($total_folders = count($folder_rows))
		{
			for($i=0; $i<$total_folders; $i++)
			{
				$boxstring .= '<option value="' . $folder_rows[$i]['folder_id'] . '">' . $folder_rows[$i]['folder_name'] . '</option>';
			}
			$boxstring .= '</select>';
		}
		
		$hidden_fields='<input type="hidden" name="mode" value="s_Add" /><input type="hidden" name="topic_id" value="' . $topic_id . '" />';

		$template->assign_vars(array(
			'S_FAVORITE_ACTION' => append_sid("favorites.$phpEx"),
			'U_VIEW_FRVORITE' => append_sid("favorites.$phpEx"),
			'FRVORITE_NAME' => $lang['Favorite_Box'],
			'L_FAVORITE' => $lang['Add_Favorite'],
			'FOLDER_SELECT' => $boxstring,
			'S_HIDDEN_FIELDS' => $hidden_fields,
			'L_ABOUT_FAVORITE' => $lang['About_Add_Favorite'])
		);
		$template->set_filenames(array(

			"body" => "favorites_add_move.tpl")
		);
		$template->pparse('body');
		break;
	case 's_Add':
		$add_time=time();
		$sql="INSERT INTO " . FAVORITES_TABLE . " (topic_id,folder_id,user_id,add_time) VALUES (" . $topic_id . "," . $folder_id . "," . $userdata['user_id'] . "," . $add_time . ")";
		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not insert new favorite topic", "", __LINE__, __FILE__, $sql);
		}

		if ($folder_id)
		{
			$sql="UPDATE " . FAVORITE_FOLDER_TABLE . " SET collections=collections+1 WHERE folder_id=" . $folder_id;
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Could not update collections.", '', __LINE__, __FILE__, $sql);
			}
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">')
		);
	
		$message = $lang['Favorite_Added'] . "<br /><br />" . sprintf($lang['Click_view_message'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . append_sid("favorites.$phpEx") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
		break;
	case 'move':
		$page_title = $lang['Create_Folder'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		if (empty($HTTP_POST_VARS['F_Favor_Select']))
		{
			message_die(GENERAL_MESSAGE, $lang['None_Selected_Favorite']);
		}
			
		$hidden_fields = '<input type="hidden" name="mode" value="s_Move" /><input type="hidden" name="openfolder" value="' . $open . '" />';

		if ( isset($HTTP_POST_VARS['F_Favor_Select']) )
		{
			$favorites = $HTTP_POST_VARS['F_Favor_Select'];
			for($i = 0; $i < count($favorites); $i++)
			{
				$hidden_fields .= '<input type="hidden" name="F_Favor_Select[]" value="' . intval($favorites[$i]) . '" />';
			}
		}

		$sql="SELECT * FROM " . FAVORITE_FOLDER_TABLE . " WHERE folder_id<>" . $openfolder . " and owner_id=" . $userdata['user_id'];
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, 'Could not obtain folder name from favorite folder table', '', __LINE__, __FILE__, $sql);
		}
		$boxstring = '<select name="folder_id"><option value="-1">' . $lang['Select_Folder'] . '</option>'.(($openfolder<>0) ? '<option value="0">' . $lang['Root'] . '</option>' : '');
		
		$folder_rows = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$folder_rows[] = $row;
		}
		$db->sql_freeresult($result);

		if ($total_folders = count($folder_rows))
		{
			for($i=0; $i<$total_folders; $i++)
			{
				$boxstring .= '<option value="' . $folder_rows[$i]['folder_id'] . '">' . $folder_rows[$i]['folder_name'] . '</option>';
			}
			$boxstring .= '</select>';
		}
		
		$template->assign_vars(array(
			'S_FAVORITE_ACTION' => append_sid("favorites.$phpEx"),
			'U_VIEW_FRVORITE' => append_sid("favorites.$phpEx"),
			'FRVORITE_NAME' => $lang['Favorite_Box'],
			'L_FAVORITE' => $lang['Move_Favorite'],
			'FOLDER_SELECT' => $boxstring,
			'S_HIDDEN_FIELDS' => $hidden_fields,
			'L_ABOUT_FAVORITE' => $lang['About_Move_Favorite'])
		);
		$template->set_filenames(array(

			"body" => "favorites_add_move.tpl")
		);
		$template->pparse('body');
		break;
	case 's_Move':
		if(isset($HTTP_POST_VARS['F_Favor_Select']))
		{
			$favorites = $HTTP_POST_VARS['F_Favor_Select'];
		}
		else
		{
			message_die(GENERAL_MESSAGE, $lang['None_Selected_Favorite']);
		}
		
		$oldfolder_id=$openfolder;
		$newfolder_id=$folder_id;
		
//		echo($oldfolder_id."<br>");
//		echo($newfolder_id."<br>");
		$favorite_id_sql = '';
		for($i = 0; $i < count($favorites); $i++)
		{
			$favorite_id_sql .= ( ( $favorite_id_sql != '' ) ? ', ' : '' ) . $favorites[$i];
		}

		$sql = "UPDATE " . FAVORITES_TABLE . " SET folder_id=" . $newfolder_id . " WHERE favorite_id IN ($favorite_id_sql)";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not Updating Favorites', '', __LINE__, __FILE__, $sql);
		}
		
		if($oldfolder_id)
		{
			$sql = "UPDATE " . FAVORITE_FOLDER_TABLE . " SET collections=collections-" . count($favorites) . " WHERE folder_id=" . $oldfolder_id;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Updating Folders', '', __LINE__, __FILE__, $sql);
			}
		}
		
		if($newfolder_id)
		{
			$sql = "UPDATE " . FAVORITE_FOLDER_TABLE . " SET collections=collections+" . count($favorites) . " WHERE folder_id=" . $newfolder_id;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Updating Folders', '', __LINE__, __FILE__, $sql);
			}
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("favorites.$phpEx?openfolder=" . $newfolder_id) . '">')
		);
	
		$message = $lang['Favorite_Moved'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . append_sid("favorites.$phpEx?openfolder=" . $newfolder_id) . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
		break;
	case 'D_del_all':
		$page_title = $lang['Favorite_Box'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		if ( $confirm )
		{
			$sql = "DELETE FROM " . FAVORITE_FOLDER_TABLE . " WHERE owner_id=" . $userdata['user_id'] . " AND folder_id<>" . $openfolder;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Folders', '', __LINE__, __FILE__, $sql);
			}
			
			$sql = "DELETE FROM " . FAVORITES_TABLE . " WHERE folder_id<>0 AND folder_id <>" . $openfolder . " AND user_id=" . $userdata['user_id'];
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Favorites', '', __LINE__, __FILE__, $sql);
			}

			$redirect_page = append_sid("favorites.$phpEx");

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect_page . '">')
			);
			
			$message = $lang['Folders_Removed'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . $redirect_page . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_forum'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			// Not confirmed, show confirmation message
			$hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="openfolder" value="' . $open . '" />';

			$template->set_filenames(array(
				'confirm' => 'confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' => $lang['Confirm'],
				'MESSAGE_TEXT' => $lang['Confirm_Delete_Folder'],

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid("favorites.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('confirm');

			include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}
		break;
	case 'D_del_sel':
		$page_title = $lang['Favorite_Box'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		if ( $confirm )
		{
			if(isset($HTTP_POST_VARS['D_Favor_Select']))
			{
				$folders = $HTTP_POST_VARS['D_Favor_Select'];
			}
			else
			{
				message_die(GENERAL_MESSAGE, $lang['None_Selected_Folder']);
			}

			$folder_id_sql = '';
			for($i = 0; $i < count($folders); $i++)
			{
				$folder_id_sql .= ( ( $folder_id_sql != '' ) ? ', ' : '' ) . $folders[$i];
			}
			
			$sql = "DELETE FROM " . FAVORITE_FOLDER_TABLE . " WHERE folder_id IN ($folder_id_sql)";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Folders', '', __LINE__, __FILE__, $sql);
			}
			
			$sql = "DELETE FROM " . FAVORITES_TABLE . " WHERE folder_id IN ($folder_id_sql)";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Favorites', '', __LINE__, __FILE__, $sql);
			}

			$redirect_page = append_sid("favorites.$phpEx?openfolder=$openfolder");

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect_page . '">')
			);
			
			$message = $lang['Folders_Removed'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . $redirect_page . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_forum'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			// Not confirmed, show confirmation message
		
			if (empty($HTTP_POST_VARS['D_Favor_Select']))
			{
				message_die(GENERAL_MESSAGE, $lang['None_Selected_Folder']);
			}

			$hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="openfolder" value="' . $open . '" />';

			if ( isset($HTTP_POST_VARS['D_Favor_Select']) )
			{
				$folders = $HTTP_POST_VARS['D_Favor_Select'];
				for($i = 0; $i < count($folders); $i++)
				{
					$hidden_fields .= '<input type="hidden" name="D_Favor_Select[]" value="' . $folders[$i] . '" />';
				}
			}

			$template->set_filenames(array(
				'confirm' => 'confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' => $lang['Confirm'],
				'MESSAGE_TEXT' => $lang['Confirm_Delete_Folder'],

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid("favorites.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('confirm');

			include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}
		break;
	case 'F_del_all':
		$page_title = $lang['Favorite_Box'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		if ( $confirm )
		{
			$sql = "DELETE FROM " . FAVORITES_TABLE . " WHERE folder_id=" . $openfolder;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Favorites', '', __LINE__, __FILE__, $sql);
			}

			$sql = "UPDATE " . FAVORITE_FOLDER_TABLE . " SET collections=0 WHERE folder_id=" . $openfolder;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Updating Folders', '', __LINE__, __FILE__, $sql);
			}

			$redirect_page = append_sid("favorites.$phpEx?openfolder=$openfolder");

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect_page . '">')
			);
			
			$message = $lang['Favorites_Removed'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . $redirect_page . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_forum'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			// Not confirmed, show confirmation message
			$hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="openfolder" value="' . $open . '" />';

			$template->set_filenames(array(
				'confirm' => 'confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' => $lang['Confirm'],
				'MESSAGE_TEXT' => $lang['Confirm_Delete_Favorite'],

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid("favorites.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('confirm');

			include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}
		break;
	case 'F_del_sel':
		$page_title = $lang['Favorite_Box'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		if ( $confirm )
		{
			if(isset($HTTP_POST_VARS['F_Favor_Select']))
			{
				$favorites = $HTTP_POST_VARS['F_Favor_Select'];
			}
			else
			{
				message_die(GENERAL_MESSAGE, $lang['None_Selected_Favorite']);
			}
			$favorite_id_sql = '';
			for($i = 0; $i < count($favorites); $i++)
			{
				$favorite_id_sql .= ( ( $favorite_id_sql != '' ) ? ', ' : '' ) . $favorites[$i];
			}
			
			$sql = "DELETE FROM " . FAVORITES_TABLE . " WHERE favorite_id IN ($favorite_id_sql)";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Deleting Favorites', '', __LINE__, __FILE__, $sql);
			}

			$sql = "UPDATE " . FAVORITE_FOLDER_TABLE . " SET collections=collections-$count WHERE folder_id=$openfolder";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not Updating Folders', '', __LINE__, __FILE__, $sql);
			}

			$redirect_page = append_sid("favorites.$phpEx?openfolder=$openfolder");

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect_page . '">')
			);
			
			$message = $lang['Folders_Removed'] . "<br /><br />" . sprintf($lang['Click_return_Favorite'], "<a href=\"" . $redirect_page . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_forum'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			if (empty($HTTP_POST_VARS['F_Favor_Select']))
			{
				message_die(GENERAL_MESSAGE, $lang['None_Selected_Favorite']);
			}

			$hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="openfolder" value="' . $open . '" />';

			if ( isset($HTTP_POST_VARS['F_Favor_Select']) )
			{
				$favorites = $HTTP_POST_VARS['F_Favor_Select'];
				for($i = 0; $i < count($favorites); $i++)
				{
					$hidden_fields .= '<input type="hidden" name="F_Favor_Select[]" value="' . $favorites[$i] . '" />';
				}
				$hidden_fields .= '<input type="hidden" name="count" value="' . count($favorites) . '" />';
			}

			$template->set_filenames(array(
				'confirm' => 'confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' => $lang['Confirm'],
				'MESSAGE_TEXT' => $lang['Confirm_Delete_Favorite'],

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid("favorites.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('confirm');

			include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}
		break;
	default:
		$page_title = $lang['Favorite_Box'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);
		if ($open)
		{
			$sql="SELECT folder_name FROM " . FAVORITE_FOLDER_TABLE . " WHERE owner_id=" . $userdata['user_id'] . " and folder_id=" . $open;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(CRITICAL_ERROR, 'Could not obtain folder name from favorite folder table', '', __LINE__, __FILE__, $sql);
			}
			$names = $db->sql_fetchrow($result);
			$folder_name=$names['folder_name'];
			$db->sql_freeresult($result);
		}
		else
		{	$folder_name=$lang['Root'];	}

		$template->assign_vars(array(
			'S_FAVORITE_ACTION' => append_sid("favorites.$phpEx"),
			'U_VIEW_FRVORITE' => append_sid("favorites.$phpEx"),
			'FRVORITE_NAME' => $lang['Favorite_Box'],
			'L_TOPICS' => $lang['Topic'],
			'L_REPLIES' => $lang['Replies'],
			'L_AUTHOR' => $lang['Author'],
			'L_VIEWS' => $lang['Views'],
			'L_LASTPOST' => $lang['Last_Post'],
			'L_MARK' => $lang['Mark'],
			'L_FOLDER_TITLE' => $lang['Folder_Title'],
			'L_TOPIC_TITLE' => $lang['Topic_Title'],
			'L_CURRENT_DIR' => $lang['Currenr_Dir'],
			'CURRENT_DIR' => $folder_name,
			'CURRENT_FOLDER_ID' => $open,
			'L_CREATE_FOLDER' => $lang['Create_Folder'])
		);
		
		$template->set_filenames(array(

			"body" => "favorites_body.tpl")
		);
		
		$sql="SELECT * FROM " . FAVORITE_FOLDER_TABLE . " WHERE owner_id=" . $userdata['user_id'] . " AND folder_id <> " . $open . " ORDER BY create_time DESC";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain folder information', '', __LINE__, __FILE__, $sql);
		}

		$total_folders = 0;
		while( $row = $db->sql_fetchrow($result) )
		{
			$folder_rowset[] = $row;
			$total_folders++;
		}
		$db->sql_freeresult($result);

		if ($total_folders)
		{
			for ($i=0; $i<$total_folders; $i++)
			{
				$template->assign_block_vars('folderrow', array(
					'FAVORITE_FOLDER_IMG' => $images['folder'],
					'U_VIEW_FOLDER' => append_sid("favorites.$phpEx?openfolder=".$folder_rowset[$i]['folder_id']),
					'FOLDER_NAME' => $folder_rowset[$i]['folder_name'],
					'FOLDER_ID' => $folder_rowset[$i]['folder_id'],
					'L_COUNTS' => $lang['Counts'],
					'COUNTS' => $folder_rowset[$i]['collections']."")
				);
			}
			$template->assign_block_vars('folderctl', array(
				'L_DELETE_ALL' => $lang['Delete_all'],
				'L_DELETE_MARKED' => $lang['Delete_marked'],
				'L_MARK_ALL' => $lang['Mark_all'])
			);
		}
		else
		{
			$template->assign_vars(array(
				'L_NO_FOLDERS' => $lang['No_Folder'])
			);
			$template->assign_block_vars('switch_no_folders', array());

		}

		$sql="SELECT f.*,t.*,u.username,p.post_username,p.post_time,u2.user_id as id2,u2.username as user2 FROM " . FAVORITES_TABLE . " f, " . TOPICS_TABLE ." t, " . USERS_TABLE ." u, " . POSTS_TABLE . " p, " . USERS_TABLE . " u2 WHERE f.user_id=" . $userdata['user_id'] . " AND f.topic_id=t.topic_id AND t.topic_poster=u.user_id AND t.topic_last_post_id=p.post_id AND u2.user_id = p.poster_id AND f.folder_id=" . $open . " ORDER BY t.topic_time DESC";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain collection information', '', __LINE__, __FILE__, $sql);
		}

		$total_topics = 0;
		while( $row = $db->sql_fetchrow($result) )
		{
			$topic_rowset[] = $row;
			$total_topics++;
		}
		$db->sql_freeresult($result);

		if ($total_topics)
		{
			for($i=0; $i<$total_topics; $i++)
			{
				$view_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $topic_rowset[$i]['topic_id']);
				$topic_author = ( $topic_rowset[$i]['topic_poster'] != ANONYMOUS ) ? '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $topic_rowset[$i]['topic_poster']) . '">' : '';
				$topic_author .= ( $topic_rowset[$i]['topic_poster'] != ANONYMOUS ) ? $topic_rowset[$i]['username'] : $lang['Guest'];
				$topic_author .= ( $topic_rowset[$i]['topic_poster'] != ANONYMOUS ) ? '</a>' : '';
				$last_post_time = create_date($board_config['default_dateformat'], $topic_rowset[$i]['post_time'], $board_config['board_timezone']);
				$last_post_author = ( $topic_rowset[$i]['id2'] == ANONYMOUS ) ? ( ($topic_rowset[$i]['post_username'] != '' ) ? $topic_rowset[$i]['post_username'] . ' ' : $lang['Guest'] . ' ' ) : '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '='  . $topic_rowset[$i]['id2']) . '">' . $topic_rowset[$i]['user2'] . '</a>';
				$last_post_url = '<a href="' . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $topic_rowset[$i]['topic_last_post_id']) . '#' . $topic_rowset[$i]['topic_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" border="0" /></a>';

				$template->assign_block_vars('topicrow', array(
					'TOPIC_FOLDER_IMG' => $images['folder'],
					'U_VIEW_TOPIC' => $view_topic_url,
					'TOPIC_TITLE' => $topic_rowset[$i]['topic_title'],
					'REPLIES' => $topic_rowset[$i]['topic_replies'],
					'TOPIC_AUTHOR' => $topic_author,
					'VIEWS' => $topic_rowset[$i]['topic_views'],
					'LAST_POST_TIME' => $last_post_time,
					'LAST_POST_AUTHOR' => $last_post_author,
					'LAST_POST_IMG' => $last_post_url,
					'FAVORITE_ID' => $topic_rowset[$i]['favorite_id'])
				);				
			}
			$template->assign_block_vars('topicctl', array(
				'L_DELETE_ALL' => $lang['Delete_all'],
				'L_DELETE_MARKED' => $lang['Delete_marked'],
				'L_MOVE_TO_FOLDER' => $lang['Move'],
				'L_MARK_ALL' => $lang['Mark_all'])
			);
		}
		else 
		{
			$template->assign_vars(array(
				'L_NO_FAVORITE' => $lang['No_Favorite'])
			);
			$template->assign_block_vars('switch_no_favorite', array());
		}

		$template->assign_vars(array(
			'PAGINATION' => generate_pagination("modcp.$phpEx?" . POST_FORUM_URL . "=$forum_id", $forum_topics, $board_config['topics_per_page'], $start),
			'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $board_config['topics_per_page'] ) + 1 ), ceil( $forum_topics / $board_config['topics_per_page'] )), 
			'L_GOTO_PAGE' => $lang['Goto_page'])
		);
		$template->pparse('body');
		break;
}

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>