<?php
		/***************************************************************************
									rate.php
		                             -------------------
		    begin                : Sat Feb 23, 2002
		    copyright            : (C) 2002 Nivisec.com
		    email                : nivisec@hotmail.com
		
		    		$Id: rate.php,v 1.2.2 2002/04/21 00:00:00 nivisec Exp $
		
		 ***************************************************************************/
		
		/***************************************************************************
		 *                                         				                                
		 *   This program is free software; you can redistribute it and/or modify  	
		 *   it under the terms of the GNU General Public License as published by  
		 *   the Free Software Foundation; either version 2 of the License, or	    	
		 *   (at your option) any later version.
		 *
		 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = "./";
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

include($phpbb_root_path . 'includes/rate_functions.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, (PAGE_INDEX - 2232002), $board_config['session_length']);
init_userprefs($userdata);
//
// End session management
//

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_rate.' . $phpEx);

//
//Get the mode if it was sent
//
if( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
}
else
{
	$mode = "";
}
//
//Rate Mode
//
if ($mode == "rate")
{
	if ( !defined('IN_PHPBB') )
	{
		die("Hacking attempt");
	}
	rating_insert($userdata['user_id'], $topic_id, $rating);
	$message = $lang['Topic_Rated'] . "<br /><br />" . sprintf($lang['Click_return_topic'], "<a href=\"" . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . "#$topic_id\">", "</a>");
	$template->assign_vars(array(
	"META" => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '#' . $topic_id . '">')
	);
	message_die(GENERAL_MESSAGE, $message);
}

//
//Rerate Mode
//
else if ($mode == "rerate")
{
	if ( !defined('IN_PHPBB') )
	{
		die("Hacking attempt");
	}
	rating_change($userdata['user_id'], $topic_id, $rating);
	$message = $lang['Topic_Rated'] . "<br /><br />" . sprintf($lang['Click_return_topic'], "<a href=\"" . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . "#$topic_id\">", "</a>");
	$template->assign_vars(array(
	"META" => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '#' . $topic_id . '">')
	);
	message_die(GENERAL_MESSAGE, $message);
}
//
//Start Do the details mode
//
else if ($mode == "details")
{
	$page_title = '>'.$lang['Detailed_Rating'];
	$rank = 0;
	$sql = "SELECT *
	FROM " . RATE_TABLE . "
	WHERE topic_id = " . $topic_id . "
	ORDER BY rate_time";
	if ( !$result = $db->sql_query($sql) ) {
		message_die(GENERAL_ERROR, "Couldn't query rating data.", "", __LINE__, __FILE__, $sql);
	}

	while ( $row = $db->sql_fetchrow($result) )
	{
		$rank++;
		$class = ( !($rank % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
		$rate_time = $row['rate_time'];
		$rate_date = create_date($board_config['default_dateformat'], $rate_time, $board_config['board_timezone']);
		$template->assign_block_vars("user_rates_row", array(
		"RANK" => $rank,
		"CLASS" => $class,
		"USER_RATE" => $row['rating'],
		"USER_MAX_RATE" => $rate_config['max_rating'],
		"USER_RATE_DATE" => $rate_date,
		"USERNAME" => sprintf($lang['Username_Gave_Rate_of_Max'], id_to_name($row['user_id']), $row['rating'], $rate_config['max_rating'], $rate_date),
		"USERNAME" => id_to_name($row['user_id']))
		);
	}

	$db->sql_freeresult($result);
	$template->assign_vars(array(
	"DEFAULT_CLASS" => $theme['td_class1'],
	"L_TOPIC_RETURN" => sprintf($lang['Click_return_topic'], "<a href=\"" . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . "#$topic_id\">", "</a>"),
	"L_TITLE" => sprintf($lang['Details_For_Topic'], id_to_title($topic_id)),
	"L_USER_RATED" => $lang['User_Rate'],
	"L_USER_MAX_RATE" => $lang['Max_Rate'],
	"L_USER_RATE_DATE" => $lang['Rate_Date'],
	"L_USER_RATE_TIME" => $lang['Rate_Time'],
	"L_NO_TOPICS_RATED" => $lang['No_Topics_Rated'],
	"L_RANK" => $lang['Rate_Order'],
	"PAGE_NAME" => $page_title)
	);

	include($phpbb_root_path . 'includes/page_header.'.$phpEx);
	$template->set_filenames(array(
	"body" => "rate_detailed.tpl")
	);
	$template->pparse("body");
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

}
//
//End Do the details mode
//
//
//Start Do the big page output mode as default
//
else
{
	$forums_row = get_forum_array();
	$forum_id_sql = generate_forum_id_sql($forums_row);

	$topics_row = get_rated_topics_array();
	$topic_id_sql = generate_topic_id_sql($topics_row);

	$topics_row = get_authorized_topics_array($forum_id_sql, $topic_id_sql);
	//Re-generate a list of topics we can view for SQL
	$topic_id_sql = generate_topic_id_sql($topics_row);

	//Generate specific forum list for pulldown menu
	$forum_list = "<select name=\"forum_top\">";

	//Ok probably not the best way to do the ALL forum tag, but if it works it works...
	$forum_list .= "<option value=\"85828182828182\" selected=\"selected\">All</option>";
	for ($i=-1; $i < count($forums_row); $i++)
	{
		$is_auth = auth('auth_view', $forums_row[$i]['forum_id'], $userdata);
		if ($is_auth['auth_view'])
		{
			$forum_list .= "<option value=\"" . $forums_row[$i]['forum_id'] . "\">" . strip_tags($forums_row[$i]['forum_name']) . "</option>";
		}
	}
	$forum_list .= "</select>";

	//Check if they want a specific forum top admin specified instead of overall
	if ($HTTP_POST_VARS['forum_top'] == 85828182828182 || $HTTP_GET_VARS['forum_top'] == 85828182828182)
	{
		$using_all = 1;
	}
	if( !$using_all && isset($HTTP_POST_VARS['forum_top']) || isset($HTTP_GET_VARS['forum_top']))
	{
		$forum_top = ( isset($HTTP_POST_VARS['forum_top']) ) ? $HTTP_POST_VARS['forum_top'] : $HTTP_GET_VARS['forum_top'];
		$page_title = sprintf($lang['Top_Topics_For_Forum'], $rate_config['big_page_number'], id_to_forum($forum_top));

		//Get a 2-D array of all the topic ids in our forum
		$sql = "SELECT	topic_id
		FROM " . TOPICS_TABLE . "
		WHERE forum_id = " . $forum_top;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't query forums data.", "", __LINE__, __FILE__, $sql);
		}
		$topics_in_forum = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);

		//Re-generate a list of topics we can view for SQL
		$topic_id_forum_sql = generate_topic_id_sql($topics_in_forum);

		//Blah blah get the topics etc
		$top_rated_row = get_top_rated_topics_array($topic_id_forum_sql, $rate_config['big_page_number']);
	}
	else
	{
		$page_title = sprintf($lang['Top_Topics'], $rate_config['big_page_number']);

		//Get the top admin control panel defined top rated topics as a 2-D array
		$top_rated_row = get_top_rated_topics_array($topic_id_sql, $rate_config['big_page_number']);
	}

	//Finally, we get to assign them to block vars for template
	$rank = 0;

	if ( count($top_rated_row) )
	{
		for ($i=0; $i < count($top_rated_row); $i++)
		{
			$rank++;
			$template->assign_block_vars("topicrow", array(
			"CLASS" => ( !($rank % 2) ) ? $theme['td_class2'] : $theme['td_class1'],
			"RANK" => $rank,
			"URL" => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $top_rated_row[$i]['topic_id']),
			"LAST_RATER" => id_to_name(last_rater($top_rated_row[$i]['topic_id'])),
			"LAST_RATER_TIME" => create_date($board_config['default_dateformat'], last_rater_time($top_rated_row[$i]['topic_id']), $board_config['board_timezone']),
			"TITLE" => id_to_title($top_rated_row[$i]['topic_id']),
			"FORUM" => id_to_forum(topic_to_forum($top_rated_row[$i]['topic_id'])),
			"RATING" => sprintf("%.2f", $top_rated_row[$i]['average']),
			"MIN" => sprintf("%d", $top_rated_row[$i]['min']),
			"MAX" => sprintf("%d", $top_rated_row[$i]['max']),
	"L_NO_TOPICS_RATED" => $lang['No_Topics_Rated'],
			"L_VIEW_DETAILS" => ($rate_config['allow_ext_rating']) ? sprintf($lang['View_Details_2'], append_sid("rate.$phpEx?mode=details&amp;topic_id=" . $top_rated_row[$i]['topic_id'])) : "",
			"NUMBER_OF_RATES" => $top_rated_row[$i]['rating_number'])
			);
		}
	}
else
{
	$template->assign_block_vars("notopics", array(
		"MESSAGE" => $lang['No_Topics_Rated'])
	);
}

	//Do the damn language vars thing (can you tell I'm tired yet?)
	$template->assign_vars(array(
	"PAGE_NAME" => $page_title,
	"L_FOR_FORUM" => ( !is_null($forum_top) ) ? sprintf($lang['For_Forum'],id_to_forum($forum_top)) : "",
	"L_LAST_RATED" => $lang['Last_Rated'],
	"L_RATES" => $lang['Number_of_Rates'],
	"L_RATING" => $lang['Rating'],
	"L_NO_TOPICS_RATED" => $lang['No_Topics_Rated'],
	"L_MIN" => $lang['Min'] . " " . $lang['Rating'],
	"L_MAX" => $lang['Max'] . " " . $lang['Rating'],
	"S_FORUMS" => $forum_list,
	"S_MODE_ACTION" => append_sid('rate.'.$phpEx),
	"L_BY_FORUM" => $lang['By_Forum'],
	"L_VIEW" => $lang['Go'],
	"SOMETHING" => "something")
	);

	$template->set_filenames(array(
	"body" => "rate.tpl")
	);

	include($phpbb_root_path . 'includes/page_header.'.$phpEx);
	$template->pparse("body");
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

}
//
//End Do the big page output mode
//
?>