<?php
		/***************************************************************************
								rate_index.php
		                             -------------------
		    begin                : Sat Feb 28, 2002
		    copyright            : (C) 2002 Nivisec.com
		    email                : nivisec@hotmail.com
		
		    $Id: rate_index.php,v 1.2.2 2002/04/21 00:00:00 nivisec Exp $
		
		 ***************************************************************************/
		
		/***************************************************************************
		 *                                         				                                
		 *   This program is free software; you can redistribute it and/or modify  	
		 *   it under the terms of the GNU General Public License as published by  
		 *   the Free Software Foundation; either version 2 of the License, or	    	
		 *   (at your option) any later version.
		 *
		 ***************************************************************************/
if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

include($phpbb_root_path . 'includes/rate_functions.'.$phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_rate.' . $phpEx);

$forums_row = get_forum_array();
$forum_id_sql = generate_forum_id_sql($forums_row);

$topics_row = get_rated_topics_array();
$topic_id_sql = generate_topic_id_sql($topics_row);

$topics_row = get_authorized_topics_array($forum_id_sql, $topic_id_sql);
//Re-generate a list of topics we can view for SQL
$topic_id_sql = generate_topic_id_sql($topics_row);

$top_rated_row = get_top_rated_topics_array($topic_id_sql, $rate_config['main_page_number']);

//Finally, we get to assign them to block vars for template
$rank = 0;
if ( count($top_rated_row) )
{
	for ($i=0; $i < count($top_rated_row); $i++)
	{
// κ
$rate_title = id_to_title($top_rated_row[$i]['topic_id']);
$rate_title1 = substr($top_rated_row[$i]['topic_id']['id_to_title'],0,6).".";
//****
		$rank++;
		$template->assign_block_vars("ratingrow", array(
		"CLASS" => ( !($rank % 2) ) ? $theme['td_class2'] : $theme['td_class1'],
		"RANK" => $rank,
		"URL" => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $top_rated_row[$i]['topic_id']),
		"LAST_RATER" => id_to_name(last_rater($top_rated_row[$i]['topic_id'])),
		"LAST_RATER_TIME" => date("ymd", last_rater_time($top_rated_row[$i]['topic_id'])), //create_date($board_config['default_dateformat'], last_rater_time($top_rated_row[$i]['topic_id']), $board_config['board_timezone']),
		"TITLE" => $rate_title,
        "T2" => $rate_title1,
		"FORUM" => id_to_forum(topic_to_forum($top_rated_row[$i]['topic_id'])),
		"RATING" => sprintf("%.2f", $top_rated_row[$i]['average']),
		"MIN" => sprintf("%d", $top_rated_row[$i]['min']),
		"MAX" => sprintf("%d", $top_rated_row[$i]['max']),
		"L_VIEW_DETAILS" => ($rate_config['allow_ext_rating']) ? sprintf($lang['View_Details_2'], append_sid("rate.$phpEx?mode=details&amp;topic_id=" . $top_rated_row[$i]['topic_id'])) : "",
		"NUMBER_OF_RATES" => $top_rated_row[$i]['rating_number'])
		);
	}
}
else
{
	$template->assign_block_vars("notopics", array(
		"MESSAGE" => $lang['No_Topics_Rated'])
	);
}

$template->assign_vars( array(
"L_TOP_RATED" => sprintf($lang['Top_Topics'], $rate_config['main_page_number']))
);

?>