<?php
		/***************************************************************************
		                             rate_viewtopic.php
		                             -------------------
		    begin                : Sat Feb 23, 2002
		    copyright            : (C) 2002 Nivisec.com
		    email                : nivisec@hotmail.com
		
		    $Id: rate_viewtopic.php,v 1.2.2 2002/04/21 00:00:00 nivisec Exp $
		
		 ***************************************************************************/
		
		/***************************************************************************
		 *                                         				                                
		 *   This program is free software; you can redistribute it and/or modify  	
		 *   it under the terms of the GNU General Public License as published by  
		 *   the Free Software Foundation; either version 2 of the License, or	    	
		 *   (at your option) any later version.
		 *
		 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_rate.' . $phpEx);
include($phpbb_root_path . 'includes/rate_functions.'.$phpEx);

//
//Check User Auth
//
$rath_auth_data = rate_auth($userdata['user_id'], $forum_id, $topic_id);

//
//See if there is voting (NONE Selection)
//
if ($rath_auth_data == 3)
{
	$template->assign_block_vars("noauth", array(
	"RATE_TOPIC_USER" => '')
	);
}

//
//If not NONE continue and check for PRIVATE before we get start output
//
else if ($rath_auth_data != 2 || ($rath_auth_data == 2 && $userdata['user_id'] != ANONYMOUS))
{
	//
	//See if NOT authorized
	//
	if ($rath_auth_data == 0)
	{

		$template->assign_block_vars("noauth", array(
		"RATE_TOPIC_USER" => sprintf($lang['Not_Authorized_To_Rate']))
		);
	}
	//
	//If ok continue
	//
	else
	{
		//
		//Has user already rated?
		//
		if (!rating_inserted($userdata['user_id'], $topic_id))
		{
			$select_rate_choices = "<select name=\"rating\">";
			for ($i=1; $i <= $rate_config['max_rating']; $i++)
			{
				$select_rate_choices .= "<option value=\"" . $i . "\"$selected>" . $i . "</option>";
			}
			$select_rate_choices .= "</select>";

			$template->assign_block_vars("rate", array(
			"L_CHOOSE_RATING" => $lang['Choose_Rating'],
			"L_RATE" => $lang['Rate'],
			"S_RATE_SELECT" => $select_rate_choices,
			"S_HIDDEN_FIELDS" => '<input type="hidden" name="topic_id" value="'. $topic_id . '" /><input type="hidden" name="mode" value="rate" />',
			"S_RATE_ACTION" => append_sid("rate.$phpEx"),
			"RATE_TOPIC_USER" => "")
			);
		}
		//
		//If they have, let them know it.
		//
		else
		{
			//
			//Admin allowing re-rates?
			//
			if ($rate_config['allow_rerate'])
			{

				$select_rate_choices = "<select name=\"rating\">";
				for ($i=1; $i <= $rate_config['max_rating']; $i++)
				{
					$select_rate_choices .= "<option value=\"" . $i . "\"$selected>" . $i . "</option>";
				}
				$select_rate_choices .= "</select>";

				$template->assign_block_vars("rerate", array(
				"L_CHANGE_RATING" => $lang['Change_Rating'],
				"L_RATE" => $lang['Rate'],
				"S_RATE_SELECT" => $select_rate_choices,
				"S_HIDDEN_FIELDS" => '<input type="hidden" name="topic_id" value="'. $topic_id . '" /><input type="hidden" name="mode" value="rerate" />',
				"S_RATE_ACTION" => append_sid("rate.$phpEx"))
				);
			}
			$template->assign_block_vars("rated", array(
			"RATE_TOPIC_USER" => sprintf($lang['Already_Rated'], rating_info($userdata['user_id'], $topic_id)))
			);
		}

	}
	//
	//Common Output Variables
	//
	$rating_row = rating_stats($topic_id);
	$template->assign_vars(array(
	"L_RATE_TOPIC_USER_ANON" => ($rate_config['check_anon_ip'] && $userdata['user_id'] == ANONYMOUS) ? sprintf($lang['Or_Someone_From_IP']) : "",
	"RATE_TOPIC_STATS" => sprintf($lang['Rate_Stats'], $rating_row['average'],$rating_row['minimum'],$rating_row['maximum'],$rating_row['number_of_rates']),
	"TOPIC_TITLE" => id_to_title($topic_id), 
	"L_SUMMARY" => $lang['Summary'])
	);
	if ($rate_config['allow_ext_rating'])
	{
		$template->assign_vars(array(
		"FULL_STATS_URL" => sprintf($lang['View_Details'], append_sid("rate.$phpEx?mode=details&amp;topic_id=" . $topic_id)))
		);
	}

	$template->set_filenames(array(
	"rate_viewtopic" => "rate_viewtopic.tpl")
	);
	$template->assign_var_from_handle('RATE_VIEWTOPIC', 'rate_viewtopic');

}
?>