<?php
/***************************************************************************
 *					siye_hist.php
 *                            -------------------
 *   begin                : Wensday, Maj 22, 2002
 *   email                : ncr@db9.dk
 *
 *	ver 0.10.0.
 *
 *  Credits:
 *  The authors of the original STATISTICS MOD witch have made the do_math function (I guess)
 *
 * History
 *   ver 0.9.0. - initial BETA release
 *	   0.9.1. - change so last 7 days are displayed correct
 *	   0.9.2. -     ---||----
 *	   0.9.3. - change so last x hours are displayed correct
 *	   0.9.4. - change how languages are translated, now php translate the months and days name
 * 	   0.9.5. - the year was not shown in te most online user list for this year
 *	   0.9.6. - The months in the monthly site history was not displayed correct, now corrected
 *	   0.10.0. - Changed this mod to not require statistis mod, thereby increasing the speed
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start user modifiable variables
//

//
// Define the Number of statistics output
//
$return_limit = 10;
$vote_left = "images/vote_lcap.gif";
$vote_right = "images/vote_rcap.gif";
$vote_bar = "images/voting_bar.gif";

//
// End user modifiable variables
//
$percentage = 0;
$bar_percent = 0;
//
// Functions
//

//
// Do the math ;)
//
function do_math($firstval, $value, $total)
{
	global $percentage, $bar_percent;

	$cst = ($firstval > 0) ? 90 / $firstval : 90;

	if ( $value != 0  )
	{
		$percentage = ( $total ) ? round( min(100, ($value / $total) * 100)) : 0;
	}
	else
	{
		$percentage = 0;
	}

	$bar_percent = round($value * $cst);
}

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_STATISTICS);
init_userprefs($userdata);
//
// End session management
//

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_site_hist.' . $phpEx);

$page_title = $lang['Site_history'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

//
// Getting voting bar info
//
if( !$board_config['override_user_style'] )
{
	if( ($userdata['user_id'] != ANONYMOUS) && (isset($userdata['user_style'])) )
	{
		$style = $userdata['user_style'];
		if( !$theme )
		{
			$style =  $board_config['default_style'];
		}
	}
	else
	{
		$style =  $board_config['default_style'];
	}
}
else
{
	$style =  $board_config['default_style'];
}

$sql = "SELECT * 
FROM " . THEMES_TABLE . " 
WHERE themes_id = $style";

if ( !($result = $db->sql_query($sql)) )
{
	message_die(CRITICAL_ERROR, "Couldn't query database for theme info.");
}

if( !$row = $db->sql_fetchrow($result) )
{
	message_die(CRITICAL_ERROR, "Couldn't get theme data for themes_id=$style.");
}

$current_template_path = 'templates/' . $row['template_name'] . '/';

$template->assign_vars(array(
	'LEFT_GRAPH_IMAGE' => $current_template_path . $vote_left,
	'RIGHT_GRAPH_IMAGE' => $current_template_path . $vote_right,
	'GRAPH_IMAGE' => $current_template_path . $vote_bar)
);



$template->set_filenames(array(
	'body' => 'site_hist.tpl')
);
$db->sql_freeresult($result);
$current_time=time();
$minutes = date('is', $current_time);
$hour_now = $current_time - (60*($minutes[0].$minutes[1])) - ($minutes[2].$minutes[3]); 
$dato=date('H');
$time_today = $hour_now - (3600*$dato); 
$year=create_date('Y', $current_time, $board_config['board_timezone']);
$month [0] = mktime (0,0,0,1,1,$year);
$month [1] = $month [0] + 2678400;
$month [2] = mktime (0,0,0,3,1,$year);
$month [3] = $month [2] + 2678400;
$month [4] = $month [3] + 2592000;
$month [5] = $month [4] + 2678400;
$month [6] = $month [5] + 2592000;
$month [7] = $month [6] + 2678400;
$month [8] = $month [7] + 2678400;
$month [9] = $month [8] + 2592000;
$month [10] = $month [9] + 2678400;
$month [11] = $month [10] + 2592000;
$month [12] = $month [11] + 2592000;
$time_thismonth = $month [date('n')-1];
$time_thisweek = $time_today - ((date('w',$time_today)-1)*86400);
$this_month = create_date('n',$time_thismonth,$board_config['board_timezone']);

$l_this_month = create_date('F',$time_thismonth,$board_config['board_timezone']);
$l_this_day = create_date('D',$time_today,$board_config['board_timezone']);


// This week top postes
$sql ='select u.user_id, u.username, count(u.user_id) as user_posts  
FROM '.USERS_TABLE.' u,'.POSTS_TABLE.' p 
WHERE u.user_id=p.poster_id AND p.post_time > "'.$time_thisweek.'"
GROUP BY user_id order by user_posts DESC
LIMIT ' . $return_limit;
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Couldn't retrieve topposters data", "", __LINE__, __FILE__, $sql);
}
$user_count = $db->sql_numrows($result);
$user_data = $db->sql_fetchrowset($result);
$firstcount = $user_data[0]['user_posts'];
for ($i = 0; $i < $user_count; $i++)
{
	$total_posts_thisweek += $user_data[$i]['user_posts'];
}
for ($i = 0; $i < $user_count; $i++)
{
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
	do_math($firstcount, $user_data[$i]['user_posts'], $total_posts_thisweek);
	$template->assign_block_vars('top_posters_week', array(
		'RANK' => $i+1,
		'CLASS' => $class,
		'USERNAME' => $user_data[$i]['username'],
		'PERCENTAGE' => $percentage,
		'BAR' => $bar_percent,
		'URL' => append_sid($phpbb_root_path . 'profile.php?mode=viewprofile&u=' . $user_data[$i]['user_id']),
		'POSTS' => $user_data[$i]['user_posts'])
	);
}
$db->sql_freeresult($result);

// This months top postes
$sql ='select u.user_id, u.username, count(u.user_id) as user_posts  
FROM '.USERS_TABLE.' u,'.POSTS_TABLE.' p 
WHERE u.user_id=p.poster_id AND p.post_time>"'.$time_thismonth.'"
GROUP BY user_id order by user_posts DESC
LIMIT ' . $return_limit;
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Couldn't retrieve topposters data", "", __LINE__, __FILE__, $sql);
}
$user_count = $db->sql_numrows($result);
$user_data = $db->sql_fetchrowset($result);
$firstcount = $user_data[0]['user_posts'];
for ($i = 0; $i < $user_count; $i++)
{
	$total_posts_thismonth += $user_data[$i]['user_posts'];
}
for ($i = 0; $i < $user_count; $i++)
{
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
	do_math($firstcount, $user_data[$i]['user_posts'], $total_posts_thismonth);
	$template->assign_block_vars('top_posters', array(
		'RANK' => $i+1,
		'CLASS' => $class,
		'USERNAME' => $user_data[$i]['username'],
		'PERCENTAGE' => $percentage,
		'BAR' => $bar_percent,
		'URL' => append_sid($phpbb_root_path . 'profile.php?mode=viewprofile&u=' . $user_data[$i]['user_id']),
		'POSTS' => $user_data[$i]['user_posts'])
	);
}
$db->sql_freeresult($result);

// months site_history
for ($i = 0; $i < 12; $i++)
{
	$sql ='SELECT MAX(reg+hidden+guests) as total, date, MAX(reg) as reg , MAX(hidden) as hidden, MAX(guests) as guests, SUM(new_topics) as topics, SUM(new_posts) as posts
	FROM '.SITE_HISTORY_TABLE.' WHERE date>=' . $month [$i] . ' AND date<' . $month [$i+1].' GROUP BY (date>=' . $month [$i] . ' AND date<' . $month [$i+1].')';
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't retrieve site history", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
	$site_monthly = $db->sql_fetchrow($result);
	if ( $i+1 == $this_month ) 
		$l_month = '<strong>'.$l_this_month.'</strong>';
	else
		$l_month = create_date('F',$month[$i],$board_config['board_timezone']);
		
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_month', array(
			'CLASS' => $class,
			'MONTH' => $l_month,
			'TOTAL' => $site_monthly['total'],
			'REG' => ($site_monthly['reg'])? $site_monthly['reg'] : $lang['None'],
			'HIDDEN' => ($site_monthly['hidden']) ? $site_monthly['hidden'] : $lang['None'],
			'GUESTS' => ($site_monthly['guests']) ? $site_monthly['guests'] : $lang['None'],
			'TOPICS' => ($site_monthly['topics']) ? $site_monthly['topics'] : $lang['None'],
			'POSTS' => ($site_monthly['posts']) ? $site_monthly['posts'] : $lang['None']
		));
	} else
	{
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_month', array(
			'CLASS' => $class,
			'MONTH' => create_date('F',$month[$i],$board_config['board_timezone']),
			'TOTAL' => $lang['Not_availble'],
		));
	} 

	$db->sql_freeresult($result);
}
// last 7 days site_history
$time_today -=518400;
for ($i = 0; $i < 7; $i++)
{
	if ($i==6)
		$l_currrent_day = '<strong>'.create_date('D',$time_today,$board_config['board_timezone']).'</strong>';
	else 
		$l_currrent_day = create_date('D',$time_today,$board_config['board_timezone']);
	$sql ='SELECT MAX(reg+hidden+guests) as total, date, MAX(reg) as reg , MAX(hidden) as hidden, MAX(guests) as guests, SUM(new_topics) as topics, SUM(new_posts) as posts
	FROM '.SITE_HISTORY_TABLE.' WHERE date>=' . $time_today . ' AND date<' . ($time_today+86400).' GROUP BY (date>=' . $time_today . ' AND date<' . ($time_today+86400) .')';
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't retrieve site history", "", __LINE__, __FILE__, $sql);
	}
	if ($db->sql_numrows($result))
	{
		$site_week = $db->sql_fetchrow($result);
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_week', array(
			'CLASS' => $class,
			'DAY' => $l_currrent_day,
			'TOTAL' => $site_week['total'],
			'REG' => ($site_week['reg'])? $site_week['reg'] : $lang['None'],
			'HIDDEN' => ($site_week['hidden']) ? $site_week['hidden'] : $lang['None'],
			'GUESTS' => ($site_week['guests']) ? $site_week['guests'] : $lang['None'],
			'TOPICS' => ($site_week['topics']) ? $site_week['topics'] : $lang['None'],
			'POSTS' => ($site_week['posts']) ? $site_week['posts'] : $lang['None']
		));
	} else
	{
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_week', array(
			'CLASS' => $class,
			'DAY' => $l_currrent_day,
			'TOTAL' => $lang['Not_availble'],
		));
	} 
	$time_today += 86400;
	$db->sql_freeresult($result);
}

// site_history last X hours
$hour_now -=(($return_limit-1)*3600);
for ($i = 0; $i < $return_limit; $i++)
{

	if ($i==$return_limit-1)
		$l_currrent_time = '<strong>'.create_date('H:i',$hour_now,$board_config['board_timezone']).'</strong>';
	else 
		$l_currrent_time = create_date('H:i',$hour_now,$board_config['board_timezone']);

	$sql ='SELECT MAX(reg+hidden+guests) as total, date, MAX(reg) as reg , MAX(hidden) as hidden, MAX(guests) as guests, SUM(new_topics) as topics, SUM(new_posts) as posts
	FROM '.SITE_HISTORY_TABLE.' WHERE date>=' . $hour_now . ' AND date<' . ($hour_now+3599).' GROUP BY (date>=' . $hour_now . ' AND date<' . ($hour_now+3599) .')';
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't retrieve site history", "", __LINE__, __FILE__, $sql);
	}

	if ($db->sql_numrows($result))
	{
		$site_today = $db->sql_fetchrow($result);
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_today', array(
			'CLASS' => $class,
			'TIME' => $l_currrent_time,
			'TOTAL' => $site_today['total'],
			'REG' => ($site_today['reg'])? $site_today['reg'] : $lang['None'],
			'HIDDEN' => ($site_today['hidden']) ? $site_today['hidden'] : $lang['None'],
			'GUESTS' => ($site_today['guests']) ? $site_today['guests'] : $lang['None'],
			'TOPICS' => ($site_today['topics']) ? $site_today['topics'] : $lang['None'],
			'POSTS' => ($site_today['posts']) ? $site_today['posts'] : $lang['None']
		));
	} else
	{
	$class = ($i % 2) ? $theme['td_class2'] : $theme['td_class1'];
		$template->assign_block_vars('site_today', array(
			'CLASS' => $class,
			'TIME' => $l_currrent_time,
			'TOTAL' => $lang['Not_availble'],
		));
	} 
	$hour_now += 3600;
	$db->sql_freeresult($result);
}

$template->assign_vars(array(
	'MONTH_BACK' => sprintf($lang['Most_online'],create_date('Y',$time_thismonth,$board_config['board_timezone'])),
	'THIS_MONTH' => create_date('Y',$time_thismonth,$board_config['board_timezone']),
	'THIS_MONTH2' => $l_this_month,
	'WEEK_BACK' => $lang['Most_online_week'],
	'24_BACK' => sprintf($lang['Last_24'],$return_limit),
	'L_USERS_TOTAL' => $lang['Total_users'],
	'L_REG_USERS' => $lang['Reg_users'],
	'L_HIDDEN_USERS' => $lang['Hidden_users'],
	'L_GUESTS_USERS' => $lang['Guests_users'],
	'L_NEW_TOPICS' => $lang['New_topics'],
	'L_NEW_POSTS' => $lang['New_posts'],
	'L_MONTH' => $lang['Month'],
	'L_DAY' => $lang['Day'],
	'L_TIME' => $lang['Time'],
	'L_TOP_POSTERS' => $lang['Top_Posting_Users'],
	'L_TOP_POSTERS_WEEK' => sprintf($lang['Top_Posting_Users_week'],(create_date('D',$time_thisweek,$board_config['board_timezone'])).' - '.$l_this_day),
	'L_RANK' => $lang['Rank'],
	'L_PERCENTAGE' => $lang['Percent'],
	'L_GRAPH' => $lang['Graph'],
	'L_USERNAME' => $lang['Username'],
	'L_POSTS' => $lang['Posts'],
	'PAGE_NAME' => $lang['Statistics'])
);

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 


?> 